      SUBROUTINE MERGER(ASYT,AFLM,JTT,IENT)
      SAVE
 
      CHARACTER*6  AFLS
      CHARACTER*7  ASTA
      CHARACTER*80 ASYS, ASYT
      CHARACTER*164 AFIL, AFLL, AFLM
      CHARACTER*80 WLIN,CLIN
      COMMON /WLI/ WLIN,CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
      COMMON /MRGX/ASYS, AFLL, AFLS, AFIL
 
      JFMR = 1
 
      ASYS = ASYT
      AFLL = AFLM
      IENH = IENT
 
      AFLS = 'sch99_'
 
      DO 12  I = 80,1,-1
      IF(ASYS(I:I).NE.' ') GO TO 13
   12 CONTINUE
   13 NSYS = I
      AFIL = ' '
 
      JT = 3
      IF(JTT.NE.0) JT = 2
      IENH = MAX0(2,MIN0(8,IABS(IENH)))
 
      DO 100  J = 0,IENH-1
      DO 1000  I = 0,IENH-1
      IF(NSYS.NE.0) AFIL(1:NSYS) = ASYS(1:NSYS)
      AFIL(NSYS+1:NSYS+6) = AFLS
      AFIL(NSYS+7:NSYS+7) = CHAR(I+48)
      AFIL(NSYS+8:NSYS+8) = CHAR(J+48)
      AFIL(NSYS+9:NSYS+12) = '.tif'
 
      ASTA = 'OLD'
      CALL OPENF(1,0,AFIL,ASTA,LERR)
      IF(LERR.NE.0) GO TO 995
 
 1000 CONTINUE
  100 CONTINUE
 
      IF(JFMR.EQ.0) WRITE(NAUS,9010) IENH, AFLL
 9010 FORMAT(' Resolution Enhancement:',I2/' Target File: ',A)
 
      CALL SAVREX(JT,0)
      GO TO 999
 
  995 IF(JFMR.EQ.0) WRITE(WLIN,9095) AFIL
 9095 FORMAT(' Missing file ',A,' !')
      CALL WROUT(0)
 
  999 RETURN
      END
 
 
      SUBROUTINE FOPEN(I,J)
      SAVE
 
      CHARACTER*1  A1,A2,AA,AQ,ABUF
      CHARACTER*4  AEXT
      CHARACTER*5  ADUM
      CHARACTER*6  AFLS
      CHARACTER*7  ASTA
      CHARACTER*80 ASYS
      CHARACTER*164 AFIL, AFLL
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2X/KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, MJ
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
      COMMON /MRGX/ASYS, AFLL, AFLS, AFIL
      DATA NFOP/0/
 
      NFOP = NFOP + 1
      IF(I.LT.0) GO TO 100
 
      IF(NSYS.NE.0) AFIL(1:NSYS) = ASYS(1:NSYS)
      AFIL(NSYS+1:NSYS+6) = AFLS
      AFIL(NSYS+7:NSYS+7) = CHAR(I+48)
      AFIL(NSYS+8:NSYS+8) = CHAR(J+48)
      AFIL(NSYS+9:NSYS+12) = '.tif'
 
      NFIL = I + 1
      NFX  = I + 50
      ASTA = 'OLD'
 
      CALL OPENF(3,NFX,AFIL,ASTA,LERR)
      IF(LERR.NE.0) GO TO 995
 
      READ(NFX,REC=1) (AQ(JJ,NFIL),JJ=1,1024)
      WRITE(ADUM,8001) (AQ(JJ,NFIL),JJ=1,5)
 8001 FORMAT(5A1)
 
      JSPT(NFIL) = 0
      IF(ADUM(1:4).EQ.'SCH9')                      JSPT(NFIL) = 1
      IF(ADUM(1:2).EQ.'MM' .AND. ADUM(4:4).EQ.'*') JSPT(NFIL) = 3
      IF(ADUM(1:5).EQ.'ERROR') JSPT(NFIL) = -1
      IF(JSPT(NFIL).LT.1) RETURN
 
      AEXT = '.sif'
      IF(JSPT(NFIL).EQ.3) AEXT = 'TIFF'
 
      IF(JFMR.NE.0) GO TO 5
 
      IF(NFOP.GT.1) THEN
        IF(NSYS.GT.46) THEN
          WRITE(NAUS,9000) AEXT, AFIL
 9000     FORMAT(' Processing ',A4,' file  ',A)
        ELSE
          WRITE(NAUS,9010) AEXT, AFIL(1:57)
 9010     FORMAT(' Processing ',A4,' file  ',A57)
        ENDIF
      ELSE
        WRITE(NAUS,9001) AEXT, AFIL
 9001   FORMAT(' Inspecting ',A4,' file  ',A)
      ENDIF
 
    5 NCR(NFIL)  = 0
      NREC(NFIL) = 0
      NRAL(NFIL) = 0
 
C *** Read Header
      IF(JSPT(NFIL).EQ.1) THEN
        CALL RWXSIF(11)
      ELSE IF(JSPT(NFIL).EQ.2) THEN
        CALL RWXPCX(11)
      ELSE IF(JSPT(NFIL).EQ.3) THEN
        CALL RWXTIF(11)
      ENDIF
 
C *** Read RGB values
      IF(JSPT(NFIL).EQ.1) THEN
        CALL RWXSIF(12)
      ELSE IF(JSPT(NFIL).EQ.3) THEN
        CALL RWXTIF(12)
      ENDIF
 
      RETURN
 
  100 CONTINUE
 
      ASTA = 'UNKNOWN'
 
      CALL OPENF(3,59,AFLL,ASTA,LERR)
      IF(LERR.NE.0) GO TO 996
 
C *** Write Header
      KXST = 0
      KYST = 0
      KXND = (LXND - LXST + 1) * IENH - 1
      KYND = (LYND - LYST + 1) * IENH - 1
      MXST = 1
      MXND = KXND + 1
 
      JT = -I
      JSOP = 0
      IF(JT.EQ.1) JSOP = 1
 
      NFIL = 9
      NCR(NFIL) = 0
      NREC(NFIL) = 0
 
      IF(JT.LT.2) THEN
        CALL RWXSIF(21)
      ELSE IF(JT.EQ.2) THEN
        CALL RWXPCX(21)
      ELSE IF(JT.EQ.3) THEN
        CALL RWXTIF(21)
      ENDIF
 
C *** Write RGB values
      IF(JT.LT.2) THEN
        CALL RWXSIF(22)
      ELSE IF(JT.EQ.3) THEN
        CALL RWXTIF(22)
      ENDIF
 
      RETURN
 
  995 AFLL = AFIL
  996 JSPT(NFIL) = -2
      RETURN
 
      END
 
 
      SUBROUTINE SAVREX(JT,JU)
      SAVE
C *** Program to save/restore a picture
C     JU  = 1 : lesen vom File
C               JT = 0 : opaque
C                    1 : transparent
C
C     JU  = 2 : schreiben auf File
C               JT  = 0 : SIF-File
C                     1 : SIF-File
C                     2 : PCX-File
C                     3 : TIF-File
 
      INCLUDE 'scom1.inc'
      CHARACTER*1  AP,APP, ARD,AGR,ABL, AN, A1,A2,AA,AQ, ABUF
      CHARACTER*6 AFLS
      CHARACTER*80 ASYS
      CHARACTER*164 AFIL, AFLL
 
      CHARACTER*80 WLIN, CLIN
      COMMON /WLI/ WLIN, CLIN
 
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /FL2/ ILL1,ILL2,IROW,ICLM,ICLN,IDX,IDY,JFL1(16),JFL2(24),
     *             IPLS,IPL0,JTSF,JINL,TFRC
 
      COMMON /PL1X/XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /LSTX/JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /MAPX/NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /COLX/NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
 
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /HSLX/JMDY, ICV1,ICV2,ICV3, ICW(3), ICV4
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /APSX/AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
      COMMON /MRGX/ASYS, AFLL, AFLS, AFIL
 
      AN = CHAR(0)
 
C *** Read the Header/RGB-values of the first file (sch99_00.xxx)
      I = 0
      J = 0
      CALL FOPEN(I,J)
      IF(JSPT(1).EQ. 0) GO TO 994
      IF(JSPT(1).EQ.-1) GO TO 995
      IF(JSPT(1).EQ.-2) GO TO 996
      CALL CLOSEF(NFX)
 
C *** Write Header/RGB-values to the output file (nnnn.xxx)
      CALL FOPEN(-JT,0)
 
      JST = 0
      JND = IENH - 1
      JNK = 1
      IF(JSPT(1).EQ.3) THEN
        JST = IENH - 1
        JND = 0
        JNK = - 1
      ENDIF
 
      CALL SFINTA(31)
      IRWW = -1
 
      DO 100  J = JST,JND,JNK
      IRWW = IRWW + 1
      DO 1000  I = 0,IENH-1
 
C *** Read the Header/RGB-values of the file (sch99_ij.xxx)
C     (just to position these files)
 
      CALL FOPEN(I,J)
      IF(JSPT(NFIL).EQ. 0) GO TO 994
      IF(JSPT(NFIL).EQ.-1) GO TO 995
      IF(JSPT(NFIL).EQ.-2) GO TO 996
 1000 CONTINUE
 
C *** Read Pixel values
 
      LYDS = IABS(LYND - LYST) + 1
      LYDT = IENH * LYDS
      LYD1 = LYDT / 20
      LYD2 = LYD1 - 1
 
      DO 10 LYS = LYST,LYND
      LY = LYS
      IF(MOD(LYS,5).EQ.0) THEN
        CALL KEYCHK(0)
        IF(JRRR.NE.0) GO TO 990
      ENDIF
      LFRC = IRWW * LYDS + IABS(LYS-LYST)
      IF(MOD(LFRC,LYD1).EQ.LYD2) THEN
        TFRC = FLOAT(LFRC) / FLOAT(LYDT)
        CALL SFINTA(38)
        CALL WINFUN(1)
        IF(JRRR.NE.0) GO TO 990
      ENDIF
 
      DO 1010  I = 0,IENH-1
      NSHF = I * (NXND - NXST + 1)
      NFX =  I + 50
      NFIL = I + 1
 
      IF(JSPT(NFIL).EQ.1) THEN
        CALL RWXSIF(13)
      ELSE IF(JSPT(NFIL).EQ.2) THEN
        CALL RWXPCX(13)
      ELSE IF(JSPT(NFIL).EQ.3) THEN
        CALL RWXTIF(13)
      ENDIF
 
      IF(JRRR.GT.0) GO TO 990
      IF(JRRR.LT.0) GO TO 998
 
C *** Write to File
C
 
C *** Write Pixel values (lines)
C     APP now contains one depacked line of pixels, received from file
C     APP is now written into target file (1 line of pixels)
 
      DO 200  NX = NXST,NXND
      AP(NX) = APP(NX)
  200 CONTINUE
 
      NFX = 59
      NFIL = 9
      IE = I + 1
 
      IF(JT.LT.2) THEN
        CALL RWXSIF(23)
      ELSE IF(JT.EQ.2) THEN
        CALL RWXPCX(23)
      ELSE IF(JT.EQ.3) THEN
        CALL RWXTIF(23)
      ENDIF
      IF(JRR.NE.0) GO TO 999
 
 1010 CONTINUE
 
   10 CONTINUE
  100 CONTINUE
 
C *** Write Finals
      IF(JT.LT.2) THEN
        CALL RWXSIF(24)
      ELSE IF(JT.EQ.2) THEN
        CALL RWXPCX(22)
      ELSE IF(JT.EQ.3) THEN
        CALL RWXTIF(24)
      ENDIF
 
      IF(JRRR.NE.0) GO TO 997
 
  990 CALL TIMCHK(0)
      DO 9900  I = 0,IENH-1
      CALL CLOSEF(I+50)
 9900 CONTINUE
      CALL CLOSEF(59)
      GO TO 999
 
  994 IF(JFMR.EQ.0) WRITE(WLIN,9094) AFIL(1:50)
 9094 FORMAT(' File  ',A,' is no TIFF file !!')
      CALL WROUT(0)
      GO TO 999
 
  995 IF(JFMR.EQ.0) WRITE(WLIN,9095) AFIL(1:50)
 9095 FORMAT(' File  ',A,' is incomplete !!')
      CALL WROUT(0)
      GO TO 999
 
  996 IF(JFMR.NE.0) WRITE(WLIN,9096) AFLL(1:50)
 9096 FORMAT(' Missing file ',A,' !')
      CALL WROUT(0)
      GO TO 999
 
  997 IF(JFMR.EQ.0) WRITE(WLIN,9097) LY
 9097 FORMAT(' Only ',I3,' pixel lines stored on file !')
      CALL WROUT(0)
      GO TO 999
 
  998 IF(JFMR.NE.0) WRITE(WLIN,9098)
 9098 FORMAT(' READ ERROR !! Picture cannot be restored !')
      CALL WROUT(0)
 
  999 CALL SFINTA(39)
      RETURN
      END
 
 
      SUBROUTINE UNFMOX
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, ABUF
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
 
      NCR(NFIL) = NCR(NFIL) + 1
      MCR = NCR(NFIL)
      AQ(MCR,NFIL) = AA
      IF(MCR.EQ.1024) THEN
        NREC(NFIL) = NREC(NFIL) + 1
        WRITE(59,REC=NREC(NFIL)) (AQ(J,NFIL), J=1,1024)
        NCR(NFIL) = 0
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE UNFMIX
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, ABUF
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
 
      IF(NCR(NFIL).EQ.0) THEN
        NREC(NFIL) = NREC(NFIL) + 1
        READ(NFX,REC=NREC(NFIL)) (AQ(J,NFIL), J=1,1024)
      ENDIF
      NCR(NFIL) = NCR(NFIL) + 1
      MCR = NCR(NFIL)
      AA = AQ(MCR,NFIL)
      IF(MCR.EQ.1024) NCR(NFIL) = 0
 
      RETURN
      END
 
 
      SUBROUTINE UNFMX1
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, ABUF
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
 
      NREC(NFIL) = 1 + NCR(NFIL) / 1024
      IF(NREC(NFIL).NE.NRAL(NFIL)) READ(NFX,REC=NREC(NFIL))
     * (AQ(J,NFIL), J=1,1024)
      AA = AQ(1+MOD(NCR(NFIL),1024),NFIL)
      NCR(NFIL) = NCR(NFIL) + 1
      NRAL(NFIL) = NREC(NFIL)
 
      RETURN
      END
 
 
      SUBROUTINE UNFMX2(IDUM)
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, ABUF
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
 
      NCR1 = 1 + MOD(NCR(NFIL),1024)
      NREC(NFIL) = 1 + NCR(NFIL) / 1024
      IF(NREC(NFIL).NE.NRAL(NFIL)) READ(NFX,REC=NREC(NFIL))
     * (AQ(J,NFIL),J=1,1024)
      IDUM = 256 * ICHAR(AQ(NCR1,NFIL)) + ICHAR(AQ(NCR1+1,NFIL))
      NCR(NFIL) = NCR(NFIL) + 2
      NRAL(NFIL) = NREC(NFIL)
 
      RETURN
      END
 
 
      SUBROUTINE MCHARX(JT,IDUM)
      SAVE
 
      CHARACTER*1 A1,A2,AA,AQ, ABUF
      COMMON /CRDX/ A1,A2, AA, AQ(1024,9), ABUF(3000)
 
      IF(JT.EQ.0) THEN
        A1 = CHAR(IDUM/256)
        A2 = CHAR(MOD(IDUM,256))
      ELSE
        IDUM = 256 * ICHAR(A1) + ICHAR(A2)
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE PCKUNX(JT)
      SAVE
 
      CHARACTER*1  AP, APP, ARD, AGR, ABL, AX, AY, AZ
      CHARACTER*1  A1, A2, AA, AQ, ABUF
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /APSX/AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
 
      AY = CHAR(254)
      AZ = CHAR(255)
 
      JRR = 0
      N = 0
 
      IF(JT.NE.0) GO TO 2
 
      NJ = 0
      AX = AZ
 
      DO 150  NX = NXST,NXMX
      IF(NX.EQ.NXMX) GO TO 151
      IF(AP(NX).EQ.AZ .OR. AP(NX).EQ.AY) GO TO 99
      IF(AP(NX).NE.AX) GO TO 151
      N = N + 1
      GO TO 150
 
  151 IF(N.EQ.0) GO TO 152
      IF(N.GT.3) GO TO 153
 
      DO 160, J = 1,N
      NJ = NJ + 1
      APP(NJ) = AX
  160 CONTINUE
      GO TO 155
 
  153 NJ = NJ + 1
      IF(N.GT.63) GO TO 154
      APP(NJ) = AZ
      NJ = NJ + 1
      APP(NJ) = CHAR(N)
      GO TO 155
  154 NN = N / 64
      APP(NJ) = AY
      NJ = NJ + 1
      APP(NJ) = CHAR(NN)
      NJ = NJ + 1
      LDUM = N - 64 * NN
      APP(NJ) = CHAR(LDUM)
  155 N = 0
  152 IF(NX.EQ.NXMX) RETURN
      NJ = NJ + 1
      APP(NJ) = AP(NX)
      AX = AP(NX)
  150 CONTINUE
      RETURN
 
    2 DO 25  J = 1,NJ
 
      IF(J.EQ.1) GO TO 21
      IF(AP(J-1).EQ.AZ .OR. AP(J-1).EQ.AY) GO TO 25
 
      IF(J.EQ.2) GO TO 21
      IF(AP(J-2).EQ.AY) GO TO 25
 
   21 IF(AP(J).EQ.AZ .OR. AP(J).EQ.AY) GO TO 26
 
      N = N + 1
      IF(N.GT.NXND) GO TO 98
      APP(N) = AP(J)
      AX = AP(J)
      GO TO 25
 
   26 NN = ICHAR(AP(J+1))
      IF(AP(J).EQ.AY) NN = 64 * NN + ICHAR(AP(J+2))
 
      DO 250 K = 1,NN
      N = N + 1
      APP(N) = AX
  250 CONTINUE
   25 CONTINUE
 
      RETURN
 
   98 JRR = -1
      RETURN
   99 JRR = 1
      RETURN
      END
 
 
      SUBROUTINE HEADEX(JT)
      SAVE
 
      CHARACTER*1  A1,A2, AA, AQ, ABUF
      CHARACTER*5  AS99
      CHARACTER*76 AHDR
      COMMON /MAPX/NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /LSTX/JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /HEAX/AHDR
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2X/KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, MJ
      COMMON /HSLX/JMDY, ICV1,ICV2,ICV3, ICW(3), ICV4
      DATA AS99/'SCH99'/
 
      IF(JT.NE.0) GO TO 100
C *** Read Header
 
      IF(AHDR(1:4).NE.'SCH9') GO TO 991
 
      IF(AHDR(6:6).EQ.'P') JSOP = 1
      A1 = AHDR(7:7)
      A2 = AHDR(8:8)
      CALL MCHARX(1,IDUM)
      LXST = IDUM
      A1 = AHDR(9:9)
      A2 = AHDR(10:10)
      CALL MCHARX(1,IDUM)
      LXND = IDUM
      A1 = AHDR(11:11)
      A2 = AHDR(12:12)
      CALL MCHARX(1,IDUM)
      LYST = IDUM
      A1 = AHDR(13:13)
      A2 = AHDR(14:14)
      CALL MCHARX(1,IDUM)
      LYND = IDUM
      NFST = ICHAR(AHDR(15:15))
      NFS  = NFST
      FST  = NFST + 1
      NFRB = ICHAR(AHDR(16:16))
      A1 = AHDR(17:17)
      A2 = AHDR(18:18)
      CALL MCHARX(1,IDUM)
      JDUM = IDUM
      A1 = AHDR(19:19)
      A2 = AHDR(20:20)
      CALL MCHARX(1,IDUM)
      KDUM = IDUM
      IDUM = MOD(IDUM,1000)
      LBCK(6) = 1000 * JDUM + IDUM
      IF(KDUM.GT.999) LBCK(6) = - LBCK(6)
      A1 = AHDR(22:22)
      A2 = AHDR(23:23)
      CALL MCHARX(1,IDUM)
      NRGB = IDUM
      NHUE = ICHAR(AHDR(24:24))
      NHU3 = 3 * NHUE
 
      IDUM = ICHAR(AHDR(25:25))
      JDUM = ICHAR(AHDR(26:26))
      KDUM = ICHAR(AHDR(27:27))
      LDUM = ICHAR(AHDR(28:28))
      JMDY = 0
      IF(MAX0(IDUM,JDUM,KDUM,LDUM).EQ.0) GO TO 11
      ICV1 = IDUM
      ICV2 = JDUM
      ICV3 = KDUM
      ICV4 = LDUM
      JMDY = 1
 
   11 IDUM = ICHAR(AHDR(31:31))
      JDUM = ICHAR(AHDR(32:32))
      IF(IDUM.EQ.0 .AND. JDUM.EQ.0) GO TO 12
      LBCK(1) = 1
      LBCK(3) = 1000 * JDUM + IDUM
 
   12 CONTINUE
      A1 = AHDR(33:33)
      A2 = AHDR(34:34)
      CALL MCHARX(1,IDUM)
      JDUM = IDUM
      KDUM = ICHAR(AHDR(35:35))
      IDUM = ICHAR(AHDR(36:36))
      LBCK(2) = JDUM + 1000000 * KDUM + 1000 * IDUM
 
      NPOS = 36
 
      DO 20 LY = 1,NHUE
      KDUM = 3 * (LY-1)
      NPOS = NPOS + 1
      A1 = AHDR(NPOS:NPOS)
      NPOS = NPOS + 1
      A2 = AHDR(NPOS:NPOS)
      CALL MCHARX(1,IDUM)
      IHUE(LY) = IDUM
      NPOS = NPOS + 1
      ISAT(LY) = ICHAR(AHDR(NPOS:NPOS))
   20 CONTINUE
 
      LXND = LXND - LXST
      LXST = 0
      LYND = LYND - LYST
      LYST = 0
 
      NXST = 1
      NXND = LXND + 1
      NXMX = NXND + 1
 
      RETURN
 
  991 JRRR = 1
      RETURN
 
C *** Write Header
  100 CONTINUE
 
      AHDR( 1: 5) = AS99
      AHDR(76:76) = CHAR(0)
 
      AHDR( 6: 6) = 'S'
      IF(JSOP.NE.0) AHDR( 6: 6) = 'P'
 
      IDUM = KXST
      CALL MCHARX(0,IDUM)
      AHDR( 7: 7) = A1
      AHDR( 8: 8) = A2
      IDUM = KXND
      CALL MCHARX(0,IDUM)
      AHDR( 9: 9) = A1
      AHDR(10:10) = A2
      IDUM = KYST
      CALL MCHARX(0,IDUM)
      AHDR(11:11) = A1
      AHDR(12:12) = A2
      IDUM = KYND
      CALL MCHARX(0,IDUM)
      AHDR(13:13) = A1
      AHDR(14:14) = A2
      AHDR(15:15) = CHAR(NFST)
      AHDR(16:16) = CHAR(NFRB)
 
      IDUM = IABS(LBCK(6)) / 1000
      CALL MCHARX(0,IDUM)
      AHDR(17:17) = A1
      AHDR(18:18) = A2
 
      IDUM = MOD(IABS(LBCK(6)),1000)
      IF(LBCK(6).LT.0) IDUM = IDUM + 1000
      CALL MCHARX(0,IDUM)
      AHDR(19:19) = A1
      AHDR(20:20) = A2
 
      AHDR(21:21) = CHAR(0)
 
      IDUM = NRGB
      CALL MCHARX(0,IDUM)
      AHDR(22:22) = A1
      AHDR(23:23) = A2
 
      IDUM = NHUE
      AHDR(24:24) = CHAR(IDUM)
 
      DO 105  I = 25,32
      AHDR( I: I) = CHAR(0)
  105 CONTINUE
 
      IF(JMDY.EQ.0) GO TO 106
      AHDR(25:25) = CHAR(ICV1)
      AHDR(26:26) = CHAR(ICV2)
      AHDR(27:27) = CHAR(ICV3)
      AHDR(28:28) = CHAR(ICV4)
 
  106 IF(LBCK(1).EQ.0) GO TO 107
      AHDR(31:31) = CHAR(MOD(LBCK(3),1000))
      AHDR(32:32) = CHAR(LBCK(3) / 1000)
 
  107 IDUM = MOD(IABS(LBCK(2)),1000)
      CALL MCHARX(0,IDUM)
      AHDR(33:33) = A1
      AHDR(34:34) = A2
      IDUM = IABS(LBCK(2)) / 1000000
      AHDR(35:35) = CHAR(IDUM)
      IDUM = MOD(IABS(LBCK(2)),1000000) / 1000
      AHDR(36:36) = CHAR(IDUM)
 
      NCHR = 36
 
      DO 110 LY = 1,NHUE
      IDUM = IHUE(LY)
      CALL MCHARX(0,IDUM)
      NCHR = NCHR + 1
      AHDR(NCHR:NCHR) = A1
      NCHR = NCHR + 1
      AHDR(NCHR:NCHR) = A2
      IDUM = ISAT(LY)
      NCHR = NCHR + 1
      AHDR(NCHR:NCHR) = CHAR(IDUM)
  110 CONTINUE
 
      RETURN
      END
