C *** Aenderungen:
C     Einige COMMONS veraendert oder zugefuegt
C     NCR durch NCR(NFIL) ersetzt
C     NREC durch NREC(NFIL) ersetzt
C     NRAL durch NRAL(NFIL) ersetzt
C     AQ(I) durch AQ(I,NFIL) ersetzt
 
 
      SUBROUTINE RWXSIF(JT)
      SAVE
 
      CHARACTER*1  AP,APP, ARD,AGR,ABL, A1,A2,AA,AQ, ABUF
      CHARACTER*76 AHDR
 
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /PL1X/XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /MAPX/NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /COLX/NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /LSTX/JJ, IG, IPSH,IFAC,LBCK(6)
 
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2X/KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, MJ
      COMMON /HSLX/JMDY, ICV1,ICV2,ICV3, ICW(3), ICV4
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /HEAX/AHDR
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /APSX/AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
 
      JU = IABS(JT) / 10
      JTT = MOD(IABS(JT),10)
 
      IF(JU.GT.1) GO TO 100
 
C *** Read from file
      GO TO (10,20,30,40), JTT
 
C *** Read Header
   10 CONTINUE
      NCHR = 0
 
        DO  12  I = 1,75
        CALL UNFMIX
        AHDR(I:I) = AA
   12   CONTINUE
      CALL HEADEX(0)
      RETURN
 
C *** Read RGB values
   20 CONTINUE
      DO 25  LY = 1,NRGB
      ICV(1) = LY - 1
        CALL UNFMIX
        ARD(LY) = AA
        CALL UNFMIX
        AGR(LY) = AA
        CALL UNFMIX
        ABL(LY) = AA
      ICV(2) = ICHAR(ARD(LY))
      ICV(3) = ICHAR(AGR(LY))
      ICV(4) = ICHAR(ABL(LY))
 
C *** Write RGB values into graphics memory
      CALL GRAFTX(4)
      IF(LY.NE.1) GO TO 25
      LBCK(5) = (ICV(2) + ICV(3) + ICV(4)) / 3
   25 CONTINUE
      CALL GRAFTX(6)
 
      RETURN
 
C *** Read pixel values
   30 CONTINUE
 
      IF(JSOP.EQ.0) THEN
          CALL UNFMIX
          NJ = ICHAR(AA)
          CALL UNFMIX
          NJ = NJ + 256 * ICHAR(AA)
          DO 32  J = 1,NJ
          CALL UNFMIX
          AP(J) = AA
   32     CONTINUE
C ***   Depack AP into APP
        CALL PCKUNX(1)
        IF(JRR.NE.0) THEN
          IF(JRR.LT.0) GO TO 39
          GO TO 38
        ENDIF
      ELSE
          DO 34  J = NXST,NXND
          CALL UNFMIX
          APP(J) = AA
   34     CONTINUE
      ENDIF
      RETURN
 
   38 JRRR = -1
      RETURN
   39 JRRR = 1
      RETURN
 
   40 CONTINUE
      RETURN
 
  100 GO TO (110,120,130,140), JTT
 
C *** Write Header
  110 CONTINUE
C *** Identification Byte (0A), Version 3.0, RLE coding, 8 bits per pixe
      AP( 1) = CHAR(10)
      AP( 2) = CHAR(5)
      AP( 3) = CHAR(1)
      AP( 4) = CHAR(8)
 
      IDUM = KXST
      CALL MCHARX(0,IDUM)
      AP( 5) = A2
      AP( 6) = A1
 
      IDUM = KYST
      CALL MCHARX(0,IDUM)
      AP( 7) = A2
      AP( 8) = A1
 
      IDUM = KXND
      CALL MCHARX(0,IDUM)
      AP( 9) = A2
      AP(10) = A1
 
      IDUM = KYND
      CALL MCHARX(0,IDUM)
      AP(11) = A2
      AP(12) = A1
 
C *** dots per inch
      IDUM = 93
      CALL MCHARX(0,IDUM)
      AP(13) = A2
      AP(14) = A1
      AP(15) = A2
      AP(16) = A1
 
      DO 112  I = 17,64
      AP(I) = CHAR(0)
  112 CONTINUE
 
C *** reserved byte, number of colour planes
      AP(65) = CHAR(1)
      AP(66) = CHAR(1)
 
C *** bytes per line
      IDUM = MXND
      CALL MCHARX(0,IDUM)
      AP(67) = A2
      AP(68) = A1
 
      DO 114  I = 69,128
      AP(I) = CHAR(0)
  114 CONTINUE
 
        DO 116  I = 1,128
        AA = AP(I)
        CALL UNFMOX
  116   CONTINUE
      RETURN
 
  120 CONTINUE
C *** Write Palette
 
      AP(1) = CHAR(12)
 
      DO 122  I = 1,256
      J = 3 * (I-1) + 2
      AP(J)   = ARD(I)
      AP(J+1) = AGR(I)
      AP(J+2) = ABL(I)
  122 CONTINUE
 
        IF(NCR(NFIL).NE.255) THEN
          NNCR = 255
          IF(NCR(NFIL).GT.255) NNCR = 1279
          NNCR = NNCR - NCR(NFIL)
          AA = CHAR(0)
          DO 123  I = 1,NNCR
          CALL UNFMOX
  123     CONTINUE
        ENDIF
 
        DO 124  J = 1,769
        AA = AP(J)
        CALL UNFMOX
  124   CONTINUE
 
        IF(NCR(NFIL).EQ.0) RETURN
 
      RETURN
 
  130 CONTINUE
C *** Write Pixel Line, originally stored in AP
 
      IF(JSOP.EQ.0) THEN
        CALL PCKUNX(0)
        IF(JRR.NE.0) GO TO 996
C ***   Write packed line into file
 
        LB2 = NJ / 256
        LB1 = NJ - 256 * LB2
        AP(1) = CHAR(LB1)
        AP(2) = CHAR(LB2)
        DO 131  N = 1,NJ
        AP(N+2) = APP(N)
  131   CONTINUE
        NCHR = NJ + 2
      ELSE
C ***   Write non-packed line into file
        NCHR = NXND - NXST + 1
      ENDIF
 
        DO 132  I = 1,NCHR
        AA = AP(I)
        CALL UNFMOX
  132   CONTINUE
 
      RETURN
 
C *** Write last record
  140 CONTINUE
      IF(JBIN.NE.0) RETURN
 
      DO 145  I = NCR(NFIL)+1,1023
      AQ(I,NFIL) = CHAR(0)
  145 CONTINUE
 
      NCR(NFIL) = 1023
      AA = CHAR(0)
      CALL UNFMOX
 
      RETURN
 
  996 CONTINUE
      END
 
 
      SUBROUTINE RWXPCX(JT)
      SAVE
 
      CHARACTER*1  AP,APP, ARD,AGR,ABL, A1,A2,AA,AQ, ABUF
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /PL1X/XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /APSX/AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2X/KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, MJ
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
 
      JU = IABS(JT) / 10
      JTT = MOD(IABS(JT),10)
 
      IF(JU.EQ.2) GO TO 100
 
      GO TO (10,20,30,40), JTT
C *** Read Header
   10 CONTINUE
      IF(JBIN.EQ.0) THEN
        NCR(NFIL) = 0
        DO 11  I = 1,12
        CALL UNFMIX
        AP(I) = AA
   11   CONTINUE
      ELSE
        REWIND NFX
        READ(NFX) (AP(J),J=1,12)
      ENDIF
 
      A2 = AP(5)
      A1 = AP(6)
      CALL MCHARX(1,LXST)
      A2 = AP(7)
      A1 = AP(8)
      CALL MCHARX(1,LYST)
      A2 = AP(9)
      A1 = AP(10)
      CALL MCHARX(1,LXND)
      A2 = AP(11)
      A1 = AP(12)
      CALL MCHARX(1,LYND)
      NXST = LXST + 1
      NXND = LXND + 1
      NXMX = NXND + 1
 
      IF(JBIN.EQ.0) THEN
        DO 14  I = 13,128
        CALL UNFMIX
   14   CONTINUE
      ELSE
        READ(NFX) (AP(J),J=13,128)
      ENDIF
 
      RETURN
 
C *** Read Palette
   20 CONTINUE
      IF(JBIN.EQ.0) THEN
        DO 210  I = 1,100000
        CALL UNFMIX
        IF(AA.EQ.CHAR(12)) GO TO 212
  210   CONTINUE
 
  212   DO 220 I = 1,256
        CALL UNFMIX
        ARD(I) = AA
        CALL UNFMIX
        AGR(I) = AA
        CALL UNFMIX
        ABL(I) = AA
  220   CONTINUE
      ELSE
        READ(NFX) AA
        READ(NFX) (ARD(J),AGR(J),ABL(J),J=1,256)
      ENDIF
      DO 230  I = 1,256
      ICV(1) = I - 1
      ICV(2) = ICHAR(ARD(I))
      ICV(3) = ICHAR(AGR(I))
      ICV(4) = ICHAR(ABL(I))
      CALL GRAFTM(4)
  230 CONTINUE
      CALL GRAFTX(6)
      RETURN
 
C *** Read Pixel Values
   30 CONTINUE
      IPP = 0
      DO 310  I = 1,10000
      IF(JBIN.EQ.0) THEN
        CALL UNFMIX
      ELSE
        READ(NFX) AA
      ENDIF
      NJ = ICHAR(AA)
      IF(NJ.GT.192) THEN
        IF(JBIN.EQ.0) THEN
          CALL UNFMIX
        ELSE
          READ(NFX) AA
        ENDIF
        DO 312  J = 1,NJ - 192
        IPP = IPP + 1
        APP(IPP) = AA
  312   CONTINUE
      ELSE
        IPP = IPP + 1
        APP(IPP) = AA
      ENDIF
      IF(IPP.GT.LXND) RETURN
  310 CONTINUE
      RETURN
 
   40 CONTINUE
      RETURN
 
  100 GO TO (110,120,130,140), JTT
 
C *** Write Header
  110 CONTINUE
C *** Identification Byte (0A), Version 3.0, RLE coding, 8 bits per pixe
      AP( 1) = CHAR(10)
      AP( 2) = CHAR(5)
      AP( 3) = CHAR(1)
      AP( 4) = CHAR(8)
 
      IDUM = KXST
      CALL MCHARX(0,IDUM)
      AP( 5) = A2
      AP( 6) = A1
 
      IDUM = KYST
      CALL MCHARX(0,IDUM)
      AP( 7) = A2
      AP( 8) = A1
 
      IDUM = KXND
      CALL MCHARX(0,IDUM)
      AP( 9) = A2
      AP(10) = A1
 
      IDUM = KYND
      CALL MCHARX(0,IDUM)
      AP(11) = A2
      AP(12) = A1
 
C *** dots per inch
      IDUM = 93
      CALL MCHARX(0,IDUM)
      AP(13) = A2
      AP(14) = A1
      AP(15) = A2
      AP(16) = A1
 
      DO 112  I = 17,64
      AP(I) = CHAR(0)
  112 CONTINUE
 
C *** reserved byte, number of colour planes
      AP(65) = CHAR(0)
      AP(66) = CHAR(1)
 
C *** bytes per line
      IDUM = MXND
      CALL MCHARX(0,IDUM)
      AP(67) = A2
      AP(68) = A1
 
      DO 114  I = 69,128
      AP(I) = CHAR(0)
  114 CONTINUE
 
      IF(JBIN.EQ.0) THEN
        DO 116  I = 1,128
        AA = AP(I)
        CALL UNFMOX
  116   CONTINUE
      ELSE
        WRITE(NFX) (AP(I),I=1,128)
      ENDIF
      RETURN
 
  120 CONTINUE
C *** Write Palette
 
      AP(1) = CHAR(12)
 
      DO 122  I = 1,256
      J = 3 * (I-1) + 2
      AP(J)   = ARD(I)
      AP(J+1) = AGR(I)
      AP(J+2) = ABL(I)
  122 CONTINUE
 
      IF(JBIN.EQ.0) THEN
 
        IF(NCR(NFIL).NE.255) THEN
          NNCR = 255
          IF(NCR(NFIL).GT.255) NNCR = 1279
          NNCR = NNCR - NCR(NFIL)
          AA = CHAR(0)
          DO 123  I = 1,NNCR
          CALL UNFMOX
  123     CONTINUE
        ENDIF
 
        DO 124  J = 1,769
        AA = AP(J)
        CALL UNFMOX
  124   CONTINUE
 
        IF(NCR(NFIL).EQ.0) RETURN
 
      ELSE
        WRITE(NFX) (AP(I),I=1,769)
      ENDIF
      RETURN
 
  130 CONTINUE
C *** Write Pixel Line, originally stored in AP
 
      IPP = 0
      ICNT = 1
 
      DO 132  I = 2,NXND
      IF(AP(I).EQ.AP(I-1) .AND. ICNT.LT.63)  THEN
        ICNT = ICNT + 1
      ELSE
        IF(ICNT.EQ.1 .AND. ICHAR(AP(I-1)).LT.192) GO TO 133
        IPP = IPP + 1
        APP(IPP) = CHAR(192 + ICNT)
  133   IPP = IPP + 1
        APP(IPP) = AP(I-1)
        ICNT = 1
      ENDIF
 
  132 CONTINUE
 
      IF(ICNT.EQ.1 .AND. ICHAR(AP(NXND)).LT.192) GO TO 135
      IPP = IPP + 1
      APP(IPP) = CHAR(192 + ICNT)
  135 IPP = IPP + 1
      APP(IPP) = AP(NXND)
 
      IF(JBIN.EQ.0) THEN
        DO 134  I = 1,IPP
        AA = APP(I)
        CALL UNFMOX
  134   CONTINUE
      ELSE
        WRITE(NFX) (APP(I),I=1,IPP)
      ENDIF
 
      RETURN
 
  140 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE RWXTIF(JT)
      SAVE
 
      CHARACTER*1  AP,APP, ARD,AGR,ABL, A1,A2,AA,AQ, AW
      CHARACTER*1  AH(1024), ABUF
      CHARACTER*8  ADEV, ANDV, ADTT
      CHARACTER*11 AS99
      CHARACTER*19 ADTM
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC4/ ADEV(9), ANDV, ADTT(2)
      COMMON /PL1X/XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /LSTX/JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /APSX/AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /RWLX/LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2X/KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, MJ
      COMMON /CRDX/A1,A2, AA, AQ(1024,9), ABUF(3000)
      COMMON /UNFX/JSOP,IENH,NFIL,NCR(9),NREC(9),NRAL(9),NHUE,NRGB,NSHF
      COMMON /CONX/JBIN, JSPT(9), IE, NSYS, JFMR, NFX
      COMMON /HEAX/AHDR
 
      DIMENSION NBPS(100,9), IZGR(100,9)
      DATA AS99/'SCHAKAL99  '/, ADTM /'1900:01:01 01:01:01'/
 
      NRGB = 256
 
      JU = IABS(JT) / 10
      JTT = MOD(IABS(JT),10)
 
      IF(JU.EQ.2) GO TO 100
 
C *** Read from file
      GO TO (10,20,30,40), JTT
 
C *** Header
   10 CONTINUE
      NCR(NFIL) = 6
      CALL UNFMX2(IZG0)
      NCR(NFIL) = IZG0
      CALL UNFMX2(NTAG)
 
      DO 12  I = 1,NTAG
      CALL UNFMX2(JTAG)
      CALL UNFMX2(JTYP)
      CALL UNFMX2(NMD1)
      CALL UNFMX2(NMD2)
      NUM = 65536 * NMD1 + NMD2
      CALL UNFMX2(IDT1)
      CALL UNFMX2(IDT2)
      IF(JTYP.EQ.3 .AND. NUM.EQ.1) THEN
        IDT = IDT1
      ELSE
        IDT = 65536 * IDT1 + IDT2
      ENDIF
 
      IF(JTAG.EQ.256) THEN
C *** ImageWidth
        LXST = 0
        LXND = IDT - 1
        NXND = IDT
      ELSE IF(JTAG.EQ.257) THEN
C *** ImageLength
        LYST = 0
        LYND = IDT - 1
      ELSE IF(JTAG.EQ.258) THEN
C *** BitsPerSample
        MBPS = IDT
      ELSE IF(JTAG.EQ.259) THEN
C *** Compression
        JCMP = IDT
      ELSE IF(JTAG.EQ.262) THEN
C *** PhotmetricInterp
        JPHI = IDT
      ELSE IF(JTAG.EQ.273) THEN
C *** StripOffsets
        IZG1 = IDT
        NSTR = NUM
      ELSE IF(JTAG.EQ.278) THEN
C *** RowsPerStrip
        IRPS = IDT
      ELSE IF(JTAG.EQ.279) THEN
C *** StripByteCounts
        IZG2 = IDT
      ELSE IF(JTAG.EQ.320) THEN
C *** ColorMap
        IZG7 = IDT
        NRGB = NUM / 3
      ELSE IF(JTAG.EQ.34620) THEN
C *** PrivateData
        IZG8 = IDT
      ENDIF
   12 CONTINUE
 
      NCR(NFIL) = IZG1
      DO 14  I = 1,NSTR
      CALL UNFMX2(IDT1)
      CALL UNFMX2(IDT2)
      IZGR(I,NFIL) = 65536 * IDT1 + IDT2
   14 CONTINUE
 
      NCR(NFIL) = IZG2
      DO 16  I = 1,NSTR
      CALL UNFMX2(IDT1)
      CALL UNFMX2(IDT2)
      NBPS(I,NFIL) = 65536 * IDT1 + IDT2
   16 CONTINUE
 
      NCR(NFIL) = IZG8
      DO 18  I = 1,75
      CALL UNFMX1
      AHDR(I:I) = AA
   18 CONTINUE
      CALL HEADEX(0)
      GO TO 999
 
C *** Read RGB Values
   20 CONTINUE
      NCR(NFIL) = IZG7
      DO 21  I = 1,NRGB
      CALL UNFMX1
      CALL UNFMX1
      ARD(I) = AA
   21 CONTINUE
      DO 22  I = 1,NRGB
      CALL UNFMX1
      CALL UNFMX1
      AGR(I) = AA
   22 CONTINUE
      DO 23  I = 1,NRGB
      CALL UNFMX1
      CALL UNFMX1
      ABL(I) = AA
   23 CONTINUE
 
      DO 25  I = 1,NRGB
      ICV(1) = I - 1
      ICV(2) = ICHAR(ARD(I))
      ICV(3) = ICHAR(AGR(I))
      ICV(4) = ICHAR(ABL(I))
      CALL GRAFTX(4)
      IF(I.EQ.1) LBCK(5) = (ICV(2) + ICV(3) + ICV(4)) / 3
   25 CONTINUE
      CALL GRAFTX(6)
      GO TO 999
 
C *** Read one line of Pixel Data
   30 CONTINUE
      NPOS = 0
 
      IF(MOD(LY,IRPS).EQ.0) NCR(NFIL) = IZGR(1+LY/IRPS,NFIL)
 
      DO 300  J = 1,100000
      CALL UNFMX1
      IAA = ICHAR(AA)
      IF(IAA.EQ.256) GO TO 300
      IF(IAA.LT.128) THEN
        DO 310  K = 1,IAA+1
        CALL UNFMX1
        NPOS = NPOS + 1
        APP(NPOS) = AA
  310   CONTINUE
      ELSE
        IAA = 256 - IAA
        CALL UNFMX1
        DO 320  K = 1,IAA+1
        NPOS = NPOS + 1
        APP(NPOS) = AA
  320   CONTINUE
      ENDIF
      IF(NPOS.GT.NXND) GO TO 991
      IF(NPOS.EQ.NXND) THEN
        NPOS = 0
        GO TO 999
      ENDIF
  300 CONTINUE
 
   40 CONTINUE
 
      GO TO 999
 
C *** Write to file
  100 GO TO (110,120,130,140), JTT
 
C *** Header
  110 CONTINUE
      CALL DATCHK
      AW = ADTT(1)(7:7)
      IF((ICHAR(AW) - 48).LT.9) ADTM(1:2) = '20'
      ADTM( 3: 4) = ADTT(1)(7:8)
      ADTM( 6: 7) = ADTT(1)(4:5)
      ADTM( 9:10) = ADTT(1)(1:2)
      ADTM(12:13) = ADTT(2)(1:2)
      ADTM(15:16) = ADTT(2)(4:5)
      ADTM(18:19) = ADTT(2)(7:8)
 
      DO 111  I = 1,1024
      AH(I) = CHAR(0)
  111 CONTINUE
 
      KYWD = KYND - KYST + 1
      NRPS = MAX0(1,(KYWD / 64))
      MSTR = FLOAT(KYWD) / FLOAT(NRPS) + .999
      LYYY = -1
 
      AH(1)   = 'M'
      AH(2)   = 'M'
      AH(4)   = CHAR(42)
      AH(8)   = CHAR(8)
      AH(10)  = CHAR(15)
C *** ImageWidth
      AH(11)  = CHAR(1)
      AH(14)  = CHAR(4)
      AH(18)  = CHAR(1)
      CALL MCHARX(0,MXND)
      AH(21)  = A1
      AH(22)  = A2
C *** ImageLength
      AH(23)  = CHAR(1)
      AH(24)  = CHAR(1)
      AH(26)  = CHAR(4)
      AH(30)  = CHAR(1)
      CALL MCHARX(0,KYND+1)
      AH(33)  = A1
      AH(34)  = A2
c *** BitsPerSample
      AH(35)  = CHAR(1)
      AH(36)  = CHAR(2)
      AH(38)  = CHAR(3)
      AH(42)  = CHAR(1)
      AH(44)  = CHAR(8)
C *** Compression
      AH(47)  = CHAR(1)
      AH(48)  = CHAR(3)
      AH(50)  = CHAR(3)
      AH(54)  = CHAR(1)
      AH(55)  = CHAR(128)
      AH(56)  = CHAR(5)
C *** PhotometricInterpretation
      AH(59)  = CHAR(1)
      AH(60)  = CHAR(6)
      AH(62)  = CHAR(3)
      AH(66)  = CHAR(1)
      AH(68)  = CHAR(3)
C *** StripOffsets
      AH(71)  = CHAR(1)
      AH(72)  = CHAR(17)
      AH(74)  = CHAR(4)
      CALL MCHARX(0,MSTR)
      AH(77) = A1
      AH(78) = A2
      JZG1 = 194
      AH(82) = CHAR(JZG1)
C *** RowsPerStrip
      AH(83) = CHAR(1)
      AH(84) = CHAR(22)
      AH(86) = CHAR(4)
      AH(90) = CHAR(1)
      AH(94) = CHAR(NRPS)
C *** StripByteCounts
      AH(95) = CHAR(1)
      AH(96) = CHAR(23)
      AH(98) = CHAR(4)
      AH(101) = A1
      AH(102) = A2
      JZG2 = JZG1 + 4 * MSTR
      CALL MCHARX(0,JZG2)
      AH(105) = A1
      AH(106) = A2
C *** XResolution
      AH(107) = CHAR(1)
      AH(108) = CHAR(26)
      AH(110) = CHAR(5)
      AH(114) = CHAR(1)
      JZG3 = JZG2 + 4 * MSTR
      CALL MCHARX(0,JZG3)
      AH(117) = A1
      AH(118) = A2
C *** YResolution
      AH(119) = CHAR(1)
      AH(120) = CHAR(27)
      AH(122) = CHAR(5)
      AH(126) = CHAR(1)
      JZG4 = JZG3 + 8
      CALL MCHARX(0,JZG4)
      AH(129) = A1
      AH(130) = A2
C *** ResolutionUnit
      AH(131) = CHAR(1)
      AH(132) = CHAR(40)
      AH(134) = CHAR(3)
      AH(138) = CHAR(1)
      AH(140) = CHAR(2)
C *** Software
      AH(143) = CHAR(1)
      AH(144) = CHAR(49)
      AH(146) = CHAR(2)
      AH(150) = CHAR(12)
      JZG5 = JZG4 + 8
      CALL MCHARX(0,JZG5)
      AH(153) = A1
      AH(154) = A2
C *** DateTime
      AH(155) = CHAR(1)
      AH(156) = CHAR(50)
      AH(158) = CHAR(2)
      AH(162) = CHAR(20)
      JZG6 = JZG5 + 12
      CALL MCHARX(0,JZG6)
      AH(165) = A1
      AH(166) = A2
C *** ColorMap
      AH(167) = CHAR(1)
      AH(168) = CHAR(64)
      AH(170) = CHAR(3)
      AH(173) = CHAR(3)
      JZG7 = JZG6 + 20 + 76
      CALL MCHARX(0,JZG7)
      AH(177) = A1
      AH(178) = A2
C *** PrivateTag
      AH(179) = CHAR(135)
      AH(180) = CHAR(60)
      AH(182) = CHAR(1)
      AH(186) = CHAR(76)
      JZG8 = JZG7 - 76
      CALL MCHARX(0,JZG8)
      AH(189) = A1
      AH(190) = A2
 
C *** Beginn Datenfelder
 
C *** XResolution
      JZGS = JZG3 + 1
      CALL MCHARX(0,MXND)
      AH(JZGS+3) = CHAR(93)
      AH(JZGS+7) = CHAR(1)
C *** YResolution
      JZGS = JZG4 + 1
      AH(JZGS+3) = CHAR(93)
      AH(JZGS+7) = CHAR(1)
C *** Software
      DO 115  I = 1,11
      AH(JZG5+I) = AS99(I:I)
  115 CONTINUE
C *** DateTime
      DO 116  I = 1,19
      AH(JZG6+I) = ADTM(I:I)
  116 CONTINUE
C *** PrivateData
      CALL HEADEX(1)
      DO 117  I = 1,75
      AH(JZG8+I) = AHDR(I:I)
  117 CONTINUE
 
      DO 118  I = 1,JZG8+76
      AA = AH(I)
      CALL UNFMOX
  118 CONTINUE
 
      IZGR(1,NFIL) = JZG7 + 6 * NRGB
      ISTR = 0
      NB = 0
 
      GO TO 999
 
  120 CONTINUE
C *** Palette
 
      IBTE = JZG8 + 76
 
      DO 122  J = 1,3
      DO 124  I = 1,NRGB
      IF(J.EQ.1) THEN
        AA = ARD(I)
      ELSE IF(J.EQ.2) THEN
        AA = AGR(I)
      ELSE
        AA = ABL(I)
      ENDIF
      CALL UNFMOX
      IBTE = IBTE + 1
      IF(IBTE.LT.1025) AH(IBTE) = AA
      CALL UNFMOX
      IBTE = IBTE + 1
      IF(IBTE.LT.1025) AH(IBTE) = AA
  124 CONTINUE
  122 CONTINUE
      RETURN
 
  130 CONTINUE
C *** Write Pixel Line, stored in AP
 
      ICT  = 0
      IBTE = 0
      ISTL = 1
      INDL = 0
 
      IF(IE.EQ.IENH) LYYY = LYYY + 1
 
      DO 132  I = 3,NXND+1
      JEQL = 0
 
      IF(I.GT.NXND) THEN
        JEQL = 1
        IF(ICT.EQ.0) THEN
          ICT = -1
          INDL = NXND
        ENDIF
      ENDIF
 
      IF(JEQL.EQ.0) THEN
        IF(AP(I).NE.AP(I-1) .OR. AP(I).NE.AP(I-2)) JEQL = 1
      ENDIF
 
      IF(JEQL.EQ.0) THEN
        IF(ICT.EQ.0) INDL = I - 3
        AW = AP(I)
        ICT = ICT + 1
      ELSE
        IF(ICT.NE.0) THEN
          IF(ISTL.LE.INDL) THEN
            NBA = 1 + (INDL - ISTL) / 128
 
            DO 134  J = 1,NBA
            KEND = MIN0((ISTL+127),INDL)
            IBTE = IBTE + 1
            LDUM = KEND-ISTL
            ABUF(IBTE) = CHAR(LDUM)
 
            DO 136  K = ISTL,KEND
            IBTE = IBTE + 1
            ABUF(IBTE) = AP(K)
  136       CONTINUE
 
            ISTL = ISTL + 128
  134       CONTINUE
 
          ENDIF
          IF(ICT.GT.0) THEN
            ICT = ICT + 1
            NBA = 1 + ICT / 128
 
            DO 138  J = 1,NBA
            IDUM = 128
            IF(J.EQ.NBA) THEN
              IDUM = MOD(ICT+1,128)
              IF(IDUM.EQ.0) THEN
                IDUM = 128
              ELSE IF(IDUM.EQ.1) THEN
                IDUM = 257
              ENDIF
            ENDIF
            IBTE = IBTE + 1
            LDUM = 256-(IDUM-1)
            ABUF(IBTE) = CHAR(LDUM)
            IBTE = IBTE + 1
            ABUF(IBTE) = AW
  138       CONTINUE
          ENDIF
          ISTL = I
        ENDIF
        ICT = 0
      ENDIF
  132 CONTINUE
 
      DO 139  I = 1,IBTE
      AA = ABUF(I)
      CALL UNFMOX
  139 CONTINUE
 
      NB = NB + IBTE
 
      IF(IE.LT.IENH)  GO TO 999
 
      IF(MOD(LYYY,NRPS).EQ.(NRPS-1) .OR. LYYY.EQ.KYND) THEN
        ISTR = ISTR + 1
        NBPS(ISTR,NFIL) = NB
        IZGR(ISTR+1,NFIL) = IZGR(ISTR,NFIL) + NB
 
        NB = 0
      ENDIF
 
      GO TO 999
 
  140 CONTINUE
C *** Write StripOffstes and StripByteCounts into record 1
 
      JZG = JZG1
 
      DO 141  I = 1,MSTR
      IDUM = IZGR(I,NFIL) / 65536
      CALL MCHARX(0,IDUM)
      JZG = JZG + 1
      AH(JZG) = A1
      JZG = JZG + 1
      AH(JZG) = A2
      IDUM = MOD(IZGR(I,NFIL),65536)
      CALL MCHARX(0,IDUM)
      JZG = JZG + 1
      AH(JZG) = A1
      JZG = JZG + 1
      AH(JZG) = A2
  141 CONTINUE
 
      JZG = JZG2
 
      DO 142  I = 1,MSTR
      IDUM = NBPS(I,NFIL) / 65536
      CALL MCHARX(0,IDUM)
      JZG = JZG + 1
      AH(JZG) = A1
      JZG = JZG + 1
      AH(JZG) = A2
      IDUM = MOD(NBPS(I,NFIL),65536)
      CALL MCHARX(0,IDUM)
      JZG = JZG + 1
      AH(JZG) = A1
      JZG = JZG + 1
      AH(JZG) = A2
  142 CONTINUE
 
      DO 144 I = NCR(NFIL)+1,1024
  144 AQ(I,NFIL) = CHAR(0)
      WRITE(NFX,REC=NREC(NFIL)+1) (AQ(J,NFIL), J=1,1024)
      WRITE(NFX,REC=1) AH
      GO TO 999
 
  991 WRITE(18,*) '### wrong number of pixels: NPOS,NXND =',NPOS,NXND
 
  999 RETURN
      END
 
 
      SUBROUTINE GRAFTX(JT)
      SAVE
 
      CHARACTER*1 AP, APP, ARD, AGR, ABL
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /APSX/AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
 
      IF(JT.NE.4) RETURN
      I = ICV(1) + 1
 
      ARD(I) = CHAR(ICV(2))
      AGR(I) = CHAR(ICV(3))
      ABL(I) = CHAR(ICV(4))
 
      RETURN
      END
