C *** SCHAKAL: MAIN PROGRAM
C     by Egbert Keller / Kristallographisches Institut der Universitaet
C     Albertstr. 25 / 79104 Freiburg / Germany /  Tel. 0761-203-6438
 
      PROGRAM SCHAKAL
 
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
 
      JFPG = 0
 
      IDDD = 0
      IMMM = 0
 
      CALL ARGCHK
 
      CALL XINIT(IDDD)
 
      CALL SETPRM
      CALL FSTPGE
      CALL MACH(1)
      IF(JRRR.NE.0) GO TO 1
      CALL SYSCHK
      IF(JRRR.NE.0) GO TO 1
 
      CALL WRITS(106)
      CALL XCLTEXWIN
 
      JFPG = 1
      JTLN = 1
 
      CALL SETDEV
      IF(JRRR.NE.0) GO TO 1
 
      CALL READCO
      CALL INTEP(-2)
      CALL MACH(2)
    1 STOP
      END
 
 
      SUBROUTINE SETPRM
C *** Set up some machine specific variables
      SAVE
 
      CHARACTER*1 ABCG, ABCK, AZIF, ASEP, ASTR
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /CHR/ ABCG(28), ABCK(28), AZIF(11), ASEP(25), ASTR(5)
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
 
C *** Set up some machine specific variables
 
C *** Version Code (set by xgraph.c !!)
C     MCHN(1) = ?
 
C *** Graphics Y coordinates, zero at bottom (0) or at top (1)
      MCHN(2) = 1
 
C *** fill_rectangle implemented: no (0) or yes (1)
      MCHN(3) = 1
 
C *** OpenGL/>8bit version:
C     OpenGL no/yes: jxgl = 0/1; >8bit no/yes: ICDP = 0/1
C     MCHN(5) =  1000 * jxgl + ICDP   (set by XSCHINIT.F !!)
 
C *** Determine time required for 500000 sin(i)
      INCK = 500000
 
      CALL TIMCHK(0)
      ITM(2) = ITM(1)
      DO 1  I = 1,INCK
      TEST = SIN(FLOAT(I))
    1 CONTINUE
      CALL TIMCHK(0)
      DTM = (ITM(1) - ITM(2)) / 1000.
      MCHN(4) = 0
      IF(DTM.GT.1.E-6) MCHN(4) = FLOAT(INCK) / DTM
 
C *** Default angle increment for on-screen rotations
C     2. Statement spaeter entfernen !
      PANI(1) = 1.
      PPIN(3) = 1.
 
C *** Some special characters
C     HP-UX:  use the next three lines instead of the following three
C     ASEP(10) = ''''
C     ASEP(11) = '"'
C     ASEP(24) = '\'
      ASEP(10) = '\''
      ASEP(11) = '\"'
      ASEP(24) = '\\'
      ASEP(25) = ASEP(24)
      ASTR(4)  = ASEP(24)
 
      RETURN
      END
 
 
      SUBROUTINE FSTPGE
C *** This contains the text which is output at the beginning.
      SAVE
 
      CHARACTER*1 ABCG, ABCK, AZIF, ASEP, ASTR
      CHARACTER*6  ALBL, AFLB, ASTL
      CHARACTER*7  ADDV
      CHARACTER*8  ADEV, ANDV, ADTT
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*80 WLIN, CLIN
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /MC4/ ADEV(9), ANDV, ADTT(2)
      COMMON /CHR/ ABCG(28), ABCK(28), AZIF(11), ASEP(25), ASTR(5)
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
 
      LOGICAL XFSTPGE,XPALSET
      COMMON/XSPEC/XFSTPGE,XPALSET
 
      XFSTPGE = .TRUE.
      XPALSET = .FALSE.
 
C *** Fill in a "Version Indicator"  (1st line) and a row of
C     stars (of equal length), as shown in the example underneath
C
      AVRS = 'X-Win           '
      AULN = '*****           '
      IF((MCHN(5)/1000).NE.0) THEN
        AVRS(6:8) = '/GL'
        AULN(6:8) = '***'
      ENDIF
      ADEV(1) = AVRS(1:8)
 
      JFPG = 0
 
      CALL WROUT(-3)
      WRITE(WLIN,9000) AVRS
 9000 FORMAT(' S C H A K A L  9 9 / ',A)
      CALL WROUT(0)
      WRITE(WLIN,9001) AULN
 9001 FORMAT(' *********************',A)
      CALL WROUT(0)
      WRITE(WLIN,9002)
 9002 FORMAT(' Version of December, 2004')
      CALL WROUT(0)
      CALL WROUT(-1)
      WRITE(WLIN,9003)
 9003 FORMAT(' by Egbert Keller')
      CALL WROUT(0)
      WRITE(WLIN,9004)
 9004 FORMAT(' Kristallographisches Institut der Universitaet')
      CALL WROUT(0)
      WRITE(WLIN,9005)
 9005 FORMAT(' Hebelstr. 25 / D-79104 Freiburg i.Br. / Germany')
      CALL WROUT(0)

      CALL WROUT(-3)
      WRITE(WLIN,9050)
 9050 FORMAT(' Adaption to X-Windows performed by ',
     * '+++ Arnd Steinmetz +++ (IBM),')
      CALL WROUT(0)
      WRITE(WLIN,9051)
 9051 FORMAT(' for SCHAKAL 92 on IBM RS/6000;  with portability ',
     * 'improvements by')
      CALL WROUT(0)
      WRITE(WLIN,9052)
 9052 FORMAT(' M. Veittes (Univ. Koeln) and  C. Taverner ',
     * '(Univ. Witwatersrand).')
      CALL WROUT(0)
      CALL WROUT(-1)
      WRITE(WLIN,9054)
 9054 FORMAT(' Modified and enhanced for SCHAKAL 99  by ',
     * 'J.-S. Pierrard and E. Keller.  ')
      CALL WROUT(0)
      WRITE(WLIN,9055)
 9055 FORMAT(' The file selection box written by ',
     * 'P. Stiegeler bases on code written ')
      CALL WROUT(0)
      WRITE(WLIN,9056)
 9056 FORMAT(' by E. A. Falk ')
      CALL WROUT(0)
      CALL PCSEC
      CALL WROUT(-3)
 
      XFSTPGE = .FALSE.
 
      RETURN
      END
 
 
      SUBROUTINE ARGCHK
C *** Get command line arguments for routine SETSYS (s21.for)
 
      SAVE
 
      CHARACTER*6 ALBL, AFLB, ASTL
      CHARACTER*7 ADDV
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP, AFIQ
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
 
      JRRR = 1
      IAR3 = 0
 
      J = IARGC()
      IF (J.EQ.0) GO TO 9
      DO 10  I = 1,J
C *** HP-UX: Use GETARG_(I,AFIQ)  instead of  GETARG(I,AFIQ)
      CALL GETARG(I,AFIQ)
      AFIP = AFIQ
      CALL SETSYS(0)
   10 CONTINUE
 
    9 AFIP = ' '
      JRRR = 0
 
      CALL SETSYS(1)
 
      RETURN
      END
 
 
      SUBROUTINE DATCHK
C *** Check for date and time
 
      SAVE
      CHARACTER*8 ADEV, ANDV, ADTT
      COMMON /MC4/ ADEV(9), ANDV, ADTT(2)
 
      CALL XEDATE(IDDD,IMMM,IYYY,ISCC,IMNN,IHRR)
 
      WRITE(ADTT(1)(1:2),9000) IDDD
 9000 FORMAT(I2.2)
      ADTT(1)(3:3) =  '/'
      WRITE(ADTT(1)(4:5),9000) IMMM
      ADTT(1)(6:6) =  '/'
      WRITE(ADTT(1)(7:8),9000) MOD(IYYY,100)
 
      WRITE(ADTT(2)(1:2),9000) IHRR
      ADTT(2)(3:3) =  ':'
      WRITE(ADTT(2)(4:5),9000) IMNN
      ADTT(2)(6:6) =  ':'
      WRITE(ADTT(2)(7:8),9000) ISCC
 
      RETURN
      END
 
 
      SUBROUTINE TIMCHK(JT)
C *** Check for CPU or real time
 
      SAVE
 
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
 
      IF(JT.NE.0) GO TO 1
C *** CPU-time in milliseconds; if not available, substitute by ITM(1) =
 
      ITM(1) = MMCLOCK()
 
      RETURN
 
C *** real (clock) time in millisec; if not available, subst. by ITM(1)
 
    1 CONTINUE
 
      CALL XDAYTIM(IMSTIM)
      ITM(1) = IMSTIM
 
      RETURN
      END
 
 
      SUBROUTINE KEYCHK(JT)
C *** Check, if a Character has been typed at the keyboard  i n   t h e
C     m e a n t i m e  (since last check).
 
      SAVE
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
 
      JRRR = 0
 
      CALL XGETCHR(ICHR)
 
      IF(ICHR.EQ.27) JRRR = 1
 
C *** additions for on-screen rotations and move of graphics cursor.
 
      IF(ICHR.EQ.77) THEN
      JRRR = 2
      ELSE IF(ICHR.EQ.75) THEN
      JRRR = 3
      ELSE IF(ICHR.EQ.80) THEN
      JRRR = 4
      ELSE IF(ICHR.EQ.72) THEN
      JRRR = 5
      ELSE IF(ICHR.EQ.52) THEN
      JRRR = 6
      ELSE IF(ICHR.EQ.54) THEN
      JRRR = 7
      ELSE IF(ICHR.EQ.56) THEN
      JRRR = 8
      ELSE IF(ICHR.EQ.50) THEN
      JRRR = 9
      ELSE IF(ICHR.EQ.76) THEN
      JRRR = 10
      ELSE IF(ICHR.EQ.120 .OR. ICHR.EQ.88) THEN
      JRRR = 11
      ELSE IF(ICHR.EQ.32) THEN
      JRRR = 12
      ELSE IF(ICHR.EQ.109 .OR. ICHR.EQ.77) THEN
      JRRR = 13
      ENDIF
 
      IF(JRRR.NE.0) JRRA = JRRR
      IF((JT.LE.0 .OR. JT.EQ.2) .AND. JRRR.NE.1) JRRR = 0
 
      RETURN
      END
 
 
      SUBROUTINE ESCCHK
      RETURN
      END
 
 
      SUBROUTINE RDIN
C *** all text input from terminal (NEIN) is going through this
 
      SAVE
      CHARACTER*80 WLIN, CLIN
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
 
      LOGICAL XFSTPGE,XPALSET
      COMMON/XSPEC/XFSTPGE,XPALSET
 
      IF(JSRF.NE.0) THEN
        CALL SURFSE
        RETURN
      ENDIF
 
      IF(JTLN.EQ.0) THEN
 
      IF(XPALSET) CALL TCOLRS(0)
      CALL XTEXTIN(WLIN)
 
      ELSE
        I = 0
    1   CALL KEYCHK(2)
        IF(ICHR.LT.32) THEN
          IF(ICHR.EQ.13) GO TO 2
          IF(ICHR.EQ. 8) THEN
            WLIN(I:I) = ' '
            CALL WRTE(I,0)
            I = MAX0(0,I-1)
          ENDIF
        ELSE
          I = I + 1
          WLIN(I:I) = CHAR(ICHR)
          CALL WRTE(I,0)
        ENDIF
        GO TO 1
      ENDIF
 
    2 JREA = 0
 
      RETURN
      END
 
 
      SUBROUTINE WRTE(IW,JT)
C *** all text output to terminal (NOUT) is produced herewith
C IBM moved textterminal onto own textwindow
C IBM end
 
      SAVE
 
      CHARACTER*80 OUTSTR
      LOGICAL XFSTPGE,XPALSET
      COMMON/XSPEC/XFSTPGE,XPALSET
 
      CHARACTER*80 WLIN, CLIN
      CHARACTER*78 ATLN
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
      COMMON /ATL/ ATLN(26)
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
 
      I = IABS(IW)
      IF(JTLN.NE.0) GO TO 2
 
      IF (XPALSET) CALL TCOLRS(1)
      IF (XFSTPGE) THEN
        WRITE(NAUS,9000) (WLIN(J:J),J=1,I)
 9000   FORMAT(78A1)
      ENDIF
      WRITE(OUTSTR,9000) (WLIN(J:J),J=1,I)
      CALL XTEXTOUT(OUTSTR)
      RETURN
 
    2 IF(JT.EQ.0 .AND. JTSV.EQ.0) GO TO 3
 
      ITXX = IDXX
 
      IF(JTSV.NE.0) THEN
        JTSV = 0
        NTLY = 1
        ITXY = IDXY
        RETURN
      ENDIF
 
      ITXY = NTLY - 1 + IDXY
 
    3 ITTX = ITXX * IWCH
      ITTY = ITXY * IHCH
 
      IST = 1 + JT
      I = MAX0(IST,IABS(IW))
 
      IF(JPUL(2).EQ.0 .OR. JT.EQ.0) THEN
 
        ITAX = ITTX
        IF(JT.EQ.0 .AND. ITXX.NE.IDXX) ITAX = ITTX - IWCH + 1
        ITAX = MAX0(0,ITAX - 2) - INT(XANI(1))
 
        NTLX = MAX0(NTLX,ITXX + I - JT)
        ITEX = NTLX * IWCH + 2 - INT(XANI(1))
 
        ITAY = MAX0(0,ITTY - 1) + INT(XANI(2))
        ITEY = ITTY + IHCH - 1 + INT(XANI(2))
 
        CALL XCLAREA(ITAX,ITAY,ITEX,ITEY,0,1)
 
      ENDIF
 
      IF(JTLN.EQ.1) CALL TCOLRS(JT)
      WLIN(I+1:I+1) = CHAR(0)
      IX1 = ITTX - INT(XANI(1))
      IY1 = ITTY + INT(XANI(2))
      CALL XDRAWTEXT(WLIN(IST:I),IX1,IY1+IHCH-4,ICLT)
      WLIN(I+1:I+1) = ' '
      CALL TCOLRS(0)
 
      IF(JT.NE.0) THEN
        ATLN(NTLY) = WLIN(2:79)
        IF(WLIN(I:I).EQ.'>') ITXX = IDXX + I
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE CHRPOS(ICCX,ICCY)
C *** Returns row/column of a text character selected by mouse
      SAVE
 
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /CRS/ ICRX,ICRY, ICX,ICY, JBGN,JTRM,JARM, LCRS
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
 
      ICCX = 1 + (ICRX / IWCH) - IDXX
      ICCY = 1 + (IXYX(2) - ICRY) / IHCH - IDXY
 
      RETURN
      END
 
 
      SUBROUTINE SOUNDG
C *** generates a beep
 
      CALL XBEEP
      RETURN
      END
 
 
      SUBROUTINE OPENF(JT,NFIL,AFIL,ASTA,LERR)
C *** Check for file existence or open a file
 
      CHARACTER*7 ASTA
      CHARACTER*164 AFIL
      LOGICAL LEX
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
 
      LERR = 0
      GO TO (10,20,30,30), JT
 
C *** Check for the existence of a file
   10 CONTINUE
      INQUIRE(FILE=AFIL,EXIST=LEX)
      IF(.NOT.LEX) GO TO 19
      RETURN
 
C *** Open a sequential file
   20 CONTINUE
      CALL CLOSEF(NFIL)
      OPEN(NFIL,FILE=AFIL,STATUS=ASTA,ERR=19)
      REWIND NFIL
      RETURN
 
C *** Open an unformatted direct-access file, record length=1024 bytes
   30 CONTINUE
      CALL CLOSEF(NFIL)
      JRCL = 1024
      IF(MCHN(1).EQ.12 .OR. MCHN(1).EQ.13) JRCL = 256
      OPEN(NFIL,FILE=AFIL,STATUS=ASTA,FORM='UNFORMATTED',ACCESS=
     * 'DIRECT',RECL=JRCL,ERR=19)
      RETURN
 
   19 LERR = 1
      RETURN
      END
 
 
      SUBROUTINE CLOSEF(NFIL)
C *** Close a file
 
      CLOSE(NFIL)
 
      RETURN
      END
 
 
      SUBROUTINE SEDIT(JT)
C *** execute some batch (script) files
 
      SAVE
      CHARACTER*6 ALBL, AFLB, ASTL
      CHARACTER*7 ADDV
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      CHARACTER*254 AFIM
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
 
      AFIM = ' '
      IF(NSYS(2).NE.0) AFIM(1:NSYS(2)) = ASYS(2)(1:NSYS(2))
 
      IF(JT.EQ.0) THEN
        CALL TXTWDW(1)
        CALL TXTWDW(0)
        AFIM(NSYS(2)+1:NSYS(2)+10) = 'editt.sh '
      ELSE IF(JT.EQ.1) THEN
        AFIM(NSYS(2)+1:NSYS(2)+10) = 'cppy .sh '
        AFIM(NSYS(2)+5:NSYS(2)+ 5) = CHAR(LDEV + 48)
      ELSE IF(JT.EQ.2) THEN
        AFIM(NSYS(2)+1:NSYS(2)+10) = 'dellt.sh '
      ENDIF
 
      AFIM(NSYS(2)+11:NSYS(2)+174) = AFIL
 
      DO 10  J = 254,1,-1
      IF(AFIM(J:J).NE.' ') GO TO 11
   10 CONTINUE
 
   11 CALL SYSTEM('sh '//AFIM)
 
      RETURN
      END
 
 
      SUBROUTINE SDIRY
C *** Get a directory listing
 
      SAVE
      CHARACTER*6 ALBL, AFLB, ASTL
      CHARACTER*7 ADDV
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      CHARACTER*185 AFIM
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
 
      DO 10  J = 164,1,-1
      IF(AFIL(J:J).NE.' ') GO TO 11
   10 CONTINUE
 
   11 AFIM = ' '
 
      AFIM(1:6) = 'ls -s '
      AFIM(7:J+6) = AFIL(1:J)
      J = J + 8
      AFIM(J:J) = '>'
      IF(NSYS(2).GT.0) AFIM(J+1:J+NSYS(2)) = ASYS(2)(1:NSYS(2))
      J = J + NSYS(2) + 1
      AFIM(J:J+8) = 'sch99.dls'
 
      CALL SYSTEM(AFIM)
 
      RETURN
      END
 
 
      SUBROUTINE FLIST(IOPN,JT)
C *** This lists a DOS directory which has been written onto the file
C     sch99.dls . File names (without Prefix and Suffix) and sizes (in
C     bytes) are listed in three columns. If this is difficult to im-
C     plement, you may use one column only.
 
      SAVE
      CHARACTER*4  ADOT
      CHARACTER*6  ALBL, AFLB, ASTL
      CHARACTER*7  ADDV
      CHARACTER*5  ASIZ(3)
      CHARACTER*10 ASUF, ASF2, ASFF
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*80 WLIN, CLIN
 
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP, AFNM(3)
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /WRT/ IWRA, IWRB, IWRC, IWRD, RWRA, RWRB
      COMMON /AUT/ JWKA,JKSA,JKSS,JCSR, JTX,NTXN,JWCD,NPMX, LSFF
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /DEC/ IBEG,JER,JNAB,JNBS,JAD,JNG,IANF,ISTP, JSI(3),PAR(3),
     *             IPPR(3),IKEY,LKEY(3),IPAR,JEXM
 
      JEND = 0
      NWRT = 2
      CALL MACH(-3)
 
      CALL WROUT(-1)
      CALL PCERS(0)
      ASFF = ASUF(IOPN)
 
      DO 100  I = 10,1,-1
      IF(ASFF(I:I).NE.' ') GO TO 101
  100 CONTINUE
  101 ISFF = I
 
      DO 20  I = 80,1,-1
      IF(APRE(IOPN)(I:I).NE.' ') GO TO 21
   20 CONTINUE
   21 ADOT = ' '
      IF(I.GT.36) ADOT = '... '
      IPRE = I
 
      WRITE(WLIN,9001) ADDV(IOPN), APRE(IOPN)(1:36), ADOT, ASFF
 9001 FORMAT(1X,'*** ',A7,' Files: ',A36,A4,2X,A10)
      CALL WROUT(0)
      CALL WROUT(-1)
 
C *** read the rest of the file
    1 CONTINUE
 
C *** Character strings for file names and sizes are filled with blanks
      DO 5  J = 1,2
      AFNM(J) = ' '
      ASIZ(J) = ' '
    5 CONTINUE
 
      DO 10  J = 1,2
 
      READ(NFH,8000,END=9) AFNM(J)
 8000 FORMAT(A164)
 
      JBLK = 0
      NBLK = 0
 
      DO 120  I = 1,5
      IF(AFNM(J)(I:I).EQ.' ') JBLK = 0
      IF(JBLK.EQ.0 .AND. AFNM(J)(I:I).NE.' ') THEN
        JBLK = 1
        NBLK = NBLK + 1
        IF(NBLK.EQ.2) GO TO 121
      ENDIF
  120 CONTINUE
  121 IBGG = I - 1
      IBG5 = MIN0(5,IBGG)
      ASIZ(J) = ' '
      ASIZ(J)(1:IBG5) = AFNM(J)(1:IBG5)
      DO 125  I = 1,164-IBGG
      AFNM(J)(I:I) = AFNM(J)(I+IBGG:I+IBGG)
  125 CONTINUE
 
      DO 110  I = 164,1,-1
      IF(AFNM(J)(I:I).NE.' ') GO TO 111
  110 CONTINUE
  111 IDLS = I - ISFF
      AFNM(J)(IDLS+1:I) = ' '
      DO 115  I = IPRE+1,IDLS
      AFNM(J)(I-IPRE:I-IPRE) = AFNM(J)(I:I)
  115 CONTINUE
      IDLS = IDLS - IPRE
      AFNM(J)(IDLS+1:30) = ' '
   10 CONTINUE
 
      GO TO 8
 
    9 JEND = 1
 
C *** condense the three lines to one line of terminal output; count
C     number of terminal output lines (NWRT).
    8 WRITE(WLIN,9000) (ASIZ(J),AFNM(J)(1:28),J=1,2)
 9000 FORMAT(1X,3(A5,1X,A28,1X))
      CALL WROUT(0)
 
      NWRT = NWRT + 1
      IF(NWRT.EQ.NPMX) THEN
        CALL WRITS(107)
        CALL WROUT(-3)
        NWRT = 0
        IF(IWRA.NE.0) GO TO 999
      ENDIF
      IF(JEND.EQ.0) GO TO 1
 
  999 CALL WROUT(-1)
      CALL CLOSEF(NFH)
 
      RETURN
      END
 
 
      SUBROUTINE CLCXOR(I1,I2)
C *** perform XOR operation
 
      I1 = XOR(I1,I2)
 
      RETURN
      END
 
 
      SUBROUTINE USERZ(LL2,JRUS)
C *** User-accessible machine-dependent routines. If you install a rou-
C     tine for a letter AL (1st letter of second label word of 'Z..'
C     command) don't forget to set JRUS = 1, as it is done for letter
C     "A", below.
 
      SAVE
      CHARACTER*1 AL
      CHARACTER*6 ALBL, AFLB, ASTL
      CHARACTER*7 ADDV
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      CHARACTER*80 WLIN, CLIN
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /DEC/ IBEG,JER,JNAB,JNBS,JAD,JNG,IANF,ISTP, JSI(3),PAR(3),
     *             IPPR(3),IKEY,LKEY(3),IPAR,JEXM
      COMMON /REF/ IX1,IX2,IY1,IY2,NCS,NCL
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
      COMMON /AUT/ JWKA,JKSA,JKSS,JCSR, JTX,NTXN,JWCD,NPMX, LSFF
      DATA NZM/0/
 
      JRUS = 0
      AL = CHAR(IABS(LL2)+64)
      IF(AL.NE.'A') GO TO 2
      JRUS = 1
      CALL WROUT(-1)
      WRITE(WLIN,9000) AL, PAR
 9000 FORMAT(1X,A1,3F8.3)
      CALL WROUT(0)
      RETURN
 
    2 IF(AL.NE.'B') GO TO 3
      JRUS = 1
      IF(PAR(1).LT.0.01) THEN
        IX1 =  80
        IX2 = 580
        IY1 = 100
        IY2 = 440
        CALL REFORM(0)
      ELSE
        NCS = 8
        NCL = 0
        CALL REFORM(1)
      ENDIF
      RETURN
 
    3 IF(AL.NE.'C') GO TO 4
      RETURN
 
    4 IF(AL.NE.'U') GO TO 5
 
C *** Next 2 statements make an interface to UNIX
      JRUS = 1
      WRITE(WLIN,9004)
 9004 FORMAT(' Enter UNIX command >> ')
      CALL WROUT(0)
      CALL WRITS(3)
      DO 400  I = 164,1,-1
      IF(AFIL(I:I).NE.' ') GO TO 401
  400 CONTINUE
  401 CALL SYSTEM(AFIL(1:I))
      RETURN
 
    5 CONTINUE
      IF(AL.NE.'E') GO TO 6
      RETURN
 
    6 CONTINUE
      IF(AL.NE.'F') GO TO 7
      RETURN
 
    7 CONTINUE
      IF(AL.NE.'M') GO TO 8
      JRUS = 1
      JKSA = 1
      JKSS = 0
      IF(IPPR(1).EQ.0) THEN
        IF(JSRF.EQ.0) NZM = 0
        JJT = 0
        IF(NZM.NE.0) JJT = 1
        CALL SURFIN(JJT)
        IF(NZM.EQ.0) CALL TXTWDW(0)
        NZM = 1
      ELSE IF(IPPR(1).EQ.1) THEN
        CALL SURFAC(29)
      ELSE IF(IPPR(1).GT.4) THEN
        JJT = IPPR(1)
        CALL SFICON(JJT)
      ENDIF
      RETURN
 
    8 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE PCSEC
C *** Special routine for PC-DOS version
 
      SAVE
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
 
      RETURN
      END
 
 
      SUBROUTINE SYSCHK
C *** Checks for the resolution of the graphics system
      SAVE
 
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC2/ XMNG(9),XMXG(9),YMNG(9),YMXG(9),RSG(9),IRS(9),INIT(9)
      COMMON /MC3/ FXYG(9),FMON(9),IPRS,FCXY,FACX,XNLG(2), RSTG,XCXG
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /EVE/ ITVS, IRSX, IRSY
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
 
C *** At this point, IRSX x IRSY is the graphics resolution (specify
C     the resolution of the graphics area only (without window frame)
 
      IXYX(1) = IPIX(1)
      IXYX(2) = IPIY(1)
 
      CALL MOUSEP(0)
 
      RETURN
      END
 
 
      SUBROUTINE INTEP(JTT)
C *** This initializes and terminates the graphics drivers
 
      SAVE
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
 
      LOGICAL XFSTPGE,XPALSET
      COMMON/XSPEC/XFSTPGE,XPALSET
 
      JT = IABS(JTT)
      GO TO (10,20,30,40,40,40,70,80,90), JT
 
   10 CONTINUE
C *** Initialization
 
      IF(JDEV.NE.0) GO TO (11,11,13,13,13,16,17,18,19), JDEV
 
   11 CONTINUE
 
      CALL SETMAP(1)
      XPALSET = .TRUE.
 
      RETURN
 
   13 CONTINUE
      CALL HPINI(0)
  131 IF(JRRR.NE.0) RETURN
      CALL MONIT(0)
      RETURN
 
   16 CONTINUE
      CALL PSINI(0)
      GO TO 131
 
   17 CONTINUE
      CALL WMFINI(0)
      GO TO 131
 
   18 CONTINUE
      RETURN
   19 CONTINUE
      RETURN
 
   20 CONTINUE
C *** Termination
 
      JEND = 0
      IF(JDEV.NE.0) GO TO (21,21,23,23,23,26,27,28,29), JDEV
 
   21 CONTINUE
 
      CALL XTERM
 
      IF(JTT.LT.0) THEN
        IF(JEND.NE.0) RETURN
        JEND = 1
      ENDIF
      IF(JOPN.LT.3) RETURN
      GO TO (23,23,23,26,27,28,29), JOPN-2
 
   23 CONTINUE
      CALL HPEND
  231 IF(JTT.LT.0) THEN
        IF(JEND.NE.0) RETURN
        JEND = 1
        GO TO 21
      ENDIF
      RETURN
 
   26 CONTINUE
      CALL PSEND
      GO TO 231
 
   27 CONTINUE
      CALL WMFEND
      GO TO 231
 
   28 CONTINUE
      RETURN
   29 CONTINUE
      RETURN
 
   30 CONTINUE
C *** Termination with following initialization (called by 'U P')
 
      IF(JDEV.NE.0) GO TO (31,31,33,33,33,36,37,38,39), JDEV
 
   31 CONTINUE
      RETURN
 
   33 CONTINUE
      CALL HPINI(JTT)
  331 IF(JRRR.NE.0) RETURN
      IF(JTT.GT.0) CALL MONIT(0)
      RETURN
 
   36 CONTINUE
      CALL PSINI(JTT)
      GO TO 331
 
   37 CONTINUE
      CALL WMFINI(JTT)
      GO TO 331
 
   38 CONTINUE
      RETURN
   39 CONTINUE
      RETURN
 
   40 CONTINUE
C *** Partial erasure of plotter file
 
      IF(JDEV.NE.0) GO TO (41,41,43,43,43,46,47,48,49), JDEV
 
   41 CONTINUE
      RETURN
 
   43 CONTINUE
      JTU = JT - 4
      CALL HPERS(JTU)
      IF(JTU.NE.0) RETURN
      CALL MONIT(0)
      CALL HPRED(0)
      RETURN
 
   46 CONTINUE
      JTU = JT - 4
      CALL PSERS(JTU)
      IF(JTU.NE.0) RETURN
      CALL MONIT(0)
      CALL PSRED(0)
      RETURN
 
   47 CONTINUE
      JTU = JT - 4
      CALL WMFERS(JTU)
      IF(JTU.NE.0) RETURN
      CALL MONIT(0)
      CALL WMFRED(0)
      RETURN
 
   48 CONTINUE
      RETURN
   49 CONTINUE
      RETURN
 
   70 CONTINUE
C *** Mark a plotter file (beginning of new partition)
 
      IF(JDEV.NE.0) GO TO (71,71,73,73,73,76,77,78,79), JDEV
 
   71 CONTINUE
      RETURN
 
   73 CONTINUE
      CALL HPMARK
      RETURN
 
   76 CONTINUE
      CALL PSMARK
      RETURN
 
   77 CONTINUE
      CALL WMFMRK
      RETURN
 
   78 CONTINUE
      RETURN
   79 CONTINUE
      RETURN
 
   80 CONTINUE
C *** Switch for PCL 5 and back to HP-GL
 
      IF(JDEV.EQ.4) CALL HPPCL5(JTT)
 
      RETURN
 
   90 CONTINUE
C *** Empty buffer for HP-GL/2 or Postscript
 
      JU = 0
      IF(JTT.LT.0) JU = 1
      IF(JDEV.EQ.5) CALL PEMPTY(JU)
      IF(JDEV.EQ.6) CALL PSEMPT(JU)
      IF(JDEV.EQ.7 .AND. JU.NE.0) CALL WMFEMP(1)
 
      RETURN
      END
 
 
      SUBROUTINE MOVEP
C *** This moves to coordinates XMV, YMV [cm]  (with pen up)
 
      SAVE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /PL3/ IXMV,IYMV,IPCT
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
 
      IF(JDEV.NE.0) GO TO (11,11,13,13,15,16,17,18,19), JDEV
 
   11 CONTINUE
      IX = XMV
      IY = YMV
  111 IXMV = IX
      IYMV = IY
      RETURN
 
   13 CONTINUE
      IPCL = 1
      CALL HPPLT
  131 IX = IXPX(1) + INT(XMV) / FMOX
      IY = IYPX(1) + INT(YMV) / FMOX
      GO TO 111
 
   15 CONTINUE
      IPCL = 1
      CALL PPLT
      GO TO 131
 
   16 CONTINUE
      IPCL = 1
      CALL PSPLT
      GO TO 131
 
   17 CONTINUE
      IPCL = 1
      CALL WMFPLT
      GO TO 131
 
   18 CONTINUE
      RETURN
   19 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE DRAWP
C *** This draws to coordinates XDR,YDR [cm]  (with pen down)
 
      SAVE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /PL3/ IXMV,IYMV,IPCT
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
 
      IF(JDEV.NE.0) GO TO (11,11,13,13,15,16,17,18,19), JDEV
 
   11 CONTINUE
      IX = XDR
      IY = YDR
 
  111 CALL XLINE(IXMV,IYMV,IX,IY)
 
      IXMV = IX
      IYMV = IY
      RETURN
 
   13 CONTINUE
      IPCL = 0
      CALL HPPLT
  131 IX = IXPX(1) + INT(XDR) / FMOX
      IY = IYPX(1) + INT(YDR) / FMOX
      GO TO 111
 
   15 CONTINUE
      IPCL = 0
      CALL PPLT
      GO TO 131
 
   16 CONTINUE
      IPCL = 0
      CALL PSPLT
      GO TO 131
 
   17 CONTINUE
      IPCL = 0
      CALL WMFPLT
      GO TO 131
 
   18 CONTINUE
      RETURN
 
   19 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE SDOTP
C *** This sets a dot at position XDR, YDR [cm]
 
      SAVE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /PL3/ IXMV,IYMV,IPCT
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
 
      IF(JDEV.NE.0) GO TO (11,11,13,14,15,16,17,18,19), JDEV
 
   11 CONTINUE
      IX = XDR
      IY = YDR
 
  111 CALL XPOINT(IX,IY)
 
      RETURN
 
   13 CONTINUE
      RETURN
 
   14 CONTINUE
      IX = IXPX(1) + INT(XDR) / FMOX
      IY = IYPX(1) + INT(YDR) / FMOX
      GO TO 111
 
   15 CONTINUE
      RETURN
 
   16 CONTINUE
      RETURN
 
   17 CONTINUE
      RETURN
 
   18 CONTINUE
      RETURN
 
   19 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE NEWCOL
C *** This calls for a new colour with colour no. IPCL
 
      SAVE
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /PL3/ IXMV,IYMV,IPCT
 
      IF(JDEV.NE.0) GO TO (11,11,13,14,15,16,17,18,19), JDEV
 
   11 CONTINUE
 
  111 CALL XCOLOR(IPCL)
 
      RETURN
 
   13 CONTINUE
      CALL HPCLR
      CALL GRAJ(IPCL)
      GO TO 111
 
   14 CONTINUE
      RETURN
 
   15 CONTINUE
      CALL PCLR
      GO TO 111
 
   16 CONTINUE
      CALL PSCLR
      GO TO 111
 
   17 CONTINUE
      CALL WMFCLR
      GO TO 111
 
   18 CONTINUE
      RETURN
   19 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE GRAFTM(JT)
 
      SAVE
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /CRS/ ICRX,ICRY, ICX,ICY, JBGN,JTRM,JARM, LCRS
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
      COMMON /FCD/ NFCD,XR0(500),YR0(500),XR(500),YR(500),IAMR(500),NAFN
      COMMON /AUT/ JWKA,JKSA,JKSS,JCSR, JTX,NTXN,JWCD,NPMX, LSFF
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
 
      GO TO (10,20,30,40,50,60,70,80), JT
 
   10 CONTINUE
C *** This is called at the beginning of any set of graphics operations.
 
      JGFT = 1
      RETURN
 
   20 CONTINUE
C *** This is called at the end of any set of graphics operations.
 
      JGFT = 0
      RETURN
 
   30 CONTINUE
C *** This erases the Screen

c     write(6,*) '30'
 
      NTLY = 0
      NTLX = 0
      JPUL(4) = 0
      NFCD = 0
 
      IF(JDEV.GT.2) RETURN
 
      IF(JSRF.EQ.0) THEN
 
        CALL XCLR
 
      ELSE
        CALL SURFAC(19)
      ENDIF
      RETURN
 
   40 CONTINUE
C *** This defines a Colour of the Colour Map
 
      IF(JDEV.NE.0) GO TO (41,41,43,43,45,46,47,48,49), JDEV
 
   41 CONTINUE
C *** Used only here, to store the colour coordinates in APAL
c      IDUM = 3 * ICV(1)
c      APAL((IDUM+1):(IDUM+1)) = CHAR(ICV(2))
c      APAL((IDUM+2):(IDUM+2)) = CHAR(ICV(3))
c      APAL((IDUM+3):(IDUM+3)) = CHAR(ICV(4))
 
      CALL XSETCOLOR(ICV(1),ICV(2),ICV(3),ICV(4))
 
      RETURN
 
   43 CONTINUE
      RETURN
 
   45 CONTINUE
      CALL PPAL
      RETURN
 
   46 CONTINUE
      CALL PSPAL
      RETURN
 
   47 CONTINUE
      RETURN
 
   48 CONTINUE
      RETURN
   49 CONTINUE
      RETURN
 
   50 CONTINUE
C *** This sets a new background colour
 
      IF(JDEV.GT.2) RETURN
 
      CALL XSETCOLOR(0,ICV(2),ICV(3),ICV(4))
 
      IF(MOD(MCHN(5),1000).EQ.0) RETURN
 
      IF(ICV(1).LT.0) RETURN
      IF(JKSA.EQ.0) RETURN
 
      IX1 = IPIX(1) / 100000
      IX2 = MOD(IPIX(1),100000)
      IYA = IXYX(2) - MOD(IPIY(1),100000)
      IYB = IXYX(2) - IPIY(1) / 100000
      IY1 = MIN0(IYA,IYB)
      IY2 = MAX0(IYA,IYB)
 
      NTLY = 0
      NTLX = 0
      JPUL(4) = 0
 
      JFLL = 1
      IF(JSRF.LT.0) JFLL = 0
      CALL XCLAREA(IX1,IY1,IX2,IY2,0,JFLL)
 
      CALL TXTWDW(0)
      RETURN
 
   60 CONTINUE
C *** This sets the whole colour palette at once, including background
C     All colour coordiantes have to be stored in APAL, previously
 
      RETURN
 
   70 CONTINUE
C *** This determines the RGB components of colour no. ICV(1) of the
C     colour map, including col. no. 0 (background)
 
      IF(JDEV.NE.0) GO TO (71,71,73,73,75,76,77,78,79), JDEV
 
   71 CONTINUE
 
      CALL XGETCOLOR(ICV(1),ICV(2),ICV(3),ICV(4))
 
      RETURN
 
   73 CONTINUE
      RETURN
   75 CONTINUE
      RETURN
   76 CONTINUE
      RETURN
 
   77 CONTINUE
      GO TO 71
 
   78 CONTINUE
      RETURN
   79 CONTINUE
      RETURN
 
   80 CONTINUE
C *** This clears a rectangle XMV/YMV - XDR/YDR or fills it
C     with color IPCL
 
      IF(JDEV.GT.2) RETURN
 
      IX1 = XMV
      IY1 = IXYX(2) - INT(YMV)
      IX2 = XDR
      IY2 = IXYX(2) - INT(YDR)
 
      IY3 = IY1
      IY1 = IY2
      IY2 = IY3
 
      JFLL = 1
      IF(JSRF.LT.0) JFLL = 0
      CALL XCLAREA(IX1,IY1,IX2,IY2,IPCL,JFLL)
 
      RETURN
      END
 
 
      SUBROUTINE MOUSEP(JTT)
C *** call mouse/hardware cursor and get pixel coordinates ICRX, ICRY
C     set JRRR = 12 if left button has been pressed
C     set JRRR = 13 if right button has been pressed
C     set JRRR = 11 if both or central button(s) have been pressed
 
      SAVE
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /CRS/ ICRX,ICRY, ICX,ICY, JBGN,JTRM,JARM, LCRS
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
 
      JT = IABS(JTT)
      IF(JT.NE.0) GO TO 1
 
C *** This initializes the mouse
      IX1 = IXYX(1) / 100000
      IX2 = MOD(IXYX(1),100000)
      IY1 = IXYX(2) / 100000
      IY2 = MOD(IXYX(2),100000)
 
      RETURN
 
    1 GO TO (10,20,30,40,50,60), JT
 
C *** This switches the mouse cursor on
   10 CONTINUE
 
      IF(JXYC.NE.0 .OR. JANI.NE.0) RETURN
      CALL XCURON(ICRX,ICRY)
      CALL XCMOVE(ICRX,ICRY)
      CALL XCDRAW
 
      ICXL = ICRX
      ICYL = ICRY
 
      RETURN
 
C *** This switches the mouse cursor off
   20 CONTINUE
 
      IF(JXYC.NE.0 .OR. JANI.NE.0) RETURN
      CALL XCUROFF
      CALL XCMOVE(ICXL,ICYL)
      CALL XCDRAW
 
      RETURN
 
C *** This reads mouse coordinates and button presses
C     IKEY = 0/1/2: no/left/right button pressed
   30 CONTINUE
      JRRR = 0
 
      CALL XGETMSE(IKKK,IMXD,IMYD)
 
      ICRX = MAX0(IX1,MIN0(IMXD,IX2))
      ICRY = MAX0(IY1,MIN0(IMYD,IY2))
      IKEY = 0
      IF(IKKK.EQ.12) IKEY = 1
      IF(IKKK.EQ.13) IKEY = 2
      IF(IKKK.EQ.11) IKEY = 3
 
      IF(IKLS.NE.IKEY) THEN
        IF(IKEY.EQ.0) THEN
          IF(IKLS.EQ.1) JBGN = 12
          IF(IKLS.EQ.2) JBGN = 13
          JRRR = 0
        ELSE IF(IKEY.EQ.1) THEN
          JRRR = 12
          JBGN = 0
        ELSE IF(IKEY.EQ.2) THEN
          JRRR = 13
          JBGN = 0
        ENDIF
      ENDIF
 
      IKLS = IKEY
 
C *** This moves the mouse cursor to a new position
C     (may contain no code, as already done by system)
   40 CONTINUE
 
      IF(JXYC.NE.0 .OR. JANI.NE.0) RETURN
      IF(ICRX.EQ.ICXL .AND. ICRY.EQ.ICYL) RETURN
      CALL XCMOVE(ICXL,ICYL)
      CALL XCDRAW
      CALL XCMOVE(ICRX,ICRY)
      CALL XCDRAW
      ICXL = ICRX
      ICYL = ICRY
      RETURN
 
C *** This forces the mouse to a certain position
C     (may contain no code)
   50 CONTINUE
      CALL XMOVEMSE(ICRX,ICRY)
      RETURN
 
C *** This defines a new cursor shape
   60 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE RWLINE(JT)
C *** this gets single pixel-values or stores single pixel-values
      SAVE
 
      INCLUDE 'scom1.inc'
      CHARACTER*1  AP, APP, ARD, AGR, ABL
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      DATA JSRT /0/
 
      IF(JTB.EQ.1) RETURN
 
      IF(JT.LT.0) THEN
        IF(JSRT.EQ.1) THEN
          CALL XRLINE(-1,LXA,LXE,LYA,LYE,MY,AP)
        ELSE IF(JSRT.EQ.2) THEN
          CALL XWLINE(-1,LXA,LXE,LYA,LYE,MY,APP)
        ENDIF
        JSRT = 0
        RETURN
      ENDIF
 
      GO TO (10,20,30,40,50,60), JT
 
   10 CONTINUE
C *** This reads 8-bit values of line_of_pixel no. LY  from the graphics
C     system and stores it in the character string AP
 
      IF(JSRT.EQ.0 .AND. (MCHN(5)/1000).NE.0) CALL WAITSL(-.25)
 
      IY = LY
      MY = LY
 
      LXA = LXST + NXST - 1
      LXE = LXST + NXND - 1
      LYA = MIN0(LYST,LYND)
      LYE = MAX0(LYST,LYND)
      CALL XRLINE(JSRT,LXA,LXE,LYA,LYE,MY,AP)
 
      JSRT = 1
      RETURN
 
   20 CONTINUE
C *** This reads string APP and stores it as line_of_pixel no. IY in the
C     graphics system
 
      IF(JSRT.EQ.0 .AND. (MCHN(5)/1000).NE.0) CALL WAITSL(-.25)
 
      MY = IY
      JXDD = MIN0(LXND-LXST,JXND-JXST) + 1
 
      LXA = LXST + JXST - 1
      LXE = LXST + JXDD - 1
      LYA = MIN0(LYST,LYND)
      LYE = MAX0(LYST,LYND)
      CALL XWLINE(JSRT,LXA,LXE,LYA,LYE,MY,APP)
 
      JSRT = 2
      RETURN
 
   30 CONTINUE
C *** This appends the whole image to file NFB which is already opened.
C     If you install this, activate the line JRR = 1
C *** JRR = 1
      RETURN
 
   40 CONTINUE
C *** restores the whole image from file NFB which is already opened.
C     If you install this, activate the line JRR = 1
C *** JRR = 1
      RETURN
 
   50 CONTINUE
C *** This writes the whole screen image to file NFB (to be opened)
C *** JRR = 1
      RETURN
 
   60 CONTINUE
C *** restores the whole screen image from file NFB (to be opened)
C *** JRR = 1
      RETURN
      END
 
 
      SUBROUTINE STREST(JT)
C *** This saves and restores a part of the screen
      SAVE
 
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSE
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      DATA IBUF/0/, jwidsv/0/, jheisv/0/
 

 
C *** IYMX ist Hoehe des gesamten SCHAKAL-Grafikwindows in Pixeln
      IYMX = MOD(IXYX(2),100000)
 
      JTS = IABS(JT)
      IF(JTS.GT.9) GO TO 100
 
      GO TO(10,20,30), JT
 
C *** store image in whatever format
   10 CONTINUE
 
      CALL XCOPYAREA(0,0,IXYX(1),IXYX(2))
      IBUF = 1
 
      RETURN
 
C *** restore part of image
   20 CONTINUE
 
      LY1 = IYMX - LTXY(1)
      LY2 = IYMX - LTXY(2)
 
      IF(IBUF.GT.0) THEN
        CALL XRESTOREAREA(LTXX(1),LY1,LTXX(2),LY2)
      ENDIF
      RETURN
 
C *** erase part of image
   30 CONTINUE
 
      LY1 = IYMX - LTXY(1)
      LY2 = IYMX - LTXY(2)
 
      CALL XCLAREA(LTXX(1),LY1,LTXX(2),LY2,0,1)
      RETURN
 
  100 CONTINUE
C *** Initialisierung der Animation: Koordinaten des
C     Grafikfensters berechnen
      JTT = MOD(JTS,10)
      IF(JTT.NE.0) GO TO 101
 
C *** IXA1,2 IYA1,2 sind die Eck-Koordinaten des
C     Zeichnen-Bereichs innerhalb des SCHAKAL-Grafikwindows
 
      IXA1 = IPIX(LMON) / 100000
      IXA2 = MOD(IPIX(LMON),100000)
      IYA1 = IYMX - MOD(IPIY(LMON),1000000)
      IYA2 = IYMX - IPIY(LMON) / 1000000
 
      JWID = IXA2 - IXA1 + 1
      JHEI = IYA2 - IYA1 + 1

C     write(6,*) '100 JWID,JHEI =',jwid,jhei

      if(jwid.ne.jwidsv .or. jhei.ne.jheisv) 
     * call xresizedblbuffer(idum,jwid,jhei)

      jwidsv = jwid
      jheisv = jhei
      RETURN
 
  101 GO TO (110,120,130), JTT
 
  110 CONTINUE
C *** "Virtuellen Screen" aktivieren (danach muessen alle
C     folgenden Grafikoperationen dorthin geschrieben werden
      IDUM = XCREATEDBLBUFFER(4,JWID,JHEI)
      CALL XENABLEDBLBUFFER()
C     write(6,*) '110 JWID,JHEI =',jwid,jhei
      RETURN
 
  120 CONTINUE
C *** Kopieren des "virtuellen Screens" auf den Bildschirm
      IDUM = XCOPYDBLBUFFER(1,IXA1,IYA1,JWID,JHEI,
     *                             4,   0,   0,JWID,JHEI,SRCCOPY)
C     write(6,*) '120 IXA1,IYA1,JWID,JHEI =',IXA1,IYA1,jwid,jhei
      RETURN
 
  130 CONTINUE
C *** "Virtuellen Screen" deaktivieren (danach muessen alle
C     folgenden Grafikoperationen wieder auf den Bildschirm
C     geschrieben werden
      CALL XDISABLEDBLBUFFER()
      IDUM = XDELETEDBLBUFFER(4)
C     write(6,*) '130'
      RETURN
      END
 
 
      SUBROUTINE REFORM(JT)
C *** This sets new limits for hardware (pixel) coordinates of a (the)
C     screen device (JT = 0) or a new colour map (JT = 1)
 
      SAVE
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC2/ XMNG(9),XMXG(9),YMNG(9),YMXG(9),RSG(9),IRS(9),INIT(9)
      COMMON /MC3/ FXYG(9),FMON(9),IPRS,FCXY,FACX,XNLG(2), RSTG,XCXG
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /REF/ IX1,IX2,IY1,IY2,NCS,NCL
 
      IF(JT.NE.0) GO TO 1
 
      IPIX(LMON) = 100000 * IX1 + IX2
      IPIY(LMON) = 100000 * IY1 + IY2
      XMNG(LMON) = IX1 / FXYG(LMON)
      XMXG(LMON) = IX2 / FXYG(LMON)
      YMNG(LMON) = IY1 / FXYG(LMON)
      YMXG(LMON) = IY2 / FXYG(LMON)
      GO TO 5
 
    1 IF(NCL.EQ.0) NCL = 250 / NCS
      NCLR(LMON) = 1000 * NCS + NCL
      CALL GRAE(100,NCS,NCL)
 
    5 LDVV = LDEV
      LDEV = LMON
      CALL SETDEV
      IF(LDEV.NE.LDVV) THEN
        LDEV = LDVV
        CALL SETDEV
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE GRMODE(JT)
C *** This switches between textmode and graphics mode of the screen
 
      JTT = JT
      RETURN
      END
 
 
      SUBROUTINE TEXTWN
C *** This may be used to switch an I/O text window on and off via the
C     'PUSH' / 'PULL' command
C     JPUL(1) = 0 : switch text window on
C     JPUL(1) = 1 : switch text window off
C     JPUL(2) = 0 : text window opaque
C     JPUL(2) = 1 : text window transparent
 
      SAVE
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
 
      IF(JPUL(1).EQ.0) THEN
        CALL TXTWDW(1)
        IF(NINA.EQ.NEIN) JTSV = 1
        IF(JPUL(2).NE.0) CALL WINTXT(-1)
      ENDIF
 
      RETURN
      END
 
      SUBROUTINE TXON
      RETURN
      END
 
      SUBROUTINE TXOFF
      RETURN
      END
 
      SUBROUTINE TXSIZE
      RETURN
      END
 
      SUBROUTINE TXSTCL(JT)
      JTT = JT
      RETURN
      END
 
 
      SUBROUTINE WINFUN(JT)
      JTT = JT
      RETURN
      END
 
 
      SUBROUTINE WINFLE(IOPN)
      SAVE

      CHARACTER*6  ALBL, AFLB, ASTL
      CHARACTER*7  ADDV, AFLN(2)
      CHARACTER*10 ASUF, ASF2
      CHARACTER*31 AFLT(2)
      CHARACTER*80 ACPT
      CHARACTER*16 AVRS, AULN
      CHARACTER*20 AEST
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS, APTH, AEDI
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      CHARACTER*255 ACMD
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /WRT/ IWRA, IWRB, IWRC, IWRD, RWRA, RWRB
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /DMP/ DRAN,IRAN,IRAM,NDMP,NLVL,LL1,LL2,JTNQ,JDDM(3),LABL(2)
      COMMON /AEB/ AEST, AEDI
      COMMON /EBQ/ JCLO, IFNE, IE(24), JUXI
      common /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
      COMMON /X11/ JFSC, IXSC, IYSC

      IF(IOPN.LE.0) RETURN

      APTH = APRE(IOPN)
      DO 5  I = 80,1,-1
      IF(APTH(I:I).NE.' ') THEN
        IF(APTH(I:I).EQ.'/') APTH(I:I) = ' '
        GO TO 6
      ENDIF
    5 CONTINUE
    6 ipth = i

      AFLN(1) = ADDV(IOPN)
      DO 60  I = 1,164
      IF(AFIL(I:I).EQ.'*') GO TO 61
   60 CONTINUE
   61 DO 62  J = I,164
      IF(AFIL(J:J).EQ.'.') GO TO 63
   62 CONTINUE
   63 JEND = J - 1
      DO 64  J = I,1,-1
      IF(AFIL(J:J).EQ.'/' .or. AFIL(J:J).EQ.':') GO TO 65
   64 CONTINUE
   65 JANF = J + 1
      LENG = JEND - JANF + 1

      AFLT(1)(1:LENG) = AFIL(JANF:JEND)

      DO 70  I = 10,1,-1
      IF(ASUF(IOPN)(I:I).NE.' ') GO TO 71
   70 CONTINUE
   71 ISUF = I

      AFLT(1)(LENG+1:LENG+isuf) = ASUF(IOPN)

      AFLN(2) = 'Any    '
      AFLT(2) = '*.*'

      JEXS = 0
      NFLT = 2
      IF(LL1.NE.5) THEN
        IF(IOPN.EQ.1) THEN
          JEXS = 1
          IF(JUXI.NE.0) JEXS = 0
        ENDIF
        IF(IOPN.EQ.2) JEXS = 1
        IF(IOPN.EQ.4 .OR. IOPN.EQ.6 .OR. IOPN.EQ.8) JEXS = 1
      ENDIF
 
c      write(6,*) 'AFIL =', afil(1:40)
c      write(6,*) 'ACPT =', acpt
c      write(6,*) 'APTH =', apth
c      write(6,*) 'AFLN =', afln
c      write(6,*) 'AFLT =', aflt

      ACPT = ' '
      ACPT = APTH
      AFIL = ' '
      IWRA = -1

      JEXS = 0

      ACMD = ' '
      N = NSYS(1)
      ACMD(   1:N)    = ASYS(1)(1:N)
      ACMD(N+ 1:N+45) = 'fileprompt -out "sch99.fle" -exist 0 -fname "'
      IF(JEXS.NE.0) ACMD(N+36:N+36) = '1'
      N = N + 45
      ACMD(N+1:N+7) = addv(iopn)
      N = N + 7
      ACMD(N+1:N+10) = '" -fmask "'
      N = N + 10
      ACMD(N+1:N+LENG+ISUF) = AFLT(1)
      N = N+LENG+ISUF

      ACMD(N+1:N+8) = '" -dir "'
      N = N + 8
      ACMD(N+1:N+IPTH) = APTH(1:IPTH)
      N = N + IPTH
      ACMD(N:N) = '"'
      ACMD(N+1:N+8) = ' -width '
      N = N + 8
      IXFS = MAX0((IXSC / 3),300)
      WRITE(ACMD(N+1:N+4),9001) IXFS
 9001 FORMAT(I4)
      N = N + 4
      ACMD(N+1:N+9) =  ' -height '
      N = N + 9
      IYFS = MAX0((IYSC / 3), 200)
      WRITE(ACMD(N+1:N+4),9001) IYFS
      N = N + 4     

      CALL SYSTEM(ACMD)
      CALL KEYCHK(0)

      CLOSE(NFH)
      OPEN(NFH,FILE='sch99.fle')
      READ(NFH,9901) AFIL
 9901 FORMAT(A)
      CLOSE(NFH)

      CALL SURFIN(-1)
     
      IF(AFIL(1:2).EQ.'  ') AFIL(1:1) = 'n'

      IF(AFIL(1:2).EQ.'n ') THEN
        IF(JECO(3).GT.0) WRITE(NFE,8001)
 8001   FORMAT('n')
        GO TO 999
      ENDIF

      DO 8 I = 164,2,-1
      AFIL(I:I) = AFIL(I-1:I-1)
    8 CONTINUE
      AFIL(1:1) = ' '

      DO 80 I = 164,1,-1
      IF(AFIL(I:I).NE.' ') GO TO 81
   80 CONTINUE
   81 WRITE(NFLX,8000) AFIL(1:I)
      IF(JECO(3).GT.0) WRITE(NFE,8000) AFIL(1:I)
 8000 FORMAT(1X,A)

  999 CONTINUE
      RETURN
      END
 
      SUBROUTINE WINTXT(JT)
      JTT = JT
      RETURN
      END
 
 
      SUBROUTINE WINPRT(JT)
      JTT = JT
      RETURN
      END
