      SUBROUTINE SAVRES(JTU,JU)
      SAVE
 
C *** Program to save/restore a picture
C     JU  = 1 : lesen vom File
C         JT = 0 : opaque
C              1 : transparent
C
C     JU  = 2 : schreiben auf File
C         JT  = 0 : SIF-File   [TIF]
C               1 : SIF-File   [PCX]
C               2 : PCX-File   [SIF]
C               3 : TIF-File   [SIF]
 
      INCLUDE 'scom1.inc'
      CHARACTER*1  AP,APP, ARD,AGR,ABL, AN, A1,A2,AA,AQ,AH
      CHARACTER*4  AEXT
      CHARACTER*5  ADUM
      CHARACTER*6  ALBL, AFLB, ASTL
      CHARACTER*7  ADDV
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*76 AHDR
      CHARACTER*80 APRE, ASYS
      CHARACTER*80 WLIN, CLIN
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NY,NDIG,JEC,JRRR
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /DEC/ IBEG,JER,JNAB,JNBS,JAD,JNG,IANF,ISTP, JSI(3),PAR(3),
     *             IPPR(3),IKEY,LKEY(3),IPAR,JEXM
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /MAP/ NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /WRT/ IWRA, IWRB, IWRC, IWRD, RWRA, RWRB
      COMMON /LST/ JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2/ KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, JENE(2)
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /HSL/ JMDY, ICV1,ICV2,ICV3, ICW(3), ICV4
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
      COMMON /CON/ JBIN, JSPT, LYNN, LYB, JTPC, JFON, QPXM, QPTH
      COMMON /SMA/ JNPL,LDEW,LD5A, JPEP, XPSH(9),YPSH(9)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
      COMMON /FL2/ ILL1,ILL2,IROW,ICLM,ICLN,IDX,IDY,JFL1(16),JFL2(24),
     *             IPLS,IPL0,JTSF,JINL,TFRC
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
 
      JT = JTU
      IPPR(2) = XPSH(1)
      IPPR(3) = YPSH(1)
 
      IF(JU.EQ.1) THEN
        JT = JTU / 10
      ELSE IF(JU.EQ.2) THEN
        JTT = MOD(JT,10)
        JTS = JT / 10
        IF(JTT.EQ.0) JT = 3
        IF(JTT.EQ.1) JT = 2
        IF(JTT.EQ.2) JT = 0
        IF(JTT.EQ.3) JT = 1
        IF(JTT.GT.3) JT = 3
        IF(JT.GT.1 .AND. JTPC.NE.0 .AND. JTS.EQ.0) JT = 5 - JT
      ENDIF
 
      AN = CHAR(0)
 
      NCR = 0
      NREC = 0
      NEND = 0
      NRAL = 0
      NHUE = 13
      NRGB = 256
 
      CALL TIMCHK(0)
      ITM(2) = ITM(1)
 
      LXST = IPIX(LDEV) / 100000
      LXND = MOD(IPIX(LDEV),100000)
      NXST = 1
      NXND = LXND - LXST + 1
      NXMX = NXND + 1
 
      LYST = IPIY(LDEV) / 100000
      LYND = MOD(IPIY(LDEV),100000)
      IF(MCHN(2).NE.0) THEN
        IDUM = LYST
        LYST = IXYX(2) - LYND
        LYND = IXYX(2) - IDUM
      ENDIF
 
      NSHF(1) = JREN(2) * NXND
      NSHF(2) = JREN(3) * (LYND - LYST + 1)
      KXST = NXST + NSHF(1) - 1
      KXND = NXND + NSHF(1) - 1
      KYST = LYST + NSHF(2)
      KYND = LYND + NSHF(2)
 
      MXND = KXND + 1
      JRR = 0
 
      CALL WINFUN(-2)
 
      IF(JU.GT.1) GO TO 20
 
C ***
C *** Read from file
C ***
 
      CALL RWLINE(6)
      IF(JRR.NE.0) GO TO 990
 
      NCLA = NCLR(LMON)
 
      JSPT = 0
      IF(JBIN.EQ.0) THEN
        READ(NFB,REC=1,ERR=995) AQ
      ELSE
        READ(NFB) (AQ(I),I=1,5)
      ENDIF
      WRITE(ADUM,8001) (AQ(I),I=1,5)
 8001 FORMAT(5A1)
 
      IF(ADUM(1:4).EQ.'SCH9')                      JSPT = 1
      IF(AQ(1).EQ.CHAR(10) .AND. ICHAR(AQ(2)).LE.5
     *  .AND. AQ(4).EQ.CHAR(8))                    JSPT = 2
      IF(ADUM(1:2).EQ.'MM' .AND. ADUM(4:4).EQ.'*') JSPT = 3
      IF(ADUM(1:5).EQ.'ERROR') GO TO 995
      IF(JSPT.EQ.0) GO TO 998
 
      AEXT = '.sif'
      IF(JSPT.EQ.2) AEXT = '.pcx'
      IF(JSPT.EQ.3) AEXT = 'TIFF'
 
      JUPD = 0
      IF(JSPT.GT.1) JUPD = 1
      IF(MCHN(2).NE.0) JUPD = 1 - JUPD
      IF(JEXM.NE.0) JUPD = 1 - JUPD
 
C *** Read Header
      IF(JSPT.EQ.1) THEN
        CALL RWSIF(11)
      ELSE IF(JSPT.EQ.2) THEN
        CALL RWPCX(11)
      ELSE IF(JSPT.EQ.3) THEN
        CALL RWTIF(11)
      ENDIF
      JXST = 1
      JXND = IXND - IXST + 1
      JXMX = JXND + 1
 
      QPXX = FLOAT(IXND - IXST + 1) / FLOAT(LXND - LXST + 1)
      QPXY = FLOAT(IYND - IYST + 1) / FLOAT(LYND - LYST + 1)
      QPXM = AMAX1(QPXX,QPXY)
      QPTH = 1.0000
      IF(ABS(QPXM - FLOAT(INT(QPXM))).LT..00001) QPTH = .99999
 
      JENE(1) = 0
      IF(JREN(1).EQ.0) THEN
        IF(QPXM.GT.1.) JENE(1) = 1
      ELSE
        IF(QPXX.GT.1.) JENE(1) = -1
      ENDIF
 
      IF(JSRF.EQ.0) THEN
        CALL WROUT(-1)
         WRITE(WLIN,9000) JXND,IYND-IYST+1,AEXT
 9000   FORMAT(' A',I6,' x',I6,1X,A,' file is loaded!)')
        CALL WROUT(0)
        CALL WAITSL(1.)
      ELSE
        IF(JANI.EQ.0) THEN
          WRITE(WLIN,9001) AEXT,JXND,IYND-IYST+1
 9001     FORMAT(1X,A,':',I6,' x',I6)
          CALL SFINTA(41)
        ENDIF
      ENDIF
      CALL TXTWDW(1)
 
C *** Read RGB values
      IF(JSPT.EQ.1) THEN
        CALL RWSIF(12)
      ELSE IF(JSPT.EQ.3) THEN
        CALL RWTIF(12)
      ENDIF
 
C *** Read Pixel values
      JRR = 0
      CALL RWLINE(4)
      IF(JRR.NE.0) GO TO 18
 
      IF(JUPD.EQ.0) THEN
        LDIM = 0
        LSIG = - 1
      ELSE
        LDIM = - ((IYND - IYST) - (LYND - LYST))
        LSIG = 1
      ENDIF
 
      LYA = LYST
      LYB = LYST + IYND - IYST
 
      LYDT = LYB - LYA + 1
      LYD1 = LYDT / 20
      LYD2 = LYD1 - 1
      IF(JANI.EQ.0) CALL SFINTA(-31)
 
      DO 10 LYS = LYA,LYB
      LY = LYS
      IF(MOD(LYS,5).EQ.0) THEN
        CALL KEYCHK(0)
        IF(JRRR.NE.0) GO TO 18
      ENDIF
      LFRC = LY - LYA
      IF(MOD(LFRC,LYD1).EQ.LYD2) THEN
        IF(JANI.EQ.0) THEN
          TFRC = FLOAT(LFRC) / FLOAT(LYDT)
          CALL SFINTA(38)
        ENDIF
        CALL WINFUN(1)
        IF(JRRR.NE.0) GO TO 18
      ENDIF
 
      JSPR = 0
 
      IF(JSPT.EQ.1) THEN
        CALL RWSIF(13)
      ELSE IF(JSPT.EQ.2) THEN
        CALL RWPCX(13)
      ELSE IF(JSPT.EQ.3) THEN
        CALL RWTIF(13)
      ENDIF
 
      IF(JRRR.GT.0) GO TO 18
      IF(JRRR.LT.0) GO TO 998
 
      IF(JUPD.NE.0) LY = LYB + LYA - LY
 
C *** APP now contains the depacked line of pixels, received from file
C     Shift operations are applied (if any)
 
      IF(IPPR(3).NE.0) LY = LY + IPPR(3)
 
      IF(JENE(1).GT.0) THEN
        LSPR = 0
        IF(AMOD(FLOAT(LYS),QPXM).GT.QPTH) LSPR = 1
        IF(LSPR.NE.0) LDIM = LDIM + 1
        LY = LY + LSIG * LDIM
        IF(LSPR.NE.0) GO TO 10
      ENDIF
 
      IF(IPPR(2).NE.0) THEN
        JXDD = MIN0(3200,JXND)
        IF(IPPR(2).GT.0) THEN
          DO 12  LL = JXDD,JXST,-1
          LLL = LL - IPPR(2)
          IF(LLL.GT.0) THEN
            APP(LL) = APP(LLL)
          ELSE
            APP(LL) = CHAR(0)
          ENDIF
   12     CONTINUE
        ELSE
          DO 13  LL = JXST,JXDD
          LLL = LL - IPPR(2)
          IF(LLL.LE.NXND) THEN
            APP(LL) = APP(LLL)
          ELSE
            APP(LL) = CHAR(0)
          ENDIF
   13     CONTINUE
        ENDIF
      ENDIF
 
      IF(LY.LT.KYST .OR. LY.GT.KYND) GO TO 10
 
      IF(JENE(1).LT.0) THEN
        IF(JENE(2).LT.NXND) THEN
          DO 15  NX = JENE(2)+1,NXND
          APP(NX) = AN
   15     CONTINUE
        ENDIF
      ENDIF
 
      IF(JT.EQ.0) GO TO 17
 
      CALL RWLINE(1)
C *** AP now contains the depacked line of pixels, received from system
C *** It is now "mixed" with APP
 
      DO 16 NX = NXST,NXND
      IF(APP(NX).EQ.AN) APP(NX) = AP(NX)
   16 CONTINUE
 
C *** APP is now written into graphics memory (1 line of pixels)
 
   17 IY = LY - NSHF(2)
      CALL RWLINE(2)
   10 CONTINUE
 
      IF(JSPT.EQ.2) CALL RWPCX(12)
 
   18 CALL TXTWDW(0)
      NCLB = 1000 * NFST + NFRB
      IF(NCLA.NE.NCLB) THEN
        NCLR(LMON) = NCLB
        NPLM = ISIGN(NCLB,NPLM)
        IF(JSRF.NE.0) CALL SURFIN(1)
        IWRA = NFST
        IWRB = NFRB
        CALL WRITS(324)
      ENDIF
      GO TO 990
 
C ***
C *** Write to File
C ***
 
   20 CONTINUE
      CALL RWLINE(5)
      IF(JRR.NE.0) GO TO 990
      CALL TXTWDW(1)
 
      JUPD = 0
      IF(JT.GT.1) JUPD = 1
      IF(MCHN(2).NE.0) JUPD = 1 - JUPD
      IF(JEXM.NE.0) JUPD = 1 - JUPD
 
      JSOP = 0
      IF(JT.EQ.1) JSOP = 1
 
C *** Write Header
      IF(JT.LT.2) THEN
        CALL RWSIF(21)
      ELSE IF(JT.EQ.2) THEN
        CALL RWPCX(21)
      ELSE IF(JT.EQ.3) THEN
        CALL RWTIF(21)
      ENDIF
 
C *** Write RGB values
      IF(JT.LT.2) THEN
        CALL RWSIF(22)
      ELSE IF(JT.EQ.3) THEN
        CALL RWTIF(22)
      ENDIF
 
C *** Write Pixel values (lines)
      JRR = 0
      CALL RWLINE(3)
      IF(JRR.NE.0) GO TO 910
 
      IF(JUPD.EQ.0) THEN
        LYA = LYST
        LYB = LYND
        LYI = 1
      ELSE
        LYA = LYND
        LYB = LYST
        LYI = -1
      ENDIF
      LYNN = 0
 
      LYDT = IABS(LYB - LYA) + 1
      LYD1 = LYDT / 10
      LYD2 = LYD1 - 1
      IF(JANI.EQ.0) CALL SFINTA(31)
 
      DO 22  LY = LYA,LYB,LYI
      IF(MOD(LY,5).EQ.0) THEN
        CALL KEYCHK(0)
        IF(JRRR.NE.0) GO TO 920
      ENDIF
      LFRC = IABS(LY - LYA)
      IF(MOD(LFRC,LYD1).EQ.1) THEN
        IF(JANI.EQ.0) THEN
          TFRC = FLOAT(LFRC) / FLOAT(LYDT)
          CALL SFINTA(38)
        ENDIF
        CALL WINFUN(1)
        IF(JRRR.NE.0) GO TO 920
      ENDIF
 
      CALL RWLINE(1)
      LYNN = LYNN + 1
      IF(JT.LT.2) THEN
        CALL RWSIF(23)
      ELSE IF(JT.EQ.2) THEN
        CALL RWPCX(23)
      ELSE IF(JT.EQ.3) THEN
        CALL RWTIF(23)
      ENDIF
      IF(JRR.NE.0) GO TO 999
   22 CONTINUE
 
C *** Finals
      IF(JT.LT.2) THEN
        CALL RWSIF(24)
      ELSE IF(JT.EQ.2) THEN
        CALL RWPCX(22)
      ELSE IF(JT.EQ.3) THEN
        CALL RWTIF(24)
      ENDIF
 
  910 IF(JRRR.NE.0) GO TO 997
      GO TO 990
 
  920 CONTINUE
      AQ(1) = 'E'
      AQ(2) = 'R'
      AQ(3) = 'R'
      AQ(4) = 'O'
      AQ(5) = 'R'
      IF(JT.LT.4) THEN
        WRITE(NFB,REC=1) AQ
      ELSE
        REWIND NFB
        WRITE(NFB,9020) AQ
 9020   FORMAT(1024A1)
        ENDFILE NFB
      ENDIF
 
  990 CALL TIMCHK(0)
      DTM = FLOAT(ITM(1) - ITM(2)) / 1000.
      RWRA = DTM
      CALL WRITS(201)
      GO TO 999
 
  995 WRITE(WLIN,9095)
 9095 FORMAT(' Incomplete File !! -- will not be restored')
      CALL WROUT(0)
      GO TO 999
 
  997 WRITE(WLIN,9097) LY
 9097 FORMAT(' Only ',I3,' pixel lines stored on file !')
      CALL WROUT(0)
      GO TO 999
 
  998 WRITE(WLIN,9098)
 9098 FORMAT(' READ ERROR !! Picture cannot be restored !')
      CALL WROUT(0)
 
  999 IF((MCHN(1)/10).EQ.1) CALL RWLINE(-1)
      IF(JANI.EQ.0) CALL SFINTA(39)
      CALL WINFUN(2)
      RETURN
      END
 
 
      SUBROUTINE UNFMOP
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, AH
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
 
      NCR = NCR + 1
      AQ(NCR) = AA
      IF(NCR.EQ.1024) THEN
        NREC = NREC + 1
        WRITE(NFB,REC=NREC) AQ
        NCR = 0
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE UNFMIN
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, AH
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
 
      IF(NCR.EQ.0) THEN
        NREC = NREC + 1
        READ(NFB,REC=NREC) AQ
      ENDIF
      NCR = NCR + 1
      AA = AQ(NCR)
      IF(NCR.EQ.1024) NCR = 0
 
      RETURN
      END
 
 
      SUBROUTINE UNFMN1
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, AH
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
 
      NREC = 1 + NCR / 1024
      IF(NREC.NE.NRAL) READ(NFB,REC=NREC) AQ
      AA = AQ(1+MOD(NCR,1024))
      NCR = NCR + 1
      NRAL = NREC
 
      RETURN
      END
 
 
      SUBROUTINE UNFMN2(IDUM)
      SAVE
 
      CHARACTER*1 A1,A2,AA, AQ, AH
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
 
      NCR1 = 1 + MOD(NCR,1024)
      NREC = 1 + NCR / 1024
      IF(NREC.NE.NRAL) READ(NFB,REC=NREC) AQ
      IDUM = 256 * ICHAR(AQ(NCR1)) + ICHAR(AQ(NCR1+1))
      NCR = NCR + 2
      NRAL = NREC
 
      RETURN
      END
 
 
      SUBROUTINE MCHARC(JT,IDUM)
      SAVE
 
      CHARACTER*1 A1,A2,AA,AQ, AH
      CHARACTER*76 AHDR
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
 
      IF(JT.EQ.0) THEN
        A1 = CHAR(IDUM/256)
        A2 = CHAR(MOD(IDUM,256))
      ELSE
        IDUM = 256 * ICHAR(A1) + ICHAR(A2)
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE PCKUNP(JT)
      SAVE
 
      CHARACTER*1  AP, APP, ARD, AGR, ABL, AX, AY, AZ
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2/ KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, JENE(2)
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /CON/ JBIN, JSPT, LYNN, LYB, JTPC, JFON, QPXM, QPTH
 
      AY = CHAR(254)
      AZ = CHAR(255)
 
      JRR = 0
      N = 0
 
      IF(JT.NE.0) GO TO 2
 
      NJ = 0
      AX = AZ
 
      DO 150  NX = NXST,NXMX
      IF(NX.EQ.NXMX) GO TO 151
      IF(AP(NX).EQ.AZ .OR. AP(NX).EQ.AY) GO TO 99
      IF(AP(NX).NE.AX) GO TO 151
      N = N + 1
      GO TO 150
 
  151 IF(N.EQ.0) GO TO 152
      IF(N.GT.3) GO TO 153
 
      DO 160, J = 1,N
      NJ = NJ + 1
      APP(NJ) = AX
  160 CONTINUE
      GO TO 155
 
  153 NJ = NJ + 1
      IF(N.GT.63) GO TO 154
      APP(NJ) = AZ
      NJ = NJ + 1
      APP(NJ) = CHAR(N)
      GO TO 155
  154 NN = N / 64
      APP(NJ) = AY
      NJ = NJ + 1
      APP(NJ) = CHAR(NN)
      NJ = NJ + 1
      APP(NJ) = CHAR(N - 64 * NN)
  155 N = 0
  152 IF(NX.EQ.NXMX) RETURN
      NJ = NJ + 1
      APP(NJ) = AP(NX)
      AX = AP(NX)
  150 CONTINUE
      RETURN
 
    2 LPP = 0
 
      DO 25  J = 1,NJ
 
      IF(J.EQ.1) GO TO 21
      IF(AP(J-1).EQ.AZ .OR. AP(J-1).EQ.AY) GO TO 25
 
      IF(J.EQ.2) GO TO 21
      IF(AP(J-2).EQ.AY) GO TO 25
 
   21 IF(AP(J).EQ.AZ .OR. AP(J).EQ.AY) GO TO 26
 
      N = N + 1
      IF(N.GT.JXND) GO TO 98
 
      IF(JENE(1).EQ.0) THEN
        APP(N) = AP(J)
      ELSE IF(JENE(1).GT.0) THEN
        IF(AMOD(FLOAT(N),QPXM).GT.QPTH) LPP = LPP + 1
        NPSS = N - LPP
        IF(NPSS.GT.0) APP(NPSS) = AP(J)
      ELSE
        IF(N.LT.KXST) GO TO 24
        IF(N.GE.MXND) GO TO 24
        NPSS = N - NSHF(1)
        IF(NPSS.GT.0) APP(NPSS) = AP(J)
      ENDIF
 
   24 AX = AP(J)
      GO TO 25
 
   26 NN = ICHAR(AP(J+1))
      IF(AP(J).EQ.AY) NN = 64 * NN + ICHAR(AP(J+2))
 
      DO 250 K = 1,NN
      N = N + 1
 
      IF(JENE(1).EQ.0) THEN
        APP(N) = AX
      ELSE IF(JENE(1).GT.0) THEN
        IF(AMOD(FLOAT(N),QPXM).GT.QPTH) LPP = LPP + 1
        NPSS = N - LPP
        IF(NPSS.GT.0) APP(NPSS) = AX
      ELSE
        IF(N.LT.KXST) GO TO 250
        IF(N.GE.MXND) GO TO 250
        NPSS = N - NSHF(1)
        IF(NPSS.GT.0) APP(NPSS) = AX
      ENDIF
 
  250 CONTINUE
   25 CONTINUE
 
      JENE(2) = NPSS
      RETURN
 
   98 JRR = -1
      RETURN
   99 JRR = 1
      RETURN
      END
 
 
      SUBROUTINE SLPCX(JT)
      SAVE
      JTT = JT
      RETURN
      END
 
 
      SUBROUTINE HEADER(JT)
      SAVE
 
      CHARACTER*1  A1,A2,AA, AQ, AH
      CHARACTER*5  AS99
      CHARACTER*76 AHDR
      COMMON /MAP/ NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /LST/ JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2/ KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, JENE(2)
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /HSL/ JMDY, ICV1,ICV2,ICV3, ICW(3), ICV4
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      DATA AS99/'SCH99'/
 
      IF(JT.NE.0) GO TO 100
C *** Read Header
 
      IF(AHDR(1:4).NE.'SCH9') GO TO 991
 
      IF(AHDR(6:6).EQ.'P') JSOP = 1
      A1 = AHDR(7:7)
      A2 = AHDR(8:8)
      CALL MCHARC(1,IDUM)
      IXST = IDUM
      A1 = AHDR(9:9)
      A2 = AHDR(10:10)
      CALL MCHARC(1,IDUM)
      IXND = IDUM
      A1 = AHDR(11:11)
      A2 = AHDR(12:12)
      CALL MCHARC(1,IDUM)
      IYST = IDUM
      A1 = AHDR(13:13)
      A2 = AHDR(14:14)
      CALL MCHARC(1,IDUM)
      IYND = IDUM
      NFST = ICHAR(AHDR(15:15))
      IF(NFST.EQ.0) NFST = 19
      NFS  = NFST
      FST  = NFST + 1
      NFRB = ICHAR(AHDR(16:16))
      IF(NFRB.EQ.0) NFRB = 13
      A1 = AHDR(17:17)
      A2 = AHDR(18:18)
      CALL MCHARC(1,IDUM)
      JDUM = IDUM
      A1 = AHDR(19:19)
      A2 = AHDR(20:20)
      CALL MCHARC(1,IDUM)
      KDUM = IDUM
      IDUM = MOD(IDUM,1000)
      LBCK(6) = 1000 * JDUM + IDUM
      IF(KDUM.GT.999) LBCK(6) = - LBCK(6)
      A1 = AHDR(22:22)
      A2 = AHDR(23:23)
      CALL MCHARC(1,IDUM)
      NRGB = IDUM
      NHUE = ICHAR(AHDR(24:24))
      NHU3 = 3 * NHUE
 
      IDUM = ICHAR(AHDR(25:25))
      JDUM = ICHAR(AHDR(26:26))
      KDUM = ICHAR(AHDR(27:27))
      LDUM = ICHAR(AHDR(28:28))
      JMDY = 0
      IF(MAX0(IDUM,JDUM,KDUM,LDUM).EQ.0) GO TO 11
      ICV1 = IDUM
      ICV2 = JDUM
      ICV3 = KDUM
      ICV4 = LDUM
      JMDY = 1
 
   11 IDUM = ICHAR(AHDR(31:31))
      JDUM = ICHAR(AHDR(32:32))
      IF(IDUM.EQ.0 .AND. JDUM.EQ.0) GO TO 12
      LBCK(1) = 1
      LBCK(3) = 1000 * JDUM + IDUM
 
   12 CONTINUE
      A1 = AHDR(33:33)
      A2 = AHDR(34:34)
      CALL MCHARC(1,IDUM)
      JDUM = IDUM
      KDUM = ICHAR(AHDR(35:35))
      IDUM = ICHAR(AHDR(36:36))
      LBCK(2) = JDUM + 1000000 * KDUM + 1000 * IDUM
 
      NPOS = 36
 
      DO 20 LY = 1,NHUE
      KDUM = 3 * (LY-1)
      NPOS = NPOS + 1
      A1 = AHDR(NPOS:NPOS)
      NPOS = NPOS + 1
      A2 = AHDR(NPOS:NPOS)
      CALL MCHARC(1,IDUM)
      IHUE(LY) = IDUM
      NPOS = NPOS + 1
      ISAT(LY) = ICHAR(AHDR(NPOS:NPOS))
   20 CONTINUE
 
      RETURN
 
  991 JRRR = 1
      RETURN
 
C *** Write Header
  100 CONTINUE
 
      AHDR( 1: 5) = AS99
      AHDR(76:76) = CHAR(0)
 
      AHDR( 6: 6) = 'S'
      IF(JSOP.NE.0) AHDR( 6: 6) = 'P'
 
      IDUM = LXST
      CALL MCHARC(0,IDUM)
      AHDR( 7: 7) = A1
      AHDR( 8: 8) = A2
      IDUM = LXND
      CALL MCHARC(0,IDUM)
      AHDR( 9: 9) = A1
      AHDR(10:10) = A2
      IDUM = LYST
      CALL MCHARC(0,IDUM)
      AHDR(11:11) = A1
      AHDR(12:12) = A2
      IDUM = LYND
      CALL MCHARC(0,IDUM)
      AHDR(13:13) = A1
      AHDR(14:14) = A2
      AHDR(15:15) = CHAR(NFST)
      AHDR(16:16) = CHAR(NFRB)
 
      IDUM = IABS(LBCK(6)) / 1000
      CALL MCHARC(0,IDUM)
      AHDR(17:17) = A1
      AHDR(18:18) = A2
 
      IDUM = MOD(IABS(LBCK(6)),1000)
      IF(LBCK(6).LT.0) IDUM = IDUM + 1000
      CALL MCHARC(0,IDUM)
      AHDR(19:19) = A1
      AHDR(20:20) = A2
 
      AHDR(21:21) = CHAR(0)
 
      IDUM = NRGB
      CALL MCHARC(0,IDUM)
      AHDR(22:22) = A1
      AHDR(23:23) = A2
 
      IDUM = NHUE
      AHDR(24:24) = CHAR(IDUM)
 
      DO 105  I = 25,32
      AHDR( I: I) = CHAR(0)
  105 CONTINUE
 
      IF(JMDY.EQ.0) GO TO 106
      AHDR(25:25) = CHAR(ICV1)
      AHDR(26:26) = CHAR(ICV2)
      AHDR(27:27) = CHAR(ICV3)
      AHDR(28:28) = CHAR(ICV4)
 
  106 IF(LBCK(1).EQ.0) GO TO 107
      AHDR(31:31) = CHAR(MOD(LBCK(3),1000))
      AHDR(32:32) = CHAR(LBCK(3) / 1000)
 
  107 IDUM = MOD(IABS(LBCK(2)),1000)
      CALL MCHARC(0,IDUM)
      AHDR(33:33) = A1
      AHDR(34:34) = A2
      IDUM = IABS(LBCK(2)) / 1000000
      AHDR(35:35) = CHAR(IDUM)
      IDUM = MOD(IABS(LBCK(2)),1000000) / 1000
      AHDR(36:36) = CHAR(IDUM)
 
      NCHR = 36
 
      DO 110 LY = 1,NHUE
      IDUM = IHUE(LY)
      CALL MCHARC(0,IDUM)
      NCHR = NCHR + 1
      AHDR(NCHR:NCHR) = A1
      NCHR = NCHR + 1
      AHDR(NCHR:NCHR) = A2
      IDUM = ISAT(LY)
      NCHR = NCHR + 1
      AHDR(NCHR:NCHR) = CHAR(IDUM)
  110 CONTINUE
 
      RETURN
      END
 
 
      SUBROUTINE RWSIF(JT)
      SAVE
 
      CHARACTER*1  AP,APP, ARD,AGR,ABL, A1,A2,AA,AQ, AH
      CHARACTER*76 AHDR
      CHARACTER*80 WLIN, CLIN
      COMMON /WLI/ WLIN, CLIN
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /DEC/ IBEG,JER,JNAB,JNBS,JAD,JNG,IANF,ISTP, JSI(3),PAR(3),
     *             IPPR(3),IKEY,LKEY(3),IPAR,JEXM
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /MAP/ NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /WRT/ IWRA, IWRB, IWRC, IWRD, RWRA, RWRB
      COMMON /LST/ JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2/ KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, JENE(2)
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /HSL/ JMDY, ICV1,ICV2,ICV3, ICW(3), ICV4
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /CON/ JBIN, JSPT, LYNN, LYB, JTPC, JFON, QPXM, QPTH
 
      JU = IABS(JT) / 10
      JTT = MOD(IABS(JT),10)
 
      IF(JU.GT.1) GO TO 100
 
C *** Read from file
      GO TO (10,20,30,40), JTT
 
C *** Read Header
   10 CONTINUE
      NCHR = 0
 
      IF(JBIN.EQ.0) THEN
        DO  12  I = 1,75
        CALL UNFMIN
        AHDR(I:I) = AA
   12   CONTINUE
      ELSE
        REWIND NFB
        READ(NFB) (AHDR(I:I),I=1,75)
      ENDIF
      CALL HEADER(0)
      RETURN
 
C *** Read RGB values
   20 CONTINUE
      DO 25  LY = 1,NRGB
      ICV(1) = LY - 1
      IF(JBIN.EQ.0) THEN
        CALL UNFMIN
        ARD(LY) = AA
        CALL UNFMIN
        AGR(LY) = AA
        CALL UNFMIN
        ABL(LY) = AA
      ELSE
        READ(NFB) ARD(LY),AGR(LY),ABL(LY)
      ENDIF
      ICV(2) = ICHAR(ARD(LY))
      ICV(3) = ICHAR(AGR(LY))
      ICV(4) = ICHAR(ABL(LY))
 
C *** Write RGB values into graphics memory
      CALL GRAFTM(4)
      IF(LY.NE.1) GO TO 25
      LBCK(5) = (ICV(2) + ICV(3) + ICV(4)) / 3
   25 CONTINUE
      CALL GRAFTM(6)
 
      RETURN
 
C *** Read pixel values
   30 CONTINUE
 
      IF(JSOP.EQ.0) THEN
        IF(JBIN.EQ.0) THEN
          CALL UNFMIN
          NJ = ICHAR(AA)
          CALL UNFMIN
          NJ = NJ + 256 * ICHAR(AA)
          DO 32  J = 1,NJ
          CALL UNFMIN
          AP(J) = AA
   32     CONTINUE
        ELSE
          READ(NFB) A1, A2
          NJ = ICHAR(A1) + 256 * ICHAR(A2)
          READ(NFB) (AP(J),J=1,NJ)
        ENDIF
C ***   Depack AP into APP
        CALL PCKUNP(1)
        IF(JRR.NE.0) THEN
          IF(JRR.LT.0) GO TO 39
          GO TO 38
        ENDIF
      ELSE
        IF(JBIN.EQ.0) THEN
          DO 34  J = JXST,JXND
          CALL UNFMIN
          APP(J) = AA
   34     CONTINUE
        ELSE
          READ(NFB) (APP(J),J=JXST,JXND)
        ENDIF
      ENDIF
      RETURN
 
   38 JRRR = -1
      RETURN
   39 JRRR = 1
      RETURN
 
   40 CONTINUE
      RETURN
 
C *** Write to file
  100 GO TO (110,120,130,140) JTT
 
C *** Write Header
  110 CONTINUE
 
      CALL HEADER(1)
      DO 112  I = 1,75
      AP(I) = AHDR(I:I)
  112 CONTINUE
 
      RETURN
 
C *** Write RGB values
  120 CONTINUE
 
      DO 125  LY = 1,NRGB
      ICV(1) = LY - 1
      CALL GRAFTM(7)
      ARD(LY) = CHAR(ICV(2))
      NCHR = NCHR + 1
      AP(NCHR) = ARD(LY)
      AGR(LY) = CHAR(ICV(3))
      NCHR = NCHR + 1
      AP(NCHR) = AGR(LY)
      ABL(LY) = CHAR(ICV(4))
      NCHR = NCHR + 1
      AP(NCHR) = ABL(LY)
  125 CONTINUE
 
      IF(JBIN.EQ.0) THEN
        DO 127  I = 1,NCHR
        AA = AP(I)
        CALL UNFMOP
  127   CONTINUE
      ELSE
        WRITE(NFB) (AP(J),J=1,NCHR)
      ENDIF
      RETURN
 
C *** Write Pixel line
  130 CONTINUE
 
      IF(JSOP.EQ.0) THEN
        CALL PCKUNP(0)
        IF(JRR.NE.0) GO TO 996
C ***   Write packed line into file
 
        LB2 = NJ / 256
        LB1 = NJ - 256 * LB2
        AP(1) = CHAR(LB1)
        AP(2) = CHAR(LB2)
        DO 131  N = 1,NJ
        AP(N+2) = APP(N)
  131   CONTINUE
        NCHR = NJ + 2
      ELSE
C ***   Write non-packed line into file
        NCHR = NXND - NXST + 1
      ENDIF
 
      IF(JBIN.EQ.0) THEN
        DO 132  I = 1,NCHR
        AA = AP(I)
        CALL UNFMOP
  132   CONTINUE
      ELSE
        WRITE(NFB) (AP(J),J=1,NCHR)
      ENDIF
 
      RETURN
 
C *** Write last record
  140 CONTINUE
      IF(JBIN.NE.0) RETURN
 
      DO 145  I = NCR+1,1023
      AQ(I) = CHAR(0)
  145 CONTINUE
 
      NCR = 1023
      AA = CHAR(0)
      CALL UNFMOP
 
      RETURN
 
  996 WRITE(WLIN,9099)
 9099 FORMAT(' Colour > 253 detected; picture cannot be packed !')
      CALL WROUT(0)
 
      END
 
 
      SUBROUTINE RWPCX(JT)
      SAVE
 
      CHARACTER*1  AP,APP, ARD,AGR,ABL, A1,A2,AA,AQ, AH
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2/ KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, JENE(2)
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
      COMMON /CON/ JBIN, JSPT, LYNN, LYB, JTPC, JFON, QPXM, QPTH
      COMMON /LST/ JJ, IG, IPSH,IFAC,LBCK(6)
 
      JU = IABS(JT) / 10
      JTT = MOD(IABS(JT),10)
      IF(JU.EQ.2) GO TO 100
 
      GO TO (10,20,30,40), JTT
C *** Read Header
   10 CONTINUE
      IF(JBIN.EQ.0) THEN
        NCR = 0
        DO 11  I = 1,12
        CALL UNFMIN
        AP(I) = AA
   11   CONTINUE
      ELSE
        REWIND NFB
        READ(NFB) (AP(J),J=1,12)
      ENDIF
 
      A2 = AP(5)
      A1 = AP(6)
      CALL MCHARC(1,IXST)
      A2 = AP(7)
      A1 = AP(8)
      CALL MCHARC(1,IYST)
      A2 = AP(9)
      A1 = AP(10)
      CALL MCHARC(1,IXND)
      A2 = AP(11)
      A1 = AP(12)
      CALL MCHARC(1,IYND)
 
      IF(JBIN.EQ.0) THEN
        DO 14  I = 13,128
        CALL UNFMIN
   14   CONTINUE
      ELSE
        READ(NFB) (AP(J),J=13,128)
      ENDIF
 
      RETURN
 
C *** Read Palette
   20 CONTINUE
      IF(JBIN.EQ.0) THEN
        DO 210  I = 1,100000
        CALL UNFMIN
        IF(AA.EQ.CHAR(12)) GO TO 212
  210   CONTINUE
 
  212   DO 220 I = 1,256
        CALL UNFMIN
        ARD(I) = AA
        CALL UNFMIN
        AGR(I) = AA
        CALL UNFMIN
        ABL(I) = AA
  220   CONTINUE
      ELSE
        READ(NFB) AA
        READ(NFB) (ARD(J),AGR(J),ABL(J),J=1,256)
      ENDIF
      DO 230  I = 1,256
      ICV(1) = I - 1
      ICV(2) = ICHAR(ARD(I))
      ICV(3) = ICHAR(AGR(I))
      ICV(4) = ICHAR(ABL(I))
      CALL GRAFTM(4)
      IF(I.EQ.1) LBCK(5) = (ICV(2) + ICV(3) + ICV(4)) / 3
  230 CONTINUE
      CALL GRAFTM(6)
      RETURN
 
C *** Read Pixel Values
   30 CONTINUE
      IPP = 0
      LPP = 0
 
      DO 310  I = 1,10000
      IF(JBIN.EQ.0) THEN
        CALL UNFMIN
      ELSE
        READ(NFB) AA
      ENDIF
      NJ = ICHAR(AA)
      IF(NJ.GT.192) THEN
        IF(JBIN.EQ.0) THEN
          CALL UNFMIN
        ELSE
          READ(NFB) AA
        ENDIF
        DO 312  J = 1,NJ - 192
        IPP = IPP + 1
        IF(JENE(1).EQ.0) THEN
          APP(IPP) = AA
        ELSE IF(JENE(1).GT.0) THEN
          IF(AMOD(FLOAT(IPP),QPXM).GT.QPTH) LPP = LPP + 1
          NPSS = IPP - LPP
          IF(NPSS.GT.0) APP(NPSS) = AA
        ELSE
          IF(IPP.LT.KXST) GO TO 312
          IF(IPP.GE.MXND) GO TO 312
          NPSS = IPP - NSHF(1)
          IF(NPSS.GT.0) APP(NPSS) = AA
        ENDIF
  312   CONTINUE
      ELSE
        IPP = IPP + 1
        IF(JENE(1).EQ.0) THEN
          APP(IPP) = AA
        ELSE IF(JENE(1).GT.0) THEN
          IF(AMOD(FLOAT(IPP),QPXM).GT.QPTH) LPP = LPP + 1
          NPSS = IPP - LPP
          IF(NPSS.GT.0) APP(NPSS) = AA
        ELSE
          IF(IPP.LT.KXST) GO TO 314
          IF(IPP.GE.MXND) GO TO 314
          NPSS = IPP - NSHF(1)
          IF(NPSS.GT.0) APP(NPSS) = AA
        ENDIF
      ENDIF
  314 IF(IPP.GE.JXND) GO TO 39
  310 CONTINUE
 
   39 JENE(2) = NPSS
      RETURN
 
   40 CONTINUE
      RETURN
 
  100 GO TO (110,120,130,140), JTT
 
C *** Write Header
  110 CONTINUE
C *** Identification Byte (0A), Version 3.0, RLE coding, 8 bits per pixe
      AP( 1) = CHAR(10)
      AP( 2) = CHAR(5)
      AP( 3) = CHAR(1)
      AP( 4) = CHAR(8)
 
      IDUM = LXST
      CALL MCHARC(0,IDUM)
      AP( 5) = A2
      AP( 6) = A1
 
      IDUM = LYST
      CALL MCHARC(0,IDUM)
      AP( 7) = A2
      AP( 8) = A1
 
      IDUM = LXND
      CALL MCHARC(0,IDUM)
      AP( 9) = A2
      AP(10) = A1
 
      IDUM = LYND
      CALL MCHARC(0,IDUM)
      AP(11) = A2
      AP(12) = A1
 
C *** dots per inch
      IDUM = 93
      CALL MCHARC(0,IDUM)
      AP(13) = A2
      AP(14) = A1
      AP(15) = A2
      AP(16) = A1
 
      DO 112  I = 17,64
      AP(I) = CHAR(0)
  112 CONTINUE
 
C *** reserved byte, number of colour planes
      AP(65) = CHAR(0)
      AP(66) = CHAR(1)
 
C *** bytes per line
      IDUM = NXND
      CALL MCHARC(0,IDUM)
      AP(67) = A2
      AP(68) = A1
 
      DO 114  I = 69,128
      AP(I) = CHAR(0)
  114 CONTINUE
 
      IF(JBIN.EQ.0) THEN
        DO 116  I = 1,128
        AA = AP(I)
        CALL UNFMOP
  116   CONTINUE
      ELSE
        WRITE(NFB) (AP(I),I=1,128)
      ENDIF
      RETURN
 
  120 CONTINUE
C *** Write Palette
 
      AP(1) = CHAR(12)
 
      DO 122  I = 1,256
      J = 3 * (I-1) + 2
      ICV(1) = I - 1
      CALL GRAFTM(7)
      AP(J)   = CHAR(ICV(2))
      AP(J+1) = CHAR(ICV(3))
      AP(J+2) = CHAR(ICV(4))
  122 CONTINUE
 
      IF(JBIN.EQ.0) THEN
 
        IF(NCR.NE.255) THEN
          NNCR = 255
          IF(NCR.GT.255) NNCR = 1279
          NNCR = NNCR - NCR
          AA = CHAR(0)
          DO 123  I = 1,NNCR
          CALL UNFMOP
  123     CONTINUE
        ENDIF
 
        DO 124  J = 1,769
        AA = AP(J)
        CALL UNFMOP
  124   CONTINUE
 
        IF(NCR.EQ.0) RETURN
      ELSE
        WRITE(NFB) (AP(I),I=1,769)
      ENDIF
      RETURN
 
  130 CONTINUE
C *** Write Pixel Line, originally stored in AP
 
      IPP = 0
      ICNT = 1
 
      DO 132  I = 2,NXND
      IF(AP(I).EQ.AP(I-1) .AND. ICNT.LT.63)  THEN
        ICNT = ICNT + 1
      ELSE
        IF(ICNT.EQ.1 .AND. ICHAR(AP(I-1)).LT.192) GO TO 133
        IPP = IPP + 1
        APP(IPP) = CHAR(192 + ICNT)
  133   IPP = IPP + 1
        APP(IPP) = AP(I-1)
        ICNT = 1
      ENDIF
 
  132 CONTINUE
 
      IF(ICNT.EQ.1 .AND. ICHAR(AP(NXND)).LT.192) GO TO 135
      IPP = IPP + 1
      APP(IPP) = CHAR(192 + ICNT)
  135 IPP = IPP + 1
      APP(IPP) = AP(NXND)
 
      IF(JBIN.EQ.0) THEN
        DO 134  I = 1,IPP
        AA = APP(I)
        CALL UNFMOP
  134   CONTINUE
      ELSE
        WRITE(NFB) (APP(I),I=1,IPP)
      ENDIF
      RETURN
 
  140 CONTINUE
      RETURN
      END
 
 
      SUBROUTINE RWTIF(JT)
      SAVE
 
      CHARACTER*1  AP,APP, ARD,AGR,ABL, A1,A2,AA,AQ,AH, ABUF(3000), AW
      CHARACTER*8  ADEV, ANDV, ADTT
      CHARACTER*11 AS99
      CHARACTER*20 ADTM
      CHARACTER*76 AHDR
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC4/ ADEV(9), ANDV, ADTT(2)
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /RW2/ KXST,KXND, KYST,KYND, KY, MXST,MXND,MXMX, JENE(2)
      COMMON /RW3/ IXST,IXND, IYST,IYND, IY, JXST,JXND,JXMX, NSHF(2)
      COMMON /CRD/ A1,A2, AA, AQ(1024), AH(1024), AHDR
      COMMON /LST/ JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /UNF/ JSOP, NCR,NREC,NEND,NCHR, NHUE,NRGB,NRAL, MCR,MREC
      COMMON /CON/ JBIN, JSPT, LYNN, LYB, JTPC, JFON, QPXM, QPTH
      DIMENSION NBPS(100), IZGR(100)
      DATA AS99/'SCHAKAL99  '/, ADTM /'1900:01:01 01:01:01'/
 
      NRGB = 256
 
      JU = IABS(JT) / 10
      JTT = MOD(IABS(JT),10)
      IF(JU.EQ.2) GO TO 100
 
C *** Read from file
      GO TO (10,20,30,40), JTT
 
C *** Header
   10 CONTINUE
 
      NCR = 6
      CALL UNFMN2(IZG0)
      NCR = IZG0
      CALL UNFMN2(NTAG)
 
      DO 12  I = 1,NTAG
      CALL UNFMN2(JTAG)
      CALL UNFMN2(JTYP)
      CALL UNFMN2(NMD1)
      CALL UNFMN2(NMD2)
      NUM = 65536 * NMD1 + NMD2
      CALL UNFMN2(IDT1)
      CALL UNFMN2(IDT2)
      IF(JTYP.EQ.3 .AND. NUM.EQ.1) THEN
        IDT = IDT1
      ELSE
        IDT = 65536 * IDT1 + IDT2
      ENDIF
 
      IF(JTAG.EQ.256) THEN
C *** ImageWidth
        IXST = 0
        IXND = IDT - 1
      ELSE IF(JTAG.EQ.257) THEN
C *** ImageLength
        IYST = 0
        IYND = IDT - 1
      ELSE IF(JTAG.EQ.258) THEN
C *** BitsPerSample
        MBPS = IDT
      ELSE IF(JTAG.EQ.259) THEN
C *** Compression
        JCMP = IDT
        IF(JCMP.NE.32773) GO TO 992
      ELSE IF(JTAG.EQ.262) THEN
C *** PhotmetricInterp
        JPHI = IDT
      ELSE IF(JTAG.EQ.273) THEN
C *** StripOffsets
        IZG1 = IDT
        NSTR = NUM
      ELSE IF(JTAG.EQ.278) THEN
C *** RowsPerStrip
        IRPS = IDT
      ELSE IF(JTAG.EQ.279) THEN
C *** StripByteCounts
        IZG2 = IDT
      ELSE IF(JTAG.EQ.320) THEN
C *** ColorMap
        IZG7 = IDT
        NRGB = NUM / 3
      ELSE IF(JTAG.EQ.34620) THEN
C *** PrivateData
        IZG8 = IDT
      ENDIF
   12 CONTINUE
 
      IF(IZG8.EQ.0) GO TO 992
 
      NCR = IZG1
      DO 14  I = 1,NSTR
      CALL UNFMN2(IDT1)
      CALL UNFMN2(IDT2)
      IZGR(I) = 65536 * IDT1 + IDT2
   14 CONTINUE
 
      NCR = IZG2
      DO 16  I = 1,NSTR
      CALL UNFMN2(IDT1)
      CALL UNFMN2(IDT2)
      NBPS(I) = 65536 * IDT1 + IDT2
   16 CONTINUE
 
      NCR = IZG8
      DO 18  I = 1,75
      CALL UNFMN1
      AHDR(I:I) = AA
   18 CONTINUE
      CALL HEADER(0)
 
      GO TO 999
 
C *** Read RGB Values
   20 CONTINUE
      NCR = IZG7
      DO 21  I = 1,NRGB
      CALL UNFMN1
      CALL UNFMN1
      ARD(I) = AA
   21 CONTINUE
      DO 22  I = 1,NRGB
      CALL UNFMN1
      CALL UNFMN1
      AGR(I) = AA
   22 CONTINUE
      DO 23  I = 1,NRGB
      CALL UNFMN1
      CALL UNFMN1
      ABL(I) = AA
   23 CONTINUE
 
      DO 25  I = 1,NRGB
      ICV(1) = I - 1
      ICV(2) = ICHAR(ARD(I))
      ICV(3) = ICHAR(AGR(I))
      ICV(4) = ICHAR(ABL(I))
      CALL GRAFTM(4)
      IF(I.EQ.1) LBCK(5) = (ICV(2) + ICV(3) + ICV(4)) / 3
   25 CONTINUE
      CALL GRAFTM(6)
      GO TO 999
 
C *** Read one line of Pixel Data
   30 CONTINUE
      NPOS = 0
      LPP = 0
 
      IF(MOD((LY-LYST),IRPS).EQ.0) NCR = IZGR(1 + (LY-LYST) / IRPS)
 
      DO 300  J = 1,100000
      CALL UNFMN1
      IAA = ICHAR(AA)
      IF(IAA.EQ.256) GO TO 300
      IF(IAA.LT.128) THEN
        DO 310  K = 1,IAA+1
        CALL UNFMN1
        NPOS = NPOS + 1
        IF(JENE(1).EQ.0) THEN
          APP(NPOS) = AA
        ELSE IF(JENE(1).GT.0) THEN
          IF(AMOD(FLOAT(NPOS),QPXM).GT.QPTH) LPP = LPP + 1
          NPSS = NPOS - LPP
          IF(NPSS.GT.0) APP(NPSS) = AA
        ELSE
          IF(NPOS.LT.KXST) GO TO 310
          IF(NPOS.GE.MXND) GO TO 310
          NPSS = NPOS - NSHF(1)
          IF(NPSS.GT.0) APP(NPSS) = AA
        ENDIF
  310   CONTINUE
      ELSE
        IAA = 256 - IAA
        CALL UNFMN1
        DO 320  K = 1,IAA+1
        NPOS = NPOS + 1
        IF(JENE(1).EQ.0) THEN
          APP(NPOS) = AA
        ELSE IF(JENE(1).GT.0) THEN
          IF(AMOD(FLOAT(NPOS),QPXM).GT.QPTH) LPP = LPP + 1
          NPSS = NPOS - LPP
          IF(NPSS.GT.0) APP(NPSS) = AA
        ELSE
          IF(NPOS.LT.KXST) GO TO 320
          IF(NPOS.GE.MXND) GO TO 320
          NPSS = NPOS - NSHF(1)
          IF(NPSS.GT.0) APP(NPSS) = AA
        ENDIF
  320   CONTINUE
      ENDIF
      IF(NPOS.GT.JXND) GO TO 991
      IF(NPOS.EQ.JXND) THEN
        NPOS = 0
        GO TO 39
      ENDIF
  300 CONTINUE
 
   39 JENE(2) = NPSS
      RETURN
 
   40 CONTINUE
      RETURN
 
C *** Write to file
  100 GO TO (110,120,130,140), JTT
 
C *** Header
  110 CONTINUE
      CALL DATCHK
      AW = ADTT(1)(7:7)
      IF((ICHAR(AW) - 48).LT.9) ADTM(1:2) = '20'
      ADTM( 3: 4) = ADTT(1)(7:8)
      ADTM( 6: 7) = ADTT(1)(4:5)
      ADTM( 9:10) = ADTT(1)(1:2)
      ADTM(12:13) = ADTT(2)(1:2)
      ADTM(15:16) = ADTT(2)(4:5)
      ADTM(18:19) = ADTT(2)(7:8)
 
      DO 111  I = 1,1024
      AH(I) = CHAR(0)
  111 CONTINUE
 
      LYWD = LYND - LYST + 1
      NRPS = MAX0(1,(LYWD / 64))
      NSTR = (FLOAT(LYWD) / FLOAT(NRPS)) + .999
 
      AH(1)   = 'M'
      AH(2)   = 'M'
      AH(4)   = CHAR(42)
      AH(8)   = CHAR(8)
      AH(10)  = CHAR(15)
C *** ImageWidth
      AH(11)  = CHAR(1)
      AH(14)  = CHAR(4)
      AH(18)  = CHAR(1)
      CALL MCHARC(0,LXND-LXST+1)
      AH(21)  = A1
      AH(22)  = A2
C *** ImageLength
      AH(23)  = CHAR(1)
      AH(24)  = CHAR(1)
      AH(26)  = CHAR(4)
      AH(30)  = CHAR(1)
      CALL MCHARC(0,LYND-LYST+1)
      AH(33)  = A1
      AH(34)  = A2
c *** BitsPerSample
      AH(35)  = CHAR(1)
      AH(36)  = CHAR(2)
      AH(38)  = CHAR(3)
      AH(42)  = CHAR(1)
      AH(44)  = CHAR(8)
C *** Compression
      AH(47)  = CHAR(1)
      AH(48)  = CHAR(3)
      AH(50)  = CHAR(3)
      AH(54)  = CHAR(1)
      AH(55)  = CHAR(128)
      AH(56)  = CHAR(5)
C *** PhotometricInterpretation
      AH(59)  = CHAR(1)
      AH(60)  = CHAR(6)
      AH(62)  = CHAR(3)
      AH(66)  = CHAR(1)
      AH(68)  = CHAR(3)
C *** StripOffsets
      AH(71)  = CHAR(1)
      AH(72)  = CHAR(17)
      AH(74)  = CHAR(4)
      CALL MCHARC(0,NSTR)
      AH(77) = A1
      AH(78) = A2
      IZG1 = 194
      AH(82) = CHAR(IZG1)
C *** RowsPerStrip
      AH(83) = CHAR(1)
      AH(84) = CHAR(22)
      AH(86) = CHAR(4)
      AH(90) = CHAR(1)
      AH(94) = CHAR(NRPS)
C *** StripByteCounts
      AH(95) = CHAR(1)
      AH(96) = CHAR(23)
      AH(98) = CHAR(4)
      AH(101) = A1
      AH(102) = A2
      IZG2 = IZG1 + 4 * NSTR
      CALL MCHARC(0,IZG2)
      AH(105) = A1
      AH(106) = A2
C *** XResolution
      AH(107) = CHAR(1)
      AH(108) = CHAR(26)
      AH(110) = CHAR(5)
      AH(114) = CHAR(1)
      IZG3 = IZG2 + 4 * NSTR
      CALL MCHARC(0,IZG3)
      AH(117) = A1
      AH(118) = A2
C *** YResolution
      AH(119) = CHAR(1)
      AH(120) = CHAR(27)
      AH(122) = CHAR(5)
      AH(126) = CHAR(1)
      IZG4 = IZG3 + 8
      CALL MCHARC(0,IZG4)
      AH(129) = A1
      AH(130) = A2
C *** ResolutionUnit
      AH(131) = CHAR(1)
      AH(132) = CHAR(40)
      AH(134) = CHAR(3)
      AH(138) = CHAR(1)
      AH(140) = CHAR(2)
C *** Software
      AH(143) = CHAR(1)
      AH(144) = CHAR(49)
      AH(146) = CHAR(2)
      AH(150) = CHAR(12)
      IZG5 = IZG4 + 8
      CALL MCHARC(0,IZG5)
      AH(153) = A1
      AH(154) = A2
C *** DateTime
      AH(155) = CHAR(1)
      AH(156) = CHAR(50)
      AH(158) = CHAR(2)
      AH(162) = CHAR(20)
      IZG6 = IZG5 + 12
      CALL MCHARC(0,IZG6)
      AH(165) = A1
      AH(166) = A2
C *** ColorMap
      AH(167) = CHAR(1)
      AH(168) = CHAR(64)
      AH(170) = CHAR(3)
      AH(173) = CHAR(3)
      IZG7 = IZG6 + 20 + 76
      CALL MCHARC(0,IZG7)
      AH(177) = A1
      AH(178) = A2
C *** PrivateTag
      AH(179) = CHAR(135)
      AH(180) = CHAR(60)
      AH(182) = CHAR(1)
      AH(186) = CHAR(76)
      IZG8 = IZG7 - 76
      CALL MCHARC(0,IZG8)
      AH(189) = A1
      AH(190) = A2
 
C *** Beginn Datenfelder
 
C *** XResolution
      IZGS = IZG3 + 1
      CALL MCHARC(0,NXND)
      AH(IZGS+3) = CHAR(93)
      AH(IZGS+7) = CHAR(1)
C *** YResolution
      IZGS = IZG4 + 1
      AH(IZGS+3) = CHAR(93)
      AH(IZGS+7) = CHAR(1)
C *** Software
      DO 115  I = 1,11
      AH(IZG5+I) = AS99(I:I)
  115 CONTINUE
C *** DateTime
      DO 116  I = 1,19
      AH(IZG6+I) = ADTM(I:I)
  116 CONTINUE
C *** PrivateData
      CALL HEADER(1)
      DO 117  I = 1,75
      AH(IZG8+I) = AHDR(I:I)
  117 CONTINUE
 
      DO 118  I = 1,IZG8+76
      AA = AH(I)
      CALL UNFMOP
  118 CONTINUE
 
      IZGR(1) = IZG7 + 6 * NRGB
      ISTR = 0
      NB = 0
 
      GO TO 999
 
  120 CONTINUE
C *** Write Palette
 
      DO 125  LY = 1,NRGB
      ICV(1) = LY - 1
      CALL GRAFTM(7)
      ARD(LY) = CHAR(ICV(2))
      AGR(LY) = CHAR(ICV(3))
      ABL(LY) = CHAR(ICV(4))
  125 CONTINUE
 
      IBTE = IZG8 + 76
 
      DO 122  J = 1,3
      DO 124  I = 1,NRGB
      IF(J.EQ.1) THEN
        AA = ARD(I)
      ELSE IF(J.EQ.2) THEN
        AA = AGR(I)
      ELSE
        AA = ABL(I)
      ENDIF
      CALL UNFMOP
      IBTE = IBTE + 1
      IF(IBTE.LT.1025) AH(IBTE) = AA
      CALL UNFMOP
      IBTE = IBTE + 1
      IF(IBTE.LT.1025) AH(IBTE) = AA
  124 CONTINUE
  122 CONTINUE
      RETURN
 
  130 CONTINUE
C *** Write Pixel Line, stored in AP
 
      ICT  = 0
      IBTE = 0
      ISTL = 1
      INDL = 0
 
      DO 132  I = 3,NXND+1
      JEQL = 0
 
      IF(I.GT.NXND) THEN
        JEQL = 1
        IF(ICT.EQ.0) THEN
          ICT = -1
          INDL = NXND
        ENDIF
      ENDIF
 
      IF(JEQL.EQ.0) THEN
        IF(AP(I).NE.AP(I-1) .OR. AP(I).NE.AP(I-2)) JEQL = 1
      ENDIF
 
      IF(JEQL.EQ.0) THEN
        IF(ICT.EQ.0) INDL = I - 3
        AW = AP(I)
        ICT = ICT + 1
      ELSE
        IF(ICT.NE.0) THEN
          IF(ISTL.LE.INDL) THEN
            NBA = 1 + (INDL - ISTL) / 128
 
            DO 134  J = 1,NBA
            KEND = MIN0((ISTL+127),INDL)
            IBTE = IBTE + 1
            ABUF(IBTE) = CHAR(KEND-ISTL)
 
            DO 136  K = ISTL,KEND
            IBTE = IBTE + 1
            ABUF(IBTE) = AP(K)
  136       CONTINUE
 
            ISTL = ISTL + 128
  134       CONTINUE
 
          ENDIF
          IF(ICT.GT.0) THEN
            ICT = ICT + 1
            NBA = 1 + ICT / 128
 
            DO 138  J = 1,NBA
            IDUM = 128
            IF(J.EQ.NBA) THEN
              IDUM = MOD(ICT+1,128)
              IF(IDUM.EQ.0) THEN
                IDUM = 128
              ELSE IF(IDUM.EQ.1) THEN
                IDUM = 257
              ENDIF
            ENDIF
            IBTE = IBTE + 1
            ABUF(IBTE) = CHAR(256-(IDUM-1))
            IBTE = IBTE + 1
            ABUF(IBTE) = AW
  138       CONTINUE
          ENDIF
          ISTL = I
        ENDIF
        ICT = 0
      ENDIF
  132 CONTINUE
 
      DO 139  I = 1,IBTE
      AA = ABUF(I)
      CALL UNFMOP
  139 CONTINUE
 
      NB = NB + IBTE
 
      IF(MOD(LYNN,NRPS).EQ.0 .OR. LY.EQ.LYB) THEN
        ISTR = ISTR + 1
        NBPS(ISTR) = NB
        IZGR(ISTR+1) = IZGR(ISTR) + NB
        NB = 0
      ENDIF
      GO TO 999
 
  140 CONTINUE
C *** Write StripOffstes and StripByteCounts into record 1
 
      IZG = IZG1
 
      DO 141  I = 1,NSTR
      IDUM = IZGR(I) / 65536
      CALL MCHARC(0,IDUM)
      IZG = IZG + 1
      AH(IZG) = A1
      IZG = IZG + 1
      AH(IZG) = A2
      IDUM = MOD(IZGR(I),65536)
      CALL MCHARC(0,IDUM)
      IZG = IZG + 1
      AH(IZG) = A1
      IZG = IZG + 1
      AH(IZG) = A2
  141 CONTINUE
 
      IZG = IZG2
 
      DO 142  I = 1,NSTR
      IDUM = NBPS(I) / 65536
      CALL MCHARC(0,IDUM)
      IZG = IZG + 1
      AH(IZG) = A1
      IZG = IZG + 1
      AH(IZG) = A2
      IDUM = MOD(NBPS(I),65536)
      CALL MCHARC(0,IDUM)
      IZG = IZG + 1
      AH(IZG) = A1
      IZG = IZG + 1
      AH(IZG) = A2
  142 CONTINUE
 
      DO 144 I = NCR+1,1024
  144 AQ(I) = CHAR(0)
      WRITE(NFB,REC=NREC+1) AQ
      WRITE(NFB,REC=1) AH
      GO TO 999
 
  991 WRITE(18,*) '### wrong no. of pxls: LY,NPOS,JXND =',LY,NPOS,JXND
      GO TO 999
 
  992 WRITE(18,*) '### not readable by SCHAKAL'
 
  999 RETURN
      END
