      SUBROUTINE TXTWDW(JT)
      SAVE
C *** Program to save/restore the text window
C     JT = 0 : auf Datei abspeichern
C     JT = 1 : von Datei zurckholen
C     JT = -1: lschen mit Rand
C     JT = -2: NTLY initialisieren
C      -10001: lschen ohne Rand  (wenn JT = 1 und JPUL(4) = 0)
 
      INCLUDE 'scom1.inc'
      CHARACTER*1  AP, APP, ARD, AGR, ABL
      COMMON /RWL/ LXST,LXND, LYST,LYND, LY, NXST,NXND,NXMX, NJ,JRR
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /APS/ AP(3200),APP(3200),ARD(256),AGR(256),ABL(256)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
      COMMON /ANI/ JANI,LANI,XANI(2), IDRI,LDRH,LDRL, WWW,WWWS,WWWT,
     *             WGES,WSUM,JRRA,NDEF(9),RANI(12),NANI,IANI(9),PANI(9)
 
      IF(JANI.GT.1) RETURN
 
      JTT = JT
 
      IF(JPUL(3).NE.0) RETURN
      IF(JT.LT.0 .AND. JPUL(2).NE.0) JTT =  1
      IF(JT.GT.0 .AND. JPUL(4).EQ.0) JTT = -1
      IF(JTT.LT.-1) GO TO 1
      IF(JTT.NE.0 .AND. NTLY.EQ.0) RETURN
 
    1 NTLY = 0
      NTLX = 0
 
      IF(JTT.NE.0) GO TO 2
 
      CALL STREST(1)
      JPUL(4) = 1
      RETURN
 
    2 IF(JTT.GT.0) THEN
        CALL STREST(2)
      ELSE
        CALL STREST(3)
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE TWSIZE(JT)
C *** This may be used to switch between small and full size of text win
C     JT = 0 : text window small; re-initialization
C     JT = 1 : text window full screen size
C     JT = 2 : like JT = 0, but skip MONIT/HPRED (otherwise double actio
 
      SAVE
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /MAP/ NFS,IRGB,IHUE(13),ISAT(13),LITE(247),IHU(13),ISA(13)
      COMMON /SMA/ JNPL,LDEW,LD5A, JPEP, XPSH(9),YPSH(9)
      COMMON /SRF/ JSRF,JXYC,JREA,JIDX,IXCR(2),IYCR(2),JMNU(6),JTCH(8),
     *             JSAC,JUIN(3)
 
      IF(JT.EQ.1) THEN
        CALL GRMODE(1)
        JTLN = 0
      ELSE
        IF(JT.NE.2) CALL GRMODE(0)
        JDV0 = JDEV
        LDV0 = LDEV
        JTB0 = JTB
        JUB0 = JUB
        IRG0 = IRGB
        NFR0 = NFRB
        NFS0 = NFST
 
        JDEV = LMON
        LDEV = LMON
        JTB  = 2
        JUB  = 1
        IRGB = 1
        NFST = IABS(NPLM) / 1000
        NFRB = MOD(IABS(NPLM),1000)
        NFS  = NFST
        FST  = NFST + 1
 
        JNPL = 0
        IF(NPLM.LT.0) JNPL = 1
        CALL INTEP(1)
        JNPL = 0
 
        IF(JT.EQ.0) THEN
          IF(JSRF.NE.0)  CALL SURFIN(1)
        ENDIF
 
        JDEV = JDV0
        LDEV = LDV0
        JTB  = JTB0
        JUB  = JUB0
        IRGB = IRG0
        NFRB = NFR0
        NFST = NFS0
        NFS  = NFST
        FST  = NFST + 1
 
        IF(JTB.EQ.1 .AND. (JT.EQ.0 .OR. JT.EQ.3)) THEN
          CALL MONIT(0)
          CALL INTEP(-9)
          IF(JDEV.LT.6) THEN
            CALL HPRED(0)
          ELSE IF(JDEV.EQ.6) THEN
            CALL PSRED(0)
          ELSE IF(JDEV.EQ.7) THEN
            CALL WMFRED(0)
          ENDIF
        ENDIF
        JTLN = 1
        NTLY = 0
        NTLX = 0
        IF(MAX0(1,JDEV).EQ.LMON) THEN
          CALL GRAFTM(1)
          CALL GRAFTM(3)
          CALL GRAFTM(2)
        ENDIF
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE TXTSV(JT)
      SAVE
 
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
 
      IF(JTLN.EQ.0) RETURN
      IF(NINA.NE.NEIN .AND. NINA.NE.NFA) RETURN
 
      JTU = MOD(IABS(JT),100)
 
      IF(NTLY.GT.(23-JTU)) THEN
        IF(JT.LT.100) THEN
          JJT = 106
          IF(JT.LT.0) JJT = 107
          CALL WRITS(JJT)
        ELSE
          CALL WAITSL(-1.0)
        ENDIF
        CALL PCERS(0)
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE PCERS(JT)
 
      SAVE
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /AUT/ JWKA,JKSA,JKSS,JCSR, JTX,NTXN,JWCD,NPMX, LSFF
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
 
      IF(JT.EQ.0 .AND. JECO(1).LT.2) THEN
        CALL TXTWDW(1)
      ENDIF
      IF(JT.LT.0) NTLY = 0
 
      RETURN
      END
 
 
      SUBROUTINE TCOLRS(JT)
 
      SAVE
      COMMON /LST/ JJ, IG, IPSH,IFAC,LBCK(6)
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /TXT/ JTLN,NTLX,NTLY, JPUL(4),JTSV, FCTX,IWCH,IHCH,ICLT,
     *             IDXX,IDXY, ITXX,ITXY, ITTX,ITTY, LTXX(2),LTXY(2)
 
      NFSS = IABS(NPLM) / 1000
      IF(JT.NE.0) GO TO 1
 
      KCOL = NFSS / 2
      IF(LBCK(5).LT.144) THEN
        ICLT = 4
        KCOL = KCOL - 1
        IF(NFSS.LT.7) KCOL = KCOL + 2
        IF(NFSS.EQ.1) KCOL = KCOL + 1
      ELSE
        ICLT = 3
        KCOL = KCOL + 2
      ENDIF
      ICLT = NFSS * ICLT + KCOL
      GO TO 2
 
    1 KCOL = NFSS / 9
      ICLT = 1 + KCOL
      IF(LBCK(5).GT.144) ICLT = NFSS + 1 - KCOL
 
    2 CALL TXSTCL(ICLT)
      RETURN
      END
 
 
      SUBROUTINE TGRBSC(JDMM)
 
      IDUM = JDMM
      RETURN
      END
