C *** This is a driver for a Postscript file
C     The file is accessed through channel no. NFLP
 
 
      SUBROUTINE PSINI(JT)
C *** Initializing routine; a file is opened for graphic commands
C     and a header is written to that file
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      CHARACTER*6  ALBL, AFLB, ASTL
      CHARACTER*7  ADDV
      CHARACTER*8  ADEV, ANDV, ADTT
      CHARACTER*10 ASUF, ASF2
      CHARACTER*16 AVRS, AULN
      CHARACTER*60 ATIT
      CHARACTER*80 APRE, ASYS
      CHARACTER*164 ASTG, AFDF, AFIL, AFIP
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /MCJ/ NFLN,NFLO,JECO(4),JMSE,JRAS,PPIN(5),LPIN(5),MCHN(5)
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC2/ XMNG(9),XMXG(9),YMNG(9),YMXG(9),RSG(9),IRS(9),INIT(9)
      COMMON /MC4/ ADEV(9), ANDV, ADTT(2)
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /FNM/ AFIL,AFIP, ASYS(4),APRE(9),ASUF(9),AFDF(9),ADDV(9),
     *             ASF2(5,2),ATIT,ASTG,AFLB,ALBL(3),ASTL(10,3),AVRS,AULN
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /SZE/ XMN(3), XMX(3), XMIN(3), XMAX(3), YA, YE
      COMMON /ZP0/ JKK, JOS, JVD, JEF, JCL, JGR, JSL, JSW
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /SVV/ J1,J2,J3,JUL,JBOX,NOPA,NOPB, IPSV(8)
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
      COMMON /SMA/ JNPL,LDEW,LD5A, JPEP, XPSH(9),YPSH(9)
      COMMON /KEY/ ICHR,NSYS(4),IAR3, IDDD,IMMM,IYYY, JFPG, LOPN
 
      JPEP = 1 - LDV3
      IF(XPSH(9).GT.0.5) JPEP = - JPEP
 
      JAUS = 0
      JU = 15
      IF(JT.LT.0) JU = -15
 
      JRRR = 0
      IF(LPIN(3).NE.0) GO TO 1
 
      JRRR = -1
      CALL MACH(JU)
      IF(JRRR.NE.0) RETURN
 
    1 IF(JOPN.NE.0) CALL PSEND
 
      IF(LPIN(3).EQ.0) JRRR = 1
      CALL MACH(JU)
      IF(JRRR.NE.0) THEN
        CALL WRITS(319)
        RETURN
      ENDIF
 
      IF(JT.LT.0) GO TO 5
 
C *** A header for the file is read from file sch99.psi and then written
C     to the plotter/printer file by subroutine PSBEG
C     If the read-file is empty, the header is written by the program
 
      LOPN = LDEV
      CALL MACH(4)
 
      CALL PSBEG
      IF(IRED.NE.0) GO TO 2
 
C *** Header for Postscript printer
 
      XSHF = - (1. + XMXG(6)) + XPSH(6)
      YSHF = 1. + YPSH(6)
 
      IF(JPEP.EQ.0) THEN
 
        WRITE(NFLP,9000) XSHF,YSHF
 9000   FORMAT('%!PS-Adobe-3.0'/
     *         ' gsave'/
     *         '/cm { 72 mul 2.54 div } def'/
     *         ' -90 rotate',F6.1,' cm',F6.1,' cm translate'/1X)
 
      ELSE
 
        IBBX = (XMXG(6) - XMNG(6)) * 28.3465
        IBBY = (YMXG(6) - YMNG(6)) * 28.3465
        CALL DATCHK
 
        IF(JPEP.GT.0) THEN
          WRITE(NFLP,9010) IBBY, IBBX, ATIT, ADTT
        ELSE
          WRITE(NFLP,9010) IBBX, IBBY, ATIT, ADTT
        ENDIF
 9010   FORMAT('%!PS-Adobe-3.0 EPSF-3.0'/
     *         '%%BoundingBox:  0  0',2I5/
     *         '%%Title:' ,A60/
     *         '%%Creator:  SCHAKAL 99'/
     *         '%%CreationDate: ',A8,2X,A8/
     *         '%%EndComments'/1X/
     *         ' gsave'/1X/
     *         '/NSTACK count 1 sub def'/
     *         '/SCH99DICT  280 dict def'/
     *         ' SCH99DICT begin'/1X/
     *         '/B 0 def /G 0 def /R 0 def /X 0 def /Y 0 def /Z 0 def'/
     *         '/cm { 72 mul 2.54 div } def')
        IF(JPEP.GT.0) THEN
          WRITE(NFLP,9011) XSHF, YSHF
 9011     FORMAT(' -90 rotate',F6.1,' cm',F6.1,' cm translate'/1X)
        ENDIF
      ENDIF
 
    2 WRITE(NFLP,9001)
 9001 FORMAT(
     * '/fac { 200 div cm } def'/1X/
     * '/C { /B exch def /G exch def /R exch def'/
     * '      R 255 div G 255 div B 255 div setrgbcolor } def'/
     * '/F { /G exch def G 255 div setgray } def'/
     * '/L { /Z exch def Z cm setlinewidth } def'/1X/
     * '/O { newpath X fac Y fac moveto } def'/
     * '/I { X fac Y fac lineto stroke } def'/1X/
     * '/P { /Y exch def /X exch def  O } def'/
     * '/M { /Y exch Y add def /X exch X add def  O } def'/
     * '/W { /X exch X add def  O } def'/
     * '/S { /Y exch Y add def  O } def'/1X/
     * '/D { /Y exch Y add def /X exch X add def  I  O } def'/
     * '/H { /X exch X add def  I  O } def'/
     * '/V { /Y exch Y add def  I  O } def'/1X/
     * ' 1 setlinecap  1 setlinejoin'/1X)
 
      IXA = 0
      IYA = 0
      NUMX = 128
      NUMO = NUMX + 1
      NUMP = 1
      NWRT = 0
      NHPL = 0
 
      GO TO 8
 
    5 CALL MONIT(0)
      CALL PSRED(-1)
 
    8 JOPN = LDEV
 
      RETURN
      END
 
 
      SUBROUTINE PSEND
C *** Termination of Plotter Instructions
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      CHARACTER*1  ALIN, ALIO, ATXT, AF, APL
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /CAR/ ALIN(80), ALIO(80), ATXT(160), AF(6), APL(6)
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /SMA/ JNPL,LDEW,LD5A, JPEP, XPSH(9),YPSH(9)
 
      IF(JOPN.EQ.0) RETURN
 
C *** Terminator is read from file  sch99.psi  by subroutine PSBEG and
C     written to the Postscript file
C     If the read-file is empty, the terminator is written by the progra
C     below
 
      CALL PSBEG
      IF(IRED.NE.0) GO TO 2
 
      IF(JAUS.LT.-1) THEN
        JAUS = 1
        GO TO 11
      ENDIF
      CALL PSEMPT(0)
 
   11 CONTINUE
      IF(JPEP.EQ.0) THEN
        WRITE(NFLP,9011)
 9011   FORMAT(1X/' grestore showpage'/' quit')
      ELSE
        WRITE(NFLP,9012)
 9012   FORMAT(1X/' end'/
     *         ' count NSTACK sub { pop } repeat'/1X/
     *         ' grestore showpage'/1X/
     *         '%%Trailer'/
     *         '%%EOF')
      ENDIF
 
    2 ENDFILE NFLP
      CALL CLOSEF(NFLP)
      JOPN = 0
 
      RETURN
      END
 
 
      SUBROUTINE PSBEG
C *** Reads a header and/or terminator from file sch99.psi
C     and writes it to the Postscript file. If no relevant
C     data are found on the read-file, PSBEG returns with IRED = 0
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      CHARACTER*1  ALIN, ALIO, ATXT, AF, APL
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /CAR/ ALIN(80), ALIO(80), ATXT(160), AF(6), APL(6)
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
 
      IRED = 0
 
    1 READ(NFLH,8000,END=999,ERR=999) ALIN
 8000 FORMAT(80A1)
 
      IF(ALIN(1).EQ.'#' .OR. ALIN(2).EQ.'#') GO TO 1
      IRED = IRED + 1
 
      DO 10  I = 80,1,-1
      IF(ALIN(I).NE.' ') GO TO 11
   10 CONTINUE
 
   11 IF(I.LT.3) GO TO 999
 
      WRITE(NFLP,9020) (ALIN(J),J=1,I)
 9020 FORMAT(80A1)
      GO TO 1
 
  999 RETURN
      END
 
 
      SUBROUTINE PSMARK
C *** This inserts a mark into the plotter file; the mark is  PU;  with
C     nothing else. The mark is inserted before any action invoked with
C     'X..' or 'W..'. Marks are searched for, when the last part(s) of
C     the file is (are) to be erased by 'K X' or 'K L' .
 
      SAVE
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /ZP1/ JTB,JUB,RES,FAC,XNL(2),ITM(2),OM(6),IPLT,NPLT,JPLT
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(NWRT.EQ.0) THEN
        CALL PSPALS
        NWRT = 1
        IPCL = IPCC
        CALL PSCLR
        NWRT = 0
      ENDIF
 
      IF(JAUS.LT.-1) THEN
        JAUS = 1
        NUMP = 1
        GO TO 1
      ENDIF
 
      CALL PSEMPT(0)
 
    1 WRITE(NFLP,9000) 1.1 * RES
 9000 FORMAT('00 00 P ',F5.3,' L')
      NWRT = NWRT + 1
      IPCM = -1
      NHPL = 0
      LOCL = -9
      NUMO = NUMX + 1
 
      CALL RESTCL(0)
 
      RETURN
      END
 
 
      SUBROUTINE PSPALS
 
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
 
      JDVV = JDEV
      IEND = 2 + (NCLR(LMON) / 1000) * MOD(NCLR(LMON),1000)
      IND5 = IEND
      IF(LDV5.NE.0) IND5 = 1 + NCLR(LMON) / 1000
 
      DO 20  I = 0,IEND
      IF(I.EQ.IEND) GO TO 21
      IF(I.GT.IND5) GO TO 20
   21 ICV(1) = I
      JDEV = LMON
      CALL GRAFTM(1)
      CALL GRAFTM(7)
      CALL GRAFTM(2)
      JDEV = JDVV
      CALL GRAFTM(4)
   20 CONTINUE
 
      JDEV = JDVV
 
      RETURN
      END
 
 
      SUBROUTINE PSERS(JT)
C *** JT = 0: rewinds the plotter file and reads it up to the last mark;
C             reading is monitored on the screen. The part behind the
C             last mark is overriden on the next 'X..' or 'W..'
C     JT = 1: goes backwards to the last mark, reads up to the end of
C             file; reading is "monitored" using the background colour
C             thus erasing part of the drawing on the screen. After that
C             the program goes back to the last mark once more.
C     JT = 2: like JT = 1, but no call of GRAFTM(1) and GRAFTM(2) in
C             subroutine PSPRED
 
      SAVE
      CHARACTER*2 APU
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
 
      IF(NWRT.EQ.0) RETURN
      IF(JT.NE.0) GO TO 5
 
      REWIND NFLP
      NWT = 0
      NKLX = MAX0(0,IABS(NKLX) - 1)
      NWRT = MAX0(1,(NWRT - NKLX))
 
    1 READ(NFLP,8001,END=9) APU
 8001 FORMAT(A2)
 
      IF(APU.NE.'00') GO TO 1
C *** PU; (mark) detected on Postscript file
      NWT = NWT + 1
      IF(NWT.NE.NWRT) GO TO 1
      GO TO 8
 
    5 CALL PSEMPT(0)
      IF(NHPL.EQ.0) RETURN
      JSPR = 0
 
    6 DO 50  I = 1,NHPL
      BACKSPACE NFLP
   50 CONTINUE
C *** Next statement causes error on workstations ?? (not for Postsc.)
c     BACKSPACE NFLP
 
      IF(JSPR.NE.0) GO TO 8
 
      BACKSPACE NFLP
 
      CALL PSRED(JT)
      JSPR = 1
      GO TO 6
 
    8 BACKSPACE NFLP
      ENDFILE NFLP
      BACKSPACE NFLP
      NWRT = NWRT - 1
      NHPL = 0
      JAUS = -2
      RETURN
 
    9 CALL WRITS(317)
      RETURN
      END
 
 
      SUBROUTINE PSRED(JT)
C *** This reads a Postscript and visualizes it on the screen
C     JT = -1  reads an old file from the beginning; counts marks
C           0  reads the current file from the beginning
C           1  reads the current file up to the end
C           2  like JT = 1, but no calls to GRAFTM(1), GRAFTM(2)
 
      SAVE
      CHARACTER ESC*1, AR*1, APC*5, PBUF*84
      COMMON /MCH/ NEIN,NAUS,NOUT,NFA,NFB,NFC,NFH,NATX,NX,NDIG,JEC,JRRR
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC3/ FXYG(9),FMON(9),IPRS,FCXY,FACX,XNLG(2), RSTG,XCXG
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /ZP0/ JKK, JOS, JVD, JEF, JCL, JGR, JSL, JSW
      COMMON /PLS/ IPCA, IPCB, IPCC, JUNC, JUND, JWLW, JRFR
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /RAS/ LRRS, LRQT, KW, IXSR, IYSR, IPXA, IPXE, NCPX, JRMF
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /SMA/ JNPL,LDEW,LD5A, JPEP, XPSH(9),YPSH(9)
      DIMENSION IWRT(8), IPAL(16)
 
      IF(NWRT.LE.0 .AND. JT.EQ.0) RETURN
 
      IF(JT.LE.0) CALL SFINTA(-3)
 
      NCMP = 0
      NPLL = 0
      JPLM = 0
      ICV(1) = 0
      JERO = 0
      JPPS = 0
 
      JDVV = JDEV
      JDEV = LMON
      IF(JT.LE.0) THEN
        REWIND NFLP
        CALL GRAFTM(1)
      ELSE
        IF(JT.EQ.1) CALL GRAFTM(1)
        IPCL = 0
        CALL NEWCOL
        CALL TXTWDW(1)
      ENDIF
 
      NWT = 0
      IYMX = MOD(IPIY(LDEV),100000)
 
      READ(NFLP,8002,END=9,ERR=99) PBUF(1:20)
 8002 FORMAT(A20)
 
      IF(JT.LT.0) THEN
        NHPL = 0
        IF(PBUF(1:4).NE.'%!PS') THEN
          JERO = 1
        ELSE
          JPPS = 0
          IF(PBUF(16:19).EQ.'EPSF') JPPS = 1
          IF(JPPS.NE.JPEP) JERO = 1
        ENDIF
        IF(JERO.NE.0) GO TO 99
      ENDIF
 
      NLIN = 1
 
    1 READ(NFLP,8001,END=9,ERR=99) APC
 8001 FORMAT(A5)
      NLIN = NLIN + 1
 
      IF(JT.LE.0) THEN
        IF(MOD(NLIN,20).EQ.1) THEN
          CALL KEYCHK(0)
          IF(JRRR.EQ.1) THEN
            JRRR = 0
            GO TO 9
          ENDIF
          IF(MOD(NLIN,100).EQ.1) THEN
            CALL WINFUN(1)
            IF(JRRR.EQ.1) THEN
              JRRR = 0
              GO TO 9
            ENDIF
          ENDIF
        ENDIF
      ENDIF
 
      IF(APC(1:1).EQ. '%') GO TO 1
      IF(APC(1:1).EQ. '@') GO TO 1
      IF(APC(1:1).EQ. ' ') GO TO 1
      IF(APC(1:2).EQ.'00') GO TO 2
      IF(APC(1:1).EQ.'/') THEN
        IF(APC(2:4).EQ.'NST') GO TO 1
        IF(APC(2:4).EQ.'SCH') GO TO 1
        ICRR = ICHAR(APC(3:3))
        IF(ICRR.GT.64 .AND. ICRR.LT.91)  GO TO 6
        GO TO 1
      ENDIF
      GO TO 7
 
C *** 00 (mark) detected on Postscript file
    2 NWT = NWT + 1
      GO TO 1
 
    6 CONTINUE
C *** Postscript palette data detected on Postscript file
      IF(JT.GE.0) GO TO 1
 
      BACKSPACE NFLP
      IF(APC(5:5).EQ.'{') THEN
        READ(NFLP,8006) ICV(2),ICV(3),ICV(4)
 8006   FORMAT(5X,3I4)
      ELSE
        READ(NFLP,8007) ICV(2)
 8007   FORMAT(6X,I4)
        ICV(3) = ICV(2)
        ICV(4) = ICV(2)
      ENDIF
 
      ICV(1) = ICV(1) + 1
 
      IF(JPLM.EQ.0) GO TO 61
      IF(ICV(1).NE.1 .AND. ICV(1).NE.NCOL) THEN
        DIV = 3.
        NFSS = 1 + MOD(ICV(1)-2,NFST)
        NFSQ = 0.667 * NFST
        IF(NFSS.GT.NFSQ) DIV = DIV + 0.1 * (FLOAT(NFSS-NFSQ) ** 2.)
        ICV(2) = (DIV * FLOAT(ICV(2)) - 255.) / (DIV - 1.)
        ICV(3) = (DIV * FLOAT(ICV(3)) - 255.) / (DIV - 1.)
        ICV(4) = (DIV * FLOAT(ICV(4)) - 255.) / (DIV - 1.)
      ENDIF
   61 CALL GRAFTM(4)
      GO TO 1
 
    7 CONTINUE
C *** Postscript line-draw data detected on Postscript file
      NCMP = NCMP + 1
      IF(NCMP.EQ.1 .AND. JT.LT.0) THEN
        CALL GRAFTM(6)
      ENDIF
      BACKSPACE NFLP
      READ(NFLP,8008) PBUF
 8008 FORMAT(A84)
 
      NZAL = 0
      NZFF = 0
      NBCH = 0
      ISIG = 1
 
      DO 70  I = 1,84
      IC = ICHAR(PBUF(I:I))
      IF(IC.EQ.45) THEN
        ISIG = -1
      ELSE IF(IC.EQ.32) THEN
        IF(NZFF.NE.0) THEN
          IVAL = 0
          DO 710  J = NZFF,1,-1
          IVAL = IVAL + IWRT(J) * 10 ** (NZFF - J)
  710     CONTINUE
          NZAL = NZAL + 1
          IPAL(NZAL) = ISIG * IVAL
          ISIG = 1
        ELSE IF(NBCH.NE.0) THEN
          IF(NBCH.EQ.2) THEN
C *** Colour Detected on Postscript file
            IF(JT.GT.0) GO TO 70
            IPCL = 26 * (ICM2 - 65) + (ICM1 - 65)
            CALL NEWCOL
          ELSE
            IF(ICM1.EQ.72) THEN
C *** H (horizontal draw) detected on Postscript file
              IXPS = IXPS + IPAL(1)
              XDR = IXPX(1) + INT(IXPS / FMOX)
              IF(JDM.EQ.0) YDR = YMV
              CALL DRAWP
              JDM = 1
            ELSE IF(ICM1.EQ.86) THEN
C *** V (vertical draw) detected on Postscript file
              IF(JDM.EQ.0) XDR = XMV
              IYPS = IYPS + IPAL(1)
              YDR = IYPX(1) + INT(IYPS / FMOY)
              CALL DRAWP
              JDM = 1
            ELSE IF(ICM1.EQ.68) THEN
C *** D (draw) detected on Postscript file
              IXPS = IXPS + IPAL(1)
              IYPS = IYPS + IPAL(2)
              XDR = IXPX(1) + INT(IXPS / FMOX)
              YDR = IYPX(1) + INT(IYPS / FMOY)
              CALL DRAWP
              JDM = 1
            ELSE IF(ICM1.EQ.87) THEN
C *** W (horizontal move) detected on Postscript file
              IXPS = IXPS + IPAL(1)
              XMV = IXPX(1) + INT(IXPS / FMOX)
              IF(JDM.NE.0) YMV = YDR
              CALL MOVEP
              JDM = 0
            ELSE IF(ICM1.EQ.83) THEN
C *** S (vertical move) detected on Postscript file
              IF(JDM.NE.0) XMV = XDR
              IYPS = IYPS + IPAL(1)
              YMV = IYPX(1) + INT(IYPS / FMOY)
              CALL MOVEP
              JDM = 0
            ELSE IF(ICM1.EQ.77) THEN
C *** M (move) detected on Postscript file
              IXPS = IXPS + IPAL(1)
              IYPS = IYPS + IPAL(2)
              XMV = IXPX(1) + INT(IXPS / FMOX)
              YMV = IYPX(1) + INT(IYPS / FMOY)
              CALL MOVEP
              JDM = 0
            ELSE IF(ICM1.EQ.80) THEN
C *** P (pos.) detected on Postscript file
              IXPS = IPAL(1)
              IYPS = IPAL(2)
              XMV = IXPX(1) + INT(IXPS / FMOX)
              YMV = IYPX(1) + INT(IYPS / FMOY)
              CALL MOVEP
              JDM = 0
            ENDIF
          ENDIF
          NZAL = 0
        ELSE
          GO TO 70
        ENDIF
        NBCH = 0
        NZFF = 0
      ELSE IF(IC.LT.58) THEN
        NZFF = NZFF + 1
        IWRT(NZFF) = IC - 48
      ELSE
        NBCH = NBCH + 1
      ENDIF
 
      ICM2 = ICM1
      ICM1 = IC
   70 CONTINUE
 
      GO TO 1
 
    9 BACKSPACE NFLP
      IF(JT.LT.0) THEN
        IF(NLIN.LT.5) THEN
          REWIND NFLP
          READ(NFLP,8001,END=99,ERR=99) APC
          READ(NFLP,8001,END=99,ERR=99) APC
        ELSE
          BACKSPACE NFLP
C *** Next statement causes error on workstations ?? (not for Postsc.)
c         BACKSPACE NFLP
          IF(JPPS.NE.0) THEN
            DO 90  I = 1,8
            BACKSPACE NFLP
   90       CONTINUE
          ENDIF
          WRITE(NFLP,9009)
 9009     FORMAT(5X)
          BACKSPACE NFLP
        ENDIF
      ENDIF
   99 IF(JT.LE.0) THEN
        CALL GRAFTM(2)
      ELSE
        IPCL = IPCB
        CALL GRAJ(IPCL)
        CALL NEWCOL
        IF(JT.EQ.1) CALL GRAFTM(2)
      ENDIF
      IF(JT.LE.0) CALL SFINTA(0)
      CALL TXTWDW(0)
      JDEV = JDVV
      IF(JT.LT.0) NWRT = NWT
      IF(JERO.NE.0) CALL WRITS(319)
      GO TO 999
 
  999 RETURN
      END
 
 
      SUBROUTINE PSPLT
C *** This plots straight lines
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      NUMO = NUMO + 1
      IF(IPCL.NE.0) GO TO 1
 
      IX = XDR
      IY = YDR
      IF(IY.EQ.IYA) THEN
        AR(1) = 'H'
        JDRR = 1
      ELSE IF(IX.EQ.IXA) THEN
        AR(1) = 'V'
        JDRR = -1
      ELSE
        AR(1) = 'D'
        JDRR = 0
      ENDIF
      GO TO 2
 
    1 IX = XMV
      IY = YMV
 
      IF(NUMO.GT.NUMX) THEN
        AR(1) = 'P'
        NUMO = 0
        JDRR = 0
        GO TO 2
      ENDIF
 
      IF(IY.EQ.IYA) THEN
        AR(1) = 'W'
        JDRR = 1
      ELSE IF(IX.EQ.IXA) THEN
        AR(1) = 'S'
        JDRR = -1
      ELSE
        AR(1) = 'M'
        JDRR = 0
      ENDIF
 
    2 JSPR = 0
      IX = MAX0(0,IX)
      IY = MAX0(0,IY)
      IF(JDRR.GE.0) THEN
        IZ = IX
        IF(NUMO.EQ.0) GO TO 3
        IZ = IZ - IXA
      ELSE
        IZ = IY - IYA
      ENDIF
      IF(JDRR.NE.0) JSPR = 1
 
    3 IF(IZ.GT.-1 .AND. IZ.LT.10) THEN
        WRITE(PBUF(NUMP:NUMP+1),9001) IZ
 9001   FORMAT(I1,1X)
        NUMP = NUMP + 2
      ELSE IF(IZ.GT.-10 .AND. IZ.LT.100) THEN
        WRITE(PBUF(NUMP:NUMP+2),9002) IZ
 9002   FORMAT(I2,1X)
        NUMP = NUMP + 3
      ELSE IF(IZ.GT.-100 .AND. IZ.LT.1000) THEN
        WRITE(PBUF(NUMP:NUMP+3),9003) IZ
 9003   FORMAT(I3,1X)
        NUMP = NUMP + 4
      ELSE IF(IZ.GT.-1000 .AND. IZ.LT.10000) THEN
        WRITE(PBUF(NUMP:NUMP+4),9004) IZ
 9004   FORMAT(I4,1X)
        NUMP = NUMP + 5
      ELSE IF(IZ.GT.-10000 .AND. IZ.LT.100000) THEN
        WRITE(PBUF(NUMP:NUMP+5),9005) IZ
 9005   FORMAT(I5,1X)
        NUMP = NUMP + 6
      ELSE
        WRITE(PBUF(NUMP:NUMP+6),9006) IZ
 9006   FORMAT(I6,1X)
        NUMP = NUMP + 7
      ENDIF
      IF(JSPR.NE.0) GO TO 5
      JSPR = 1
      IZ = IY
      IF(NUMO.EQ.0) GO TO 3
      IZ = IZ - IYA
      GO TO 3
 
    5 PBUF(NUMP:NUMP) = AR(1)
      PBUF(NUMP+1:NUMP+1) = ' '
      NUMP = NUMP + 2
 
      CALL PSWR
 
      IXA = IX
      IYA = IY
 
      RETURN
      END
 
 
      SUBROUTINE PSCLR
C *** This switches to a new colour
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(NWRT.EQ.0) THEN
        IPCC = IPCL
        RETURN
      ENDIF
 
      IF(IPCL.EQ.LOCL) RETURN
      LOCL = IPCL
 
      AR(1) = CHAR(65 + IPCL/26)
      AR(2) = CHAR(65 + MOD(IPCL,26))
      WRITE(PBUF(NUMP:NUMP+2),9000) AR(1),AR(2)
 9000 FORMAT(2A1,1X)
 
      NUMP = NUMP + 3
      CALL PSWR
 
      RETURN
      END
 
 
      SUBROUTINE PSPAL
 
      CHARACTER ESC*1, AR*1, A1*1, A2*1, PBUF*84
      COMMON /MC1/ JTYP(9),NCLR(9),IPIX(9),IPIY(9), LDEV,LDV2,NDEV,NSET
      COMMON /MC5/ LMON,FMOX,FMOY,IXPX(2),IYPX(2),LXRD,LYRD,NPLM,IXYX(2)
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /PL1/ XDR,YDR, XMV,YMV, IPCL,IPCM, ICV(4), JDEV
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /COL/ NCOL,NFRB,NFST, JCOL,ICP,INP,INPP, JTW,FST,JWD
      COMMON /PPP/ ESC, PBUF, AR(999)
      COMMON /JAB/ JABS,PABS(3), LDV3,LDV5,LDW5(9), JREN(3),RENH(3)
 
      A1 = CHAR(65 + ICV(1) / 26)
      A2 = CHAR(65 + MOD(ICV(1),26))
      IF(LDV5.NE.0) THEN
        WRITE(NFLP,9000) A1,A2, ICV(2)
 9000   FORMAT('/',2A1,'  {',I4,' F } def')
      ELSE
        WRITE(NFLP,9001) A1,A2, ICV(2), ICV(3), ICV(4)
 9001   FORMAT('/',2A1,' {',3I4,' C } def')
      ENDIF
 
      RETURN
      END
 
 
      SUBROUTINE PSWR
 
      CHARACTER ESC*1, AR*1, PBUF*84
      COMMON /MCI/ NINA,NINB,NINC,NOUS,NFLP,NFLR,NFLS,NFLH,NFLM,NFLX,NFE
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPP/ ESC, PBUF, AR(999)
 
      IF(NUMP.GT.68 .OR. JAUS.LT.0) THEN
        IF(JAUS.LT.-1) THEN
          NUMP = 1
          RETURN
        ENDIF
        WRITE(NFLP,8000) PBUF(1:NUMP-2)
 8000   FORMAT(A)
        NHPL = NHPL + 1
        NUMP = 1
      ENDIF
 
      JAUS = 1
 
      RETURN
      END
 
 
      SUBROUTINE PSEMPT(JT)
      SAVE
 
      COMMON /HPP/ JOPN, NWRT, IRED, NHPL, LOCL, NKLX, JP34, NUMP, JAUS
      COMMON /PPS/ IXA,IYA, NUMO,NUMX, IEND,IPCC, IPXX,IPYY, LCR,LREC
 
      IF(JT.NE.0 .AND. JAUS.LT.-1) RETURN
 
      IF(NUMP.GT.1) THEN
        JAUS = -1
        CALL PSWR
      ENDIF
 
      RETURN
      END
